# -*- coding: utf-8 -*-


import time
from report import report_sxw
import datetime
from datetime import datetime


class formulacion_report(report_sxw.rml_parse):
    
    _name = 'formulacion.report'
    
    def __init__(self, cr, uid, name, context=None):
        super(formulacion_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
        'generar_reporte':self.generar_reporte,
        'sumar_lineas':self.sumar_lineas,
        'generate_query' :self.generate_query,
        'get_filtros_name' :self.get_filtros_name,
        'filtros_name' :self.filtros_name,
        'tipo_accion' :self.tipo_accion,
        'ver_filtros' :self.ver_filtros,
        })
        self.cr = cr
        self.ordenados = []
        self.filtros = {}        
            
    def format_num(self, num):
		num = int(num)
		num = '{:,}'.format(num)
		num = num.replace(',', '.')
		return num
    
    def tipo_accion(self, tipo):
		d = {'proyecto':'Proyecto', 'centralizada': 'Accion Central'}
		return d[tipo]
		
    def get_filtros_name(self):
        return self.filtros
    
    def ver_filtros(self):
		filtros = self.filtros
		res = ''
		if filtros['accion_especifica'] != "Todas" or filtros['partida'] != "Todas" :
		   res = "(ver filtros)"
		return res   

    def filtros_name(self, form):
        res = {"ejercicio":None,
        "accion_centralizada":"Todas",
        "accion_especifica":"Todas",
        "partida":"Todas",}

        all_partidas = form['all_partidas']
        all_accion_especificas = form['all_accion_especificas']
        all_accion_centralizadas = form['all_accion_centralizadas']
        res['ejercicio'] = form['ejercicio']
        if not all_accion_centralizadas:
            res['accion_centralizada'] = form['accion_centralizada']
        if not all_accion_especificas:
            res['accion_especifica'] = form['accion_especifica']
        if not all_partidas:
            res['partida'] = form['partida']
        self.filtros = res
    
    def generate_query(self, form, limit=None):
        all_partidas = form['all_partidas']
        all_accion_especificas = form['all_accion_especificas']
        all_accion_centralizadas = form['all_accion_centralizadas']
        accion_especifica_id = form['accion_especifica_id']
        accion_centralizada_id = form['accion_centralizada_id']
        ejercicio_id = form['ejercicio_id']
        partida_id = form['partida_id']
    
        sql = """
            select ejer_pre.name, acc_cent.name, acc_esp.name, 
            clas_presu.name, clas_presu.code, pfd.amount, acc_cent.type  
            from presupuesto_formulacion_cabecera as pfc 
            join presupuesto_formulacion_detalle as pfd  
            ON pfc.id =  pfd.pfc_id
            join ejercicio_presupuestario as ejer_pre 
            ON  ejer_pre.id =  pfc.ejercicio_id
            join accion_centralizada as acc_cent 
            ON acc_cent.id = pfc.accion_centralizada_id
            join clasificador_presupuestario as clas_presu 
            ON clas_presu.id = pfd.partida_id
            join accion_especifica as acc_esp 
            ON acc_esp.id = pfd.accion_especifica_id 
            where pfc.ejercicio_id = %s
            """ %ejercicio_id
        if not all_accion_centralizadas:
           sql = sql + '\n and pfc.accion_centralizada_id = %s'%accion_centralizada_id
        if not all_accion_especificas:
           sql = sql + '\n and pfd.accion_especifica_id = %s'%accion_especifica_id
        if not all_partidas:
           sql = sql + '\n and pfd.partida_id = %s'%partida_id
        if limit:
		    sql = sql + '\n limit %s'%limit
        sql = sql + '\n order by clas_presu.code asc'
        
        self.cr.execute(sql)
        result = self.cr.fetchall()
        return result 
        
    def generar_reporte(self, form):
        salida_consulta = self.generate_query(form)
        agrupar = {}
        for i in salida_consulta:
            self.partida = i[0]
            agrupar[(i[1],i[6])] = {}
        
        for i in salida_consulta:
            agrupar[(i[1],i[6])].update({i[2]:[]})
        
        for i in salida_consulta:
            agrupar[(i[1],i[6])][i[2]].append({"partida":i[3], "code":i[4], "monto":i[5]})
        return [agrupar]	
	
		
    def sumar_lineas(self, dict, key, campo, recurcion=False):
        dict_lineas = {campo:0.00}
        for i in dict[key]:
            if not recurcion:
               dict_lineas[campo] += i[campo]
            else:
                for l in dict[key][i]:
                    dict_lineas[campo] += l[campo]
        return dict_lineas   

        

report_sxw = report_sxw.report_sxw    
class RMLParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False, header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
    
    def create_single_pdf(self, cursor, uid, ids, data, report_xml, context=None):
        """generate the PDF"""
        
        if context is None:
            context={}
        
        if report_xml.report_type == 'pdf':
            return super(RMLParser,self).create_single_pdf(cursor, uid, ids, data, report_xml, context=context)


RMLParser('report.formulacion.report',
          'presupuesto.formulacion.cabecera', 
          'l10n_ve_presupuesto/report/formulacion_report.rml',
          parser=formulacion_report)
