# -*- coding: utf-8 -*-
import time
from report import report_sxw
from numero_a_texto import Numero_a_texto
import datetime
from osv import osv

class report_order_payment(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_order_payment, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            
            'get_empresa': self.get_empresa,
            'time': time,
            'get_title': self.get_title,
            'get_lines':self.get_lines,
            'get_on_account':self.get_on_account,
            'convertir':self.convertir,
            'get_iva':self.get_iva,
            'get_crs':self.get_crs,
            'accion_principal':self.accion_principal,
            'reset_all':self.reset_all,
            'check':self.check,
            'check_amount':self.check_amount,

            'verificar_imputacion':self.verificar_imputacion,
            'traductor':self.traductor,
            'action_imputacion_presupuestaria':self.action_imputacion_presupuestaria,
            'accion_especifica':self.accion_especifica,
            'return_partida':self.return_partida,
            'description_partida':self.description_partida,
            'total_action_imputacion_presupuestaria':self.total_action_imputacion_presupuestaria,
            'total_imputaciones':self.total_imputaciones,
            'printing':self.printing,
            
            'return_accion_pre':self.return_accion_pre,
            'apunte_contable_inicio':self.apunte_contable_inicio,
            'apunte_contable':self.apunte_contable,
            'cuenta':self.cuenta,
            'descripcion':self.descripcion,
            'total_apunte_contable':self.total_apunte_contable,
            'verificar_factura':self.verificar_factura,
            
        })
        self.dic = {}
        self.l = []
        self.ll = []
        self.dic_partida= {}
        self.dic_apunte= {}
        self.state = ''
    
    def reset_all(self):
        self.dic = {}
        self.l = []
        self.ll = []
        self.dic_partida= {}
        self.dic_apunte= {}
        self.state = ''
        return ''
    
    def printing(self, obj_type):
        if obj_type == 'payment':
            return True
        return False
    
    def accion_principal(self, voucher_id, state, line_voucher_ids):
        aux={}
        self.state = state
        if state== 'draft':
            obj_addr = self.pool.get('account.voucher')
            self.dic = obj_addr._report_accion_imputar(self.cr, self.uid, [voucher_id])
            
        elif state== 'posted':
            for i in line_voucher_ids:
                
                sqlPostgrest = """select  clasificador_presupuestario.code, clasificador_presupuestario.name, sum (presupuesto_imputacion_linea.amount) as total,
                accion_especifica_id as accion_especifica_id
                from presupuesto_imputacion_linea
                inner join clasificador_presupuestario on clasificador_presupuestario.id = presupuesto_imputacion_linea.partida_id
                where presupuesto_imputacion_linea.model='account.voucher.line' and presupuesto_imputacion_linea.res_id = """+ str(i.id) +"""
                and presupuesto_imputacion_linea.status = 'pagado'
                group by clasificador_presupuestario.code, clasificador_presupuestario.name, accion_especifica_id

                union

                select  clasificador_presupuestario.code, clasificador_presupuestario.name, sum (presupuesto_imputacion_linea.amount) as total,
                accion_especifica_id as accion_especifica_id
                from presupuesto_imputacion_linea
                inner join clasificador_presupuestario on clasificador_presupuestario.id = presupuesto_imputacion_linea.partida_id
                where presupuesto_imputacion_linea.model='account.voucher.line' and presupuesto_imputacion_linea.res_id = """+ str(i.id) +"""
                and presupuesto_imputacion_linea.status_ingreso = 'recaudado'
                group by clasificador_presupuestario.code, clasificador_presupuestario.name, accion_especifica_id """

                self.cr.execute(sqlPostgrest)
                res = self.cr.fetchall()
                
                for x in res:                    
                    self.dic[i.id] = []
                
                for x in res:                    
                    aux = {'partida':x[0], 'amount': x[2], 'accion_especifica_id':x[3]}
                    self.dic[i.id].append(aux)
        
        elif state == 'cancel':
            raise osv.except_osv(('ERROR!'), ('No se puede generar dicho reporte debido a su estado.'))
        return ''
    
    def check_amount(self, objeto):
        total = 0.00
        amount = float("{0:.2f}".format(objeto.amount))
        for i in objeto.line_ids:
            total += i.amount
        total = float("{0:.2f}".format(total))
        if total == amount:
            return True
        return False
        
    def check(self, objeto):
        anticipo = self.tiene_anticipo(self.cr, self.uid, objeto)
        if objeto.hr_process_id:
            return 'nomina'
        elif anticipo:
            return 'anticipo'
        else:
            return True
        
    def tiene_anticipo(self, cr, uid, voucher_obj):
        """
        Busca todas las lineas que tienen una cuenta que no debe ser imputada.
        @return: lista de diccionario con el modelo y id que no se imputara
        """
        user_id = 1
        aac_conf = self.pool.get('account.bank.statement.config')
        aac_conf_id = aac_conf.search(cr, uid, [('type','in',['journal']),('type_reg','in',['advance'])])
        account_list = []
        aac_brw = aac_conf.browse(cr, user_id, aac_conf_id)
        for lista_diarios in aac_brw:
            account_list.append(lista_diarios.journal_id.default_credit_account_id.id)
            account_list.append(lista_diarios.journal_id.default_debit_account_id.id)
        #remover ctas repetidas
        account_list = list(set(account_list))
        
        #cuenta de transferencia bancaria no debe imputar
        aac_conf_transf_id = aac_conf.search(cr, uid, [('type','in',['account']),('type_reg','in',['transferencias'])])
        aac_transf_brw = aac_conf.browse(cr, user_id, aac_conf_transf_id)
        for lista_transf in aac_transf_brw:
            if lista_transf.account_id:
                account_list.append(lista_transf.account_id.id)
        
        for avl in voucher_obj.line_ids:
            account_line = avl.account_id and avl.account_id.id or 0
            if not avl.invoice_id and account_line in account_list:
                return True
        return False
    
    def traductor(self, palabra):
        palabras = {'posted':'Contabilizado','draft':'Borrador','cancel':'Cancelado'}
        return palabras[palabra]
    
    def return_partida(self, key):
        key = key.split("/")
        return key[0]
        
    def return_accion_pre(self, key):
        key = key.split("/")
        return key[1]
    
    def apunte_contable_inicio(self, objeto):
        obj_addr = self.pool.get('account.move.line')
        for obj in objeto:
            
            if obj.move_line_id:
                lineas_id = obj_addr.search(self.cr, self.uid, [('move_id','=',obj.move_line_id.move_id.id)])
                if lineas_id:
                    
                    lineas_brw = obj_addr.browse(self.cr, self.uid, lineas_id)
                     
                    for line in lineas_brw:
                        if not line.account_id.code +"/"+ line.account_id.name in self.dic_apunte:
                            self.dic_apunte[line.account_id.code +"/"+ line.account_id.name] = {'debe':0, 'haber':0}
                        
                    for line in lineas_brw:
                            self.dic_apunte[line.account_id.code +"/"+ line.account_id.name]['debe'] += line.debit
                            self.dic_apunte[line.account_id.code +"/"+ line.account_id.name]['haber'] += line.credit                     
        return ''
    
    def apunte_contable(self):
        return self.dic_apunte
    
    def total_apunte_contable(self):
        debe = 0.00
        haber = 0.00
        for key1 in self.dic_apunte:
            debe += self.dic_apunte[key1]['debe']
            haber += self.dic_apunte[key1]['haber']
        dic_res = {'debe':debe, 'haber':haber}
        return dic_res
    
    def action_imputacion_presupuestaria(self):
        if self.dic != {}:
            try:
                for i in self.dic:
                    self.dic_partida[str(self.dic[i]["partida"])+"/"+str(self.dic[i]["accion_especifica_id"])] = 0
                
                for i in self.dic:
                    self.dic_partida[str(self.dic[i]["partida"])+"/"+str(self.dic[i]["accion_especifica_id"])] += self.dic[i]["amount"]
                
                for i in self.dic_partida:
                    self.l.append(self.dic_partida[i])
                    
            except:
                
                try:
                
                    for i in self.dic:
                        for x in self.dic[i]:
                            key = str(self.dic[i][x]['partida']) + '/' + str(self.dic[i][x]['accion_especifica_id'])
                            self.dic_partida[key] = 0                
            
                    for i in self.dic:
                        for x in self.dic[i]:
                            key = str(self.dic[i][x]['partida']) + '/' + str(self.dic[i][x]['accion_especifica_id'])
                            self.dic_partida[key] += self.dic[i][x]['amount']
            
                    for i in self.dic_partida:
                        self.l.append(self.dic_partida[i])
            
                except:
                    
                    if self.dic != True:
                        for i in self.dic:
                            for x in self.dic[i]:
                                key = str(x['partida']) + '/' + str(x['accion_especifica_id'])
                                self.dic_partida[key] = 0
                        
                        for i in self.dic:
                            for x in self.dic[i]:
                                key = str(x['partida']) + '/' + str(x['accion_especifica_id'])
                                self.dic_partida[key] += x['amount']
                                
                        for i in self.dic_partida:
                            self.l.append(self.dic_partida[i])
                    else:
                        self.dic_partida = {}

        return self.dic_partida
        
    
    def verificar_imputacion(self):
        if not self.dic_partida:
            return False
        return True
    
    def verificar_factura(self, objeto):
        if objeto:
            for obj in objeto:
                if obj.move_line_id:
                    return True
                return False
        return False
    
    def cuenta(self, apunte):            
            if apunte:
                apunte = apunte.split("/")
                return apunte[0]
            return ''
        
    def descripcion(self, apunte):
        if apunte:
            apunte = apunte.split("/")
            return apunte[1]
        return ''
    
    def total_action_imputacion_presupuestaria(self, key):
        return self.dic_partida[key]
    
    def total_imputaciones(self):
        return sum(self.l)
    
    def description_partida(self, code):
        obj_addr = self.pool.get('clasificador.presupuestario')
        obj_id = obj_addr.search(self.cr, self.uid, [('code','=',code)])
        if obj_id:
            obj_brw = obj_addr.browse(self.cr, self.uid, obj_id)[0]
            return obj_brw.name
        return ''
        
    def accion_especifica(self, id_accion):
        obj_addr = self.pool.get('accion.especifica')
        obj_id = obj_addr.search(self.cr, self.uid, [('id','=',id_accion)])
        if obj_id:
            obj_brw = obj_addr.browse(self.cr, self.uid, obj_id)[0]
            return obj_brw.codigo
        return ''
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
            
    def convertir(self,amount):
        res = Numero_a_texto(amount)
        return res

    def get_lines(self, voucher):
        res={}
        data = []
        for line in voucher:
            clave = line.account_id.code + ' ' + line.account_id.name
            if not clave in res:
                res[clave] = line.amount
            else:
                res[clave] = res[clave] + line.amount
        for d in res:
            tupla = (d,res[d])
            data.append(tupla)
        return data
        
    def get_title(self, type):
        title = ''
        if type:
            title = type[0].swapcase() + type[1:] + " Comprobante"
        return title

    def get_on_account(self, voucher):
        name = ""
        if voucher.type == 'receipt':
            name = "Recibe dinero de "+str(voucher.partner_id.name)
        elif voucher.type == 'payment':
            name = "Pago de "+str(voucher.partner_id.name)
        elif voucher.type == 'sale':
            name = "Venta de "+str(voucher.partner_id.name)
        elif voucher.type == 'purchase':
            name = "Compra de "+str(voucher.partner_id.name)
        return name
        
    def get_iva(self, voucher_line):
        l=0.0
        for line in voucher_line.invoice_id.wh_iva_id.wh_lines:
            l += line.amount_tax_ret
        return str(l)
        
    def get_crs(self, invoice):
        l=0.0
        if not invoice.wh_src_id:
             return "0.00"
        
        for line in invoice.wh_src_id.line_ids:
            if line.invoice_id.id == invoice.id:
                l += line.wh_amount
                
        if l == 0.0:
            return "0.00"
        return str(l)

report_sxw.report_sxw(
    'report.budget.support.printing',
    'account.voucher',
    'l10n_ve_presupuesto/report/budget_support.rml',
    parser=report_order_payment,header="external"
)
