#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Copyright (C) Industrias Diana, C.A. (www.industriasdiana.gob.ve)
#    All Rights Reserved
###############Credits######################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
import calendar
import string

class wizard_formulacion_presupestaria(osv.osv_memory):
    _name = 'wizard.formulacion.presupestaria'
    _columns = {
       #cabecera
        'ejercicio_id': fields.many2one('ejercicio.presupuestario','Ejercicio Presupuestario', required=True),
        'accion_centralizada_id': fields.many2one('accion.centralizada','Accion Central / Proyecto'),
       #lineas
        'partida_id': fields.many2one('clasificador.presupuestario','Partida'),
        'accion_especifica_id': fields.many2one('accion.especifica','Accion Especifica'),
       #filtros
        'filtro_accion_centralizada_id': fields.text("Filtrar accion centralizada"),
        'filtro_partida_id': fields.text("Filtrar Partida"),
        'filtro_accion_especifica_id': fields.text("Filtrar accion especifica"),
       # condiciones
        'all_accion_centralizadas':fields.boolean("Todas las Acciones Cent/Proyectos"), 
        'all_partidas':fields.boolean("Todas las Partidas"), 
        'all_accion_especificas':fields.boolean("Todas las Accion Especifica"), 
        }
    _defaults = {
		'all_accion_centralizadas':True,
		'all_partidas':True,
		'all_accion_especificas':True,
		'ejercicio_id':lambda self,cr,uid,ids: self.periodo_actual(cr, uid, ids)['ejercicio'],
		'filtro_accion_centralizada_id':lambda self,cr,uid,ids: self.periodo_actual(cr, uid, ids)['filtro'],
	}
    
    def periodo_actual(self, cr, uid, ids, dt=None, exception=True, context=None):
		ejer_id = self.pool.get('ejercicio.presupuestario').find(cr, uid)
		filtro = str([])
		if ejer_id:
			filtro=self.on_change_ejercicio_id(cr, uid, ids, ejer_id)
			filtro = filtro['value']['filtro_accion_centralizada_id']
		return {"ejercicio":ejer_id, 'filtro':filtro}
		
		
		
    def on_change_ejercicio_id(self, cr, uid, ids, ejercicio_id):
        brw = self.browse(cr, uid, ids)
        filtro = self.filtro_accion_centralizada(cr, uid, ejercicio_id)
        result = {
        'filtro_accion_centralizada_id':str(list(set(filtro['accion_centralizada_id']))),
        }
        
        return {'value': result}
   
    def on_change_accion_centralizada_id(self, cr, uid, ids, ejercicio_id, accion_centralizada_id):
        formulacion_obj = self.pool.get('presupuesto.formulacion.cabecera')
        formulacion_id = formulacion_obj.search(cr, uid, [('ejercicio_id','=',ejercicio_id), 
        ('accion_centralizada_id','=',accion_centralizada_id)])
        
        formulacion_brw = formulacion_obj.browse(cr, uid, formulacion_id)
        l1 = []
        l2 = []
        for i in formulacion_brw:
            for l in i.formulacion_ids:
                l1.append(l.partida_id.id)
                #~ l2.append(l.accion_especifica_id.id)
        
        result = {
        'filtro_partida_id':str(list(set(l1))),
        #~ 'filtro_accion_especifica_id':str(list(set(l2))),
        }
        
        return {'value': result}
    
    def filtro_accion_centralizada(self, cr, uid, ejercicio_id):
        res = {"accion_centralizada_id":[]}
        formulacion_obj = self.pool.get('presupuesto.formulacion.cabecera')
        formulacion_id = formulacion_obj.search(cr, uid, [('ejercicio_id','=',ejercicio_id)])
        formulacion_brw = formulacion_obj.browse(cr, uid, formulacion_id)
        for i in formulacion_brw:
            res["accion_centralizada_id"].append(i.accion_centralizada_id.id)
        return res
    
    def button_print(self, cr, uid, ids, context=None):
		agrupador = {}
		wizard_brw = self.browse(cr, uid, ids)[0]
		for i in self._columns:
			if type(getattr(wizard_brw, i)) in [osv.orm.browse_record, osv.orm.browse_null]:
				agrupador[i] = getattr(getattr(wizard_brw, i),'id')
			else:
				agrupador[i] =  getattr(wizard_brw, i)  
        
		
		agrupador["ejercicio"] = wizard_brw.ejercicio_id.name
		if not wizard_brw.all_accion_centralizadas:
			agrupador["accion_centralizada"] = wizard_brw.accion_centralizada_id.name
		if not wizard_brw.all_partidas:
			agrupador["partida"] = wizard_brw.partida_id.name
		if not wizard_brw.all_accion_especificas:
			agrupador["accion_especifica"] = wizard_brw.accion_especifica_id.name
		
		datas = {'form':agrupador}
		return {
		'type': 'ir.actions.report.xml',
		'report_name': 'formulacion.report',
		'datas': datas,
		}
        
wizard_formulacion_presupestaria()
