# -*- coding: utf-8 -*-
#!/usr/bin/env python

from osv import fields, osv
from tools.translate import _
from datetime import datetime

class  horas_extras_planificacion(osv.osv):
    _inherit = 'horas.extras.planificacion'
    _columns = {
        'changelog': fields.one2many('horas.extras.planificacion.history', 'horas_extras_planificacion_id', 'Changelog', readonly=True),
    }
    
    def write(self, cr, uid, ids, vals, context=None):
        if not context:
            context = {}

        if not isinstance(ids, list):
            ids = [ids]

        for record in self.browse(cr, uid, ids, context):
            observacion = 'Obs: ' + record.observacion if record.observacion else None
            nota_nomina = 'Nom: ' + record.nota_nomina if record.nota_nomina else None
            last_state = record.state

        state = vals['state'] if 'state' in vals else None
        if state:
            if state in ['confirmed']:
                notes = observacion
            elif state in ['load'] and last_state not in ['done']:
                notes = nota_nomina
            elif state in ['processing'] and last_state in ['approved']:
                notes = nota_nomina
            elif state in ['draft'] and last_state in ['processing']:
                notes = nota_nomina
            else:
                notes = None

            state = dict(self.pool.get('horas.extras.planificacion').fields_get(cr, uid, fields=['state'], context=context)['state']['selection'])[state]

            values = {
                'editor_id': uid,
                'edited_date': datetime.now(),
                'changed_state': state,
                'state_notes': notes,
            }

            vals.update({
                'changelog': [(0, 0, values)]
            })
        return super(horas_extras_planificacion, self).write(cr, uid, ids, vals, context)

horas_extras_planificacion()

class hr_variable_concepts(osv.osv):
    _inherit = 'hr.variable.concepts'
    # Fix
    def unlink(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids[0])
        horas_extras_obj = self.pool.get('horas.extras.planificacion')
        
        if brw.tipo_de_proceso == 'sobretiempo':
           if brw.state not in ['done', 'execute']:
               horas_extras_id = horas_extras_obj.search(cr, uid, [('variable_concept_id','in',ids)])
               horas_extras_obj.write_state_lines(cr, uid, horas_extras_id,'processing')
        return super(hr_variable_concepts, self).unlink(cr, uid, ids)

hr_variable_concepts()

class horas_extras_planificacion_history(osv.osv):
    _name = 'horas.extras.planificacion.history'
    _columns = {
        'horas_extras_planificacion_id': fields.many2one('horas.extras.planificacion'),
        'editor_id': fields.many2one('res.users', 'Editor user'),
        'edited_date': fields.datetime('Edited date'),
        'changed_state': fields.char('Changed state', size=32),
        'state_notes': fields.text('State notes')
    }
    _order = 'id desc'

horas_extras_planificacion_history()