#-*- coding:utf-8 -*-


from osv import fields, osv
from tools.translate import _
from datetime import datetime
import logging



class hr_variable_concepts(osv.osv):
    """
    Herencia para:
    1) Incluir funcion para obtener el nombre de los conceptos
    variables
    """
    _inherit = 'hr.variable.concepts'

    def __init__(self, *args, **kargs):
        super(hr_variable_concepts, self).__init__(*args, **kargs)
        if 'tipo_de_proceso' in self._columns:
            if ('deducciones', 'Deducciones') not in self._columns['tipo_de_proceso'].selection:
                self._columns['tipo_de_proceso'].selection.append(('deducciones', 'Deducciones'))
        else:
            self._columns['tipo_de_proceso'] = fields.selection([('deducciones', 'Deducciones')], "Tipo de proceso")


    def unlink(self, cr, uid, ids, context=None):
        hr_process_obj = self.pool.get('hr.process')
        variables_lines_obj = self.pool.get('hr.variable.concept.line')
        brw = self.browse(cr, uid, ids[0])
        process_id = brw.hr_process_id.id
        if brw.tipo_de_proceso == 'deducciones':
           if brw.state not in ['done', 'execute']:
              lines = [i.id for i in brw.variable_concept_line_ids]
              variables_lines_obj.unlink(cr, uid, lines, context=context)
        hr_process_obj.write(cr, uid, process_id, {'calculado_descuento':False})
        return super(hr_variable_concepts, self).unlink(cr, uid, ids)

hr_variable_concepts()
