#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import logging
from tools.translate import _
from datetime import datetime
import csv
import binascii
from StringIO import StringIO
import random
import base64

class ml_carga_datos(osv.osv_memory):
    _name = 'ml.carga.datos'
    
    _columns = {
        'fecha': fields.date('Date of purchase', required=True),
        'adjunto': fields.binary('CSV file', required=True),
        'ruta':fields.char('Path', size=500),
        'state':fields.selection([('draft', 'Draft'),('done','Done')], 'State'),
        'key': fields.char('key', size=16),
        'valid_item':fields.integer('Valid Item'),
        
    }
    _defaults = { 'valid_item':lambda self,cr,uid,context : random.randrange(1, 100000000, 1)}
        
    def cvr_date(self, fecha):
        return  datetime.strptime(fecha, '%Y-%m-%d').strftime('%d/%m/%Y')  
    
    
    def mercado_linea_cargar_csv(self, cr, uid, defaults, context=None):
        if context is None:
            context = {}
        
        record_id = self.browse(cr, uid, defaults, context=context)
        ruta = record_id[0].ruta
        if not ruta:
            raise osv.except_osv(_('Error !'), _("Select a file."))
        
        ruta = record_id[0].ruta.split('.')
        
        # validacion de extension
        if ruta[-1].upper() != 'CSV':
            raise osv.except_osv(_('Error !'), _("The extension ."+ruta[-1]+" It is not valid in this process . You must select a .csv file"))
            
        file_in = record_id[0].adjunto
        fecha= record_id[0].fecha
        randon = record_id[0].valid_item
        
        obj_employee = self.pool.get('hr.employee')
        obj_csv_lineas = self.pool.get('ml.csv.lineas')
        obj_csv_cabecera = self.pool.get('ml.subir.csv')
        
        datos = {'fecha':record_id[0].fecha,'adjunto':record_id[0].adjunto,'state':'draft', 'key':'wizard', 'valid_item':randon}
        
        try:
            compr_csv = binascii.a2b_base64(unicode(file_in))
            arch_csv = StringIO(compr_csv)
            f_move = csv.reader(arch_csv, delimiter=';')
        except Exception, n:
                raise osv.except_osv(_('Error !'), _("Failed to convert the file"))
                
        # se crea la cabecera para obtener su id y posteriormente insertarlo en las lineas        
        id_cabecera = obj_csv_cabecera.create(cr, uid, datos, context=context)
        
        
        dic = {'amount':0.0}
        # se leen las lineas del archivo  y cada linea se le asigna a row
        for row in f_move:
            
            # validacion del numero de columnas que contiene el archivo
            if len(row) != 8:
                raise osv.except_osv(_('Error !'), _("The file does not have the correct format!"))
             
            # validacion de fecha que sean iguales tanto cabecera como las lineas 
            if fecha != row[1]:
                raise osv.except_osv(_('Error !'), _("The dates do not coincide therefore can not load the information"))
            
            # se busca al empleado por la cedula del archivo en hr_employee
            empleado_id = obj_employee.search(cr, uid, [('identification_id','=',row[3])], context=context)
             
            # validacion de empleado entre el archivo y el sisb
            if not empleado_id:
                raise osv.except_osv(_('Error !'), _("Unable to load information , there is an error in the information contained in the file %s!" ) % (row[3]))
                 
            empleado_brw = obj_employee.browse(cr, uid, empleado_id)
            
            compra_lineas = {
                'csv_id':id_cabecera,
                'empresa': row[0],
                'fecha': self.cvr_date(row[1]),
                'name': row[2],
                'cedula': empleado_brw[0].identification_id,
                'employee_id': empleado_brw[0].id,
                'cantidad': row[6],
                'monto': row[7],
                'deferred': row[7],
                'state': 'draft',
            }
            
            dic['amount'] += float(row[7])
            
            insertar = obj_csv_lineas.create(cr, uid, compra_lineas, context=context)
        
        actualizar = obj_csv_cabecera.write(cr, uid, [id_cabecera], dic, context=context)
        
        return {'type': 'ir.actions.act_window_close'}
        
ml_carga_datos()




