#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import osv,fields 
from tools.translate import _ 
from datetime import *
from decimal import *

class wizard_discount_feeding(osv.osv_memory):
    _name = 'wizard.discount.feeding'
    _description = 'Market discount voucher online by feeding'
    
    _columns = {
        'type_loan':fields.selection([('bonus_feeding', 'Bono alimentacion'), ('loan', 'Nomina')], "Type loan", required=True),
        'percentage':fields.selection([(1, '100 %'),(0.50, '50 %')], 'Percentage', required=True),
        'daily_payroll_cuote':fields.char('Dues daily payroll', size=64, required=False),
        'monthly_payroll_cuote':fields.char('Dues monthly payroll', size=64, required=False),
    }
    
    def redondeo(self, monto):
        m = str(monto).split('.')
        decimales = len(m[1])
        if decimales > 2:
            ultimo = int(m[1][2])
            if ultimo == 5:
                res = int(m[1])+1
                return round(float(str(m[0])+"."+str(res)), 2)
        return monto
    
    
    def send_loan(self, cr, uid, cabecera, type_loan, cuota_diaria, cuota_mensual, percentage, context=None):
        csv_lineas_obj = self.pool.get('ml.csv.lineas')
        csv_subir_obj = self.pool.get('ml.subir.csv')
        csv_montos_obj = self.pool.get('ml.montos.lineas')
        
        hr_parameters_obj = self.pool.get('hr.parameters')
        loan_obj = self.pool.get('hr.loan')
        obj_employee = self.pool.get('hr.employee')
        obj_concept = self.pool.get('hr.concept')
        obj_concept_loan = self.pool.get('hr.concept.loan')
        
        #~ concept_list=[]
        line_param_id = hr_parameters_obj.search(cr, uid, [('type','=','concepto_mercado_en_linea')], context=context)
        if not line_param_id:
            raise osv.except_osv(_('Error'),_('Debes configurar los conceptos de descuento del mercado en linea en los parametros de nomina'))
        
        line_param_brw = hr_parameters_obj.browse(cr, uid, line_param_id, context=context)
        if type_loan == 'loan':
            #~ concept_list.append(('code','=','6498'))
            concepto_descuento = line_param_brw[0].concepto_mercado_en_linea_nomina_id and line_param_brw[0].concepto_mercado_en_linea_nomina_id.id or False
            
        elif type_loan =='bonus_feeding':
            #~ concept_list.append(('code','=','6499'))
            concepto_descuento = line_param_brw[0].concepto_mercado_en_linea_id and line_param_brw[0].concepto_mercado_en_linea_id.id or False
            
        if not concepto_descuento:
            raise osv.except_osv(_('Error'),_('Debes configurar los conceptos de descuento del mercado en linea en los parametros de nomina'))
        else:
            concept_id = obj_concept.browse(cr, uid, concepto_descuento, context=context)
        
        concept_loan_id = obj_concept_loan.search(cr, uid, [('concept_id','=',concepto_descuento)], context=context)
        
        if not concept_loan_id:
            raise osv.except_osv(_('Error'),_('Debes configurar concepto de prestamos'))
            
        carga_me_id = csv_lineas_obj.search(cr, uid, [('csv_id', '=', cabecera),('state','in',['draft','inprocess'])])
         
        carga_me_brw = csv_lineas_obj.browse(cr, uid, carga_me_id)
        
         
        for carga_ml in carga_me_brw:
           
            if carga_ml.state in ['draft','inprocess']:
                
                montos_id = csv_montos_obj.search(cr, uid, [('csv_linea','=',carga_ml.id)])
                
                total_deducir = 0.0
                monto_list=[]
                
                if percentage != 1:
                
                    if montos_id:
                        
                        montos_brw = csv_montos_obj.browse(cr, uid, montos_id)
                        
                        for i in montos_brw:
                            monto_list.append(i.monto)
                            
                        total_deducir = carga_ml.monto - sum(monto_list)
                        
                        total_deducir = total_deducir * percentage

                        
                    else:
                        total_deducir = carga_ml.deferred * percentage
                        
                    deferred = carga_ml.deferred - total_deducir
                    
                else:
                    
                    total_deducir = self.redondeo(carga_ml.deferred)
                    
                    deferred = 0.0
                    
                    

                    
                empleado_brw = obj_employee.browse(cr, uid, carga_ml.employee_id.id, context=context)
                
                if empleado_brw.hr_payroll_id.id == 2:
                    num_cuotas = cuota_diaria
                else:
                    num_cuotas = cuota_mensual
                
                monto_cuota = total_deducir / num_cuotas
                
                
                
                hr_loan_dict = {
                    'employee_id': empleado_brw.id,
                    'concept_id': concept_loan_id[0],
                    'amount': float(total_deducir),
                    'amount_quota': float(monto_cuota),
                    'num_quotas': num_cuotas,
                    'date_start': carga_ml.fecha,
                    'paid_quotas': 0,
                    'paid_amount': 0.0,
                    'remaining_debt': 0.0,
                    'date_payment':carga_ml.fecha,
                    'active': 'active',
                }
                  
                
                insertar = loan_obj.create(cr, uid, hr_loan_dict, context=context)
                
                
                csv_montos_obj.create(cr, uid, {'csv_linea':carga_ml.id, 'monto':round(total_deducir, 4)}, context=context)
                
                

                if deferred == 0.0:
                    csv_lineas_obj.write(cr, uid, [carga_ml.id], {'state':'done', 'deferred':deferred}, context=context)
                    
                elif deferred != carga_ml.deferred:
                    csv_lineas_obj.write(cr, uid, [carga_ml.id], {'state':'inprocess', 'deferred':deferred}, context=context)
                
                elif deferred == carga_ml.deferred:
                    csv_lineas_obj.write(cr, uid, [carga_ml.id], {'state':'draft', 'deferred':deferred}, context=context)
                
        carga_brw = csv_lineas_obj.browse(cr, uid, carga_me_id)
        
        
        dic = {'done':0,'inprocess':0,'draft':0}
 
 
        for i in carga_brw:
            dic[i.state] += 1
    
        if dic['inprocess'] > 0:
            csv_subir_obj.write(cr, uid, [cabecera], {'state':'inprocess'}, context=context)
            
        elif dic['draft'] == 0 and dic['done'] > 0:
            csv_subir_obj.write(cr, uid, [cabecera], {'state':'done'}, context=context)
        
        elif dic['draft'] > 0 and dic['done'] > 0:
            csv_subir_obj.write(cr, uid, [cabecera], {'state':'inprocess'}, context=context)
        
        elif dic['draft'] > 0 and dic['done'] == 0:
            csv_subir_obj.write(cr, uid, [cabecera], {'state':'draft'}, context=context)

        return True
    
    
    def validation_type(self, cuota_string):
        try:
            cuota = int(cuota_string)
            return cuota
        except ValueError:
            raise osv.except_osv(_('ERROR!'), _('Tipo de dato no valido. Debes ingresar un numero de cuotas a descontar.'))

    def action_generate_concept(self, cr, uid, ids, context=None):
        
        type_loan = self.browse(cr, uid, ids[0], context).type_loan
        percentage = self.browse(cr, uid, ids[0], context).percentage
        cabecera = context['active_id']
        
        if type_loan == 'loan':
            
            daily_payroll_cuote = self.browse(cr, uid, ids[0], context).daily_payroll_cuote
            monthly_payroll_cuote = self.browse(cr, uid, ids[0], context).monthly_payroll_cuote
            
            daily_payroll_cuote = self.validation_type(daily_payroll_cuote)
            monthly_payroll_cuote = self.validation_type(monthly_payroll_cuote) 
            
            if not daily_payroll_cuote or not monthly_payroll_cuote or daily_payroll_cuote == 0 or monthly_payroll_cuote == 0:
                raise osv.except_osv(_('ERROR!'), _('No se ha establecido un numero de cuotas para nomina diaria o mensual'))
            
            res = self.send_loan(cr, uid, cabecera, type_loan, daily_payroll_cuote, monthly_payroll_cuote, percentage)
            
        elif type_loan == 'bonus_feeding':
            
            daily_payroll_cuote = 1
            monthly_payroll_cuote = 1
            
            res = self.send_loan(cr, uid, cabecera, type_loan, daily_payroll_cuote, monthly_payroll_cuote, percentage)
        
        return {'type': 'ir.actions.act_window_close'}
        
wizard_discount_feeding()
