from lxml import etree
import re 


#~ XML = """
 #~ <story></story>
#~ """
#~ 
#~ parser = etree.XMLParser(remove_blank_text=True)
#~ node = etree.fromstring(XML, parser)

def create_element(tag, sub_tag=None):
	parent = etree.Element(tag)
	if sub_tag:
		childs = etree.SubElement(parent, sub_tag)
	return parent
	
def create_repeatIn(func, var, style):
	section = create_element('section', sub_tag='para')
	para = section.find('para')
	para.set('style', style)
	para.text = "[[ repeatIn(%s , '%s')  ]]"%(func, var) 
	return section
	

def agregar_etiqueta(node, elemento, find_param=False,  pos='top'):
	posicion = {'top':'append', 'after':'addnext', 'before':'addprevious'}
	tag = node
	if find_param:
		tag = node.find(find_param)
	getattr(tag, posicion[pos])(elemento)
	return node  

class sections():
	def __init__(self, func, val, repeat=False):
		self.func = func
		self.val = val
		self.repeat = repeat
		self.section_acum = None
		self.paras_dict = None
	
	def create(self, sub_tag=None):
		parent = etree.Element('section')
		if sub_tag:
			childs = etree.SubElement(parent, sub_tag)
			self.paras_dict = childs
		self.section_acum= parent
		return parent
	
	def set_para_style(self, style):
		self.paras_dict.set('style', style) 
		
	def set_para_value(self, value):
		self.paras_dict.text = value
		
	def create_repeatIn(self, style):
		sect_post = self.section_acum
		self.set_para_style(style)
		if self.repeat:
		   value = "[[ repeatIn(%s , '%s')  ]]"%(self.func, self.val)
		   self.set_para_value(value)
		return sect_post

class bloktables():
	def __init__(self, columns, trs=1, paras=1):
		self.columns = columns
		self.trs = trs
		self.tds = columns
		self.paras = paras
		self.paras_acum = []
		self.colWidths = None
	
	def get_colWidths(self, frame, uni_medida='cm'):
		cols = frame / float(self.columns)
		l = []
		for i in range(self.columns):
			l.append(str(round(cols, 2))+uni_medida)
		return ",".join(l)
	
	def set_colWidths(self, valor):
		self.colWidths = valor
			
	def set_para_style(self, posicion, style):
		self.paras_acum[posicion].set('style', style) 
		
	def set_para_value(self, posicion, value):
		self.paras_acum[posicion].text = value
		
	def set_paras(self, values, style):
		x = 0
		for i in self.paras_acum:
			self.set_para_style(x, style)
			self.set_para_value(x, values[x])
			x+=1
	
	def crear_tabla(self):
		block = etree.Element("blockTable")
		block.set('colWidths',self.colWidths)
		for c in range(self.trs):
			tr =  etree.SubElement(block, "tr")
			for s in range(self.tds):
				td =  etree.SubElement(tr, "td")
				for p in range(self.paras):
					para = etree.SubElement(td, "para")
					self.paras_acum.append(para)
		return block
		
 
#~ columnas =  [y for x,y in sorted(cabecera.items())]
#~ columnas.insert(0, 'Trabajador')
#~ 
#~ bl1 = bloktables(len(columnas), trs=1, paras=1)
#~ c = bl1.get_colWidths(25, uni_medida='cm')
#~ bl1.set_colWidths(c)
#~ bloque1 = bl1.crear_tabla()
#~ bl1.set_paras(columnas, 'style')

#~ bl2 = bloktables(1, trs=1, paras=1)
#~ c = bl2.get_colWidths(25, uni_medida='cm')
#~ bl2.set_colWidths(c)
#~ bloque2 = bl2.crear_tabla()
#~ bl2.set_paras('k', 'style')
#~ 
#~ 
#~ 
#~ 
#~ sec = sections('dicc', 'k', repeat=True)
#~ section = sec.create(sub_tag='para')	
#~ sec.create_repeatIn('style')
#~ 
#~ sec = sections('dicc[k]', 'o', repeat=True)
#~ section1 = sec.create(sub_tag='para')	
#~ sec.create_repeatIn('style')
#~ 
#~ sec = sections('dicc[k][o]', 'd', repeat=True)
#~ section2 = sec.create(sub_tag='para')	
#~ sec.create_repeatIn('style')

#~ agregar_etiqueta(node, section, pos='top')
#~ agregar_etiqueta(node, bloque2, pos='top')
#~ agregar_etiqueta(section,  section1, pos='top')
#~ agregar_etiqueta(section1, bloque1, pos='top')
#~ agregar_etiqueta(section1, section2, pos='top')


#~ print etree.tostring(node, pretty_print=True)

		
