#-*- coding:utf-8 -*-
from report import report_sxw
from report.report_sxw import rml_parse
from operator import itemgetter
import time
from datetime import datetime
import random
from numero_a_texto import Numero_a_Texto
import netsvc
import time
from tools.translate import _
from osv import fields, osv
import datetime
from datetime import date
import locale


class hr_contabilidad(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(hr_contabilidad, self).__init__(cr, uid, name, context)
        
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'lineas_contables_nomina':self.lineas_contables_nomina,
            'nomina':self.nomina,
            'cuenta_contable':self.cuenta_contable,

        })
        self.context = context
        

    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
        
    def lineas_contables_nomina(self, nomina, cuenta_contable, concepto):
        lineas = []
        
        concepto_nomina = ''
        if concepto:
            concepto_nomina = " and hc.id = '%s'" % (concepto)
            
        cond_cuenta_contable = ''
        if cuenta_contable:
            cond_cuenta_contable = " and cc.id = '%s'" % (cuenta_contable)
        
        
        self.cr.execute("""
            select hc.code as codigo,
            hc.name as concepto,
            hraaa.code as codigo_cuenta_analitica,
            hraaa.name as cuenta_analitica,
            hrp.name as nomina,
            cc.code as codigo_cuenta_contable,
            cc.name as cuenta_contable,
            ccount.code as codigo_cuenta_contra_partida,
            ccount.name as cuenta_contra_partida,
            hrcp.code as codigo_partida_presupuestaria,
            hrcp.name as partida_presupuestaria
            from hr_account
            inner join hr_concept hc on hr_account.concept_id = hc.id
            inner join account_analytic_account hraaa on hr_account.analytic_account_id = hraaa.id
            inner join hr_payroll hrp on hr_account.payroll_id = hrp.id
            inner join account_account cc on hr_account.account_id = cc.id
            inner join account_account ccount on  hr_account.account_payroll_id = ccount.id
            left outer join clasificador_presupuestario hrcp on  hr_account.partida_presupuesto = hrcp.id
            where hrp.id = '%s'  %s %s
            order by nomina, concepto"""%(nomina, cond_cuenta_contable, concepto_nomina))
        
        
        lineas = self.cr.dictfetchall()
    
        return lineas


    def nomina(self, nomina):
        lineas = []
        self.cr.execute("""select hr_payroll.name from hr_payroll
            where hr_payroll.id = '%s'"""%(nomina))
        lineas = self.cr.dictfetchall()
        return lineas
        
    def cuenta_contable(self, cuenta_contable):
        lineas = []
        self.cr.execute("""select account_account.name from account_account
            where account_account.id = '%s'"""%(cuenta_contable))
        lineas = self.cr.dictfetchall()
        return lineas

report_sxw.report_sxw(
        'report.report.hr.contabilidad',
        'hr.account',
        'sisb_nomina/report/hr_contabilidad.rml',
        parser=hr_contabilidad, header=False
)
