#!/usr/bin/python
# -*- encoding: utf-8 -*-

############### Credits ########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt
import base64
from osv import osv,fields
from tools.translate import _
import unicodedata
import re
import datetime

class report_level_department(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_level_department, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_hour_date': self.get_hour_date,
            'get_fecha': self.get_fecha,
            'get_total': self.get_total,
            'datos': self.datos,
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def formatDepertament(self, dep):
        return dep[0]
        
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
    
    def datos(self, lista_ids):
        obj_employee = self.pool.get('hr.employee')
        obj_department = self.pool.get('hr.department.employee')
        return_list = []
        for i in lista_ids:
            browse_employee = obj_employee.browse(self.cr, self.uid, [i])
            if browse_employee:
                id_department_employee = obj_department.search(self.cr, self.uid, [('employee_id','=',browse_employee[0].id)])
                if id_department_employee:
                    browse_department = obj_department.browse(self.cr, self.uid, id_department_employee)
                return_list.append((browse_employee[0].name,browse_employee[0].cod_number, browse_department[-1].job))
        return sorted(return_list)
        
    def get_total(self, data):
        c=0
        for i in data:
            if i[1]:
                c+=int(i[1])
        return str(c)
    
    
        
report_sxw.report_sxw('report.sisb.level.department.report',
    'wizard.level.department',
    'sisb_nomina/report/report_level_department.rml',
     parser=report_level_department)
