from report import report_sxw
import datetime
from datetime import datetime
import calendar


class report_listado_prestaciones_sociales(report_sxw.rml_parse):
    _name =  'report.listado.prestaciones.sociales'
    
    def __init__(self, cr, uid, name, context):
        super(report_listado_prestaciones_sociales, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'generar_conculta_conceptos':self.generar_conculta_conceptos,
            'consulta_concepto':self.consulta_concepto,
            'get_totales':self.get_totales,
            
        })
        self.cr = cr
        self.uid = uid
        self.context = context
        self.agrupador = {}
        self.concept_historico = {}
        self.salidas = []
        self.totales = {'prest_acum':{'anterior':0.0, 'mes_pamm':0.00, 'actual':0.00}, 
                        'anticipos':{'actual':0.0, 'acumulado':0.00},  
                        'inetereses':{'anterior':0.00, 'actual':0.00},
                        'pago_intereses':{'pago':0.00}}
    
    def get_totales(self, parametro, month_id, colum, acum=None):
        return self.totales[parametro][colum]
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def query(self):
        sql = """
            select  employee.id, employee.cod_number, employee.name, pay_line.total, concept.id from hr_payslip_line as pay_line
            join hr_payslip as pay ON pay_line.slip_id = pay.id
            join hr_employee as employee ON pay_line.employee_id = employee.id
            join hr_concept as concept ON pay_line.concept_id = concept.id
            where pay_line.slip_id in (select slip.id from hr_payslip as slip 
            join hr_employee as employee ON slip.employee_id = employee.id
            join hr_process as process ON slip.hr_process_id = process.id
            where process.id in (select process_id from hr_period_process_rel as process_rel 
            join hr_period as period ON process_rel.period_id = period.id
            join hr_month as month ON period.hr_month_id = month.id
            where month.id=%s)
            """
        return sql 
    
    def generar_conculta_conceptos(self, data):
        result = '0.0'
        agrupador = {} 
        sql = self.query()
        month_id = data['month_id']
        sede_id = data['sede_id']
        employee_id = data['employee_id']
        concept_list = data['concept_list']
        paramters_dict = data['paramters_dict']
        selection = data['selection']
        self.concept_historico = data['conept_historico']
        sql = sql % month_id
        if employee_id:
           sql= sql + "\nand employee.id=%s"%employee_id
        sql = sql + ")" 
        if sede_id:
           sql= sql + "\nand pay_line.sede_id=%s"%sede_id
        sql = sql + "\nand concept.id in %s" %str(self.list_2_typle(concept_list))
        
        self.cr.execute(sql)
        result = self.cr.fetchall()
        for i in result:
            self.salidas.append((i[0],i[1],i[2]))
            agrupador[(i[0],i[1],i[2])] = {}
        for i in result:
            agrupador[(i[0],i[1],i[2])].update({paramters_dict[i[4]]:[i[4],i[3]]})
        agrupador = self.chek_concept(agrupador,selection)
        self.agrupador = agrupador
        return agrupador
    
    def get_concept(self, code):
        sql = """
            select code from hr_concept where id = '%s'
            """ %code
        self.cr.execute(sql)
        result = self.cr.fetchall()
        return result[0][0]
    
    def chek_concept(self, struct, selection):
        for k in struct:
            for l in selection.keys():
                if l not in struct[k]:
                   struct[k].update({l:[selection[l], 0.00]})
        return struct

    def consulta_concepto(self, k, parametro, month_id, colum, acum=None):
        agrr = self.agrupador[k]
        sum_concept_last = self.sumatoria_mes_anterior
        sum_concept = self.sumatoria_concepto
        salida = {'actual':0.0, 'mes':0.0, 'anterior':0.0, 'acumulado':0.0, 'pago':0.0, 'mes_pamm':0.0}
        salida['actual']= agrr[parametro][1]
        salida['pago']= agrr[parametro][1]
        salida['anterior']= sum_concept_last(k[0], agrr[parametro][0], month_id)
        salida['mes']= salida['actual']-salida['anterior']
        salida['mes_pamm']= salida['actual']-salida['anterior']+agrr['anticipos'][1]
        salida['acumulado']= sum_concept_last(k[0], agrr[parametro][0], month_id, final=acum)
        self.totales[parametro][colum] += salida[colum]
        return salida[colum]
    
    def get_process_for_period(self, month_id):
        sql = """
        select distinct process_id from hr_period_process_rel as process_rel 
        join hr_period as period ON process_rel.period_id = period.id
        join hr_month as month ON period.hr_month_id = month.id
        where month.id in %s
        """%str(month_id)
        self.cr.execute(sql)
        result = self.cr.fetchall()
        return result

    def sumatoria_concepto(self, employee_id, concept_id, month_id):
        attr_obj = self.pool.get('hr.attribute')
        month_id = self.list_2_typle(month_id)
        process_id = self.get_process_for_period(month_id)
        process_id = [t for l in process_id for t in l] 
        process_id = self.list_2_typle(process_id)
        if process_id:
            sql = """
                select sum(total) from hr_payslip_line 
                where employee_id =%s 
                and concept_id = %s
                and process_id in %s
                """%(employee_id, concept_id,process_id)
            self.cr.execute(sql)
            result = self.cr.fetchall()
            result = [l for t in result for l in t][0]
        else:
            code_concept = self.concept_historico
            attr_id = attr_obj.search(self.cr, 1, [('concept_id','=', code_concept[concept_id]), ('employee_id','=',employee_id)])
            attr_brw = attr_obj.browse(self.cr, 1, attr_id)
            result = [i.amount  for i in attr_brw ]
            result = sum(result)
        return result or 0.00

    def add_months(self, sourcedate, months):
        month = sourcedate.month - 1 + months
        year = sourcedate.year + month / 12
        month = month % 12 + 1
        day = min(sourcedate.day,calendar.monthrange(year,month)[1])
        fech = "%s-%s-%s"%(year,month,day)
        return fech
    
    def sumatoria_mes_anterior(self, employee_id, concept_id, month_id, final=None):
        total = 0.0
        month_obj = self.pool.get('hr.month')
        period_obj = self.pool.get('hr.period')
        month_brw = month_obj.browse(self.cr, self.uid, month_id) 
        year = month_brw.hr_year_id.year 
        month =  month_brw.month_year
        date_start = "%s-%s-01" %(year, month)
        date_end = "%s-%s-%s" %(year, month, calendar.monthrange(year, month)[1]) 
        formato = '%Y-%m-%d'
        if not final:
            somedate1 = datetime.strptime(date_start, formato)
            somedate2 = datetime.strptime(date_end, formato)
            date_start = self.add_months(somedate1, -1)
            date_end = self.add_months(somedate2, -1)
            if not final:
               param = [('date_start', '>=', date_start), ('date_end', '<=', date_end)]
        else:
            param = [('date_end', '<=', date_end)]
        
        period_id = period_obj.search(self.cr, 1, param)
        period_brw = period_obj.browse(self.cr, 1, period_id)
        month_ids = [i.hr_month_id.id for i in period_brw]
        month_ids = list(set(month_ids))
        total = self.sumatoria_concepto(employee_id, concept_id, month_ids)
        return total or 0.00
        
    def list_2_typle(self, lista):
        if not isinstance(lista, list):
           lista = [lista] 
        lista = [str(i) for i in lista]    
        t = ()
        if len(lista) == 1:
            t = "(%s)"%"".join(lista)
        else:
            t = tuple(lista)
        return t  

    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        return  datetime.datetime.strptime(fecha, '%Y-%m-%d').strftime('%Y%m%d')    
    

report_sxw.report_sxw(
    'report.listado.prestaciones.sociales',
    'wizard.listado.prestaciones.sociales',
    'sisb_nomina/report/report_listado_prestaciones_sociales.rml',
    parser=report_listado_prestaciones_sociales, header=False)
