#!/usr/bin/python
# -*- encoding: utf-8 -*-

############### Credits ########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt
import base64
from osv import osv,fields
from tools.translate import _
import unicodedata
import re
import datetime
import itertools
from creador_tablas_rml import bloktables
from creador_tablas_rml import agregar_etiqueta
from creador_tablas_rml import sections

class report_reporte_multiple_nomina(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_reporte_multiple_nomina, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'get_title': self.get_title,
            'getEmpleados': self.getEmpleados,
            'getName': self.getName,
            'getConcepto': self.getConcepto,
            'formatDepertament': self.formatDepertament,
            'getConceptoTotal': self.getConceptoTotal,
            'total': self.total,
            'get_final': self.get_final,
            'get_': self.get_,
        
            
            
            'leer_diccionario': self.leer_diccionario,
            'format_departamento': self.format_departamento,
            'leer_conceptos': self.leer_conceptos,
            'get_name_concept': self.get_name_concept,
            'get_name_empleado': self.get_name_empleado,
           
            
            
        })
        self.values_concept = {}
        self.concept = []
        self.values_con = {}
        self.total_departamento={}
        self.total_general={}
        
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def formatDepertament(self, dep):
        return dep[0]
        
    def get_title(self, title_id):
        cr = self.cr
        uid = self.uid
        SQL = """select name from reporte_multiple where id = %s"""%(str(title_id))
        cr.execute(SQL)
        ids =  cr.fetchall()
        return ids[0][0] 
    
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
    
    
    
    def get_final(self, dat):
        self.values_tt = dat
        return ""
    
    
    
    
    def getEmpleados(self, dep):
        if dep[0] in self.values_concept:
            return self.values_concept[dep[0]]
        
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    def getName(self, identificador):
        cr = self.cr
        uid = self.uid
        obj_emplo = self.pool.get('hr.employee')
        id_ = obj_emplo.search(cr, uid, [('id','=',identificador)])
        browse_employee = obj_emplo.browse(cr, uid, id_)
        for i in  browse_employee:
            return i.name
    
    
    
    def get_name_empleado(self, depart):
        return depart[0].keys()
    
    
    def get_name_concept(self, con_id):
        obj_concepto = self.pool.get('hr.concept')
        id_ = obj_concepto.search(self.cr, self.uid, [('id','=',con_id)])
        browse_concepto = obj_concepto.browse(self.cr, self.uid, id_)
        for i in browse_concepto:
            return i.name
        
    def leer_conceptos(self):
        return self.concept
    
    def leer_diccionario(self):
        return self.values_concept
    
    def format_departamento(self, dep):
        departamento = dep[0].split("/")
        del departamento[0]
        cadena="/".join(departamento)
        return cadena
    
    
    
    def get_(self, data):
        cr = self.cr
        uid = self.uid
        
        mes = data['mes']
        titulo_id = data['titulo_id']
        sede_id = data['sede_id']
        departamento_id = data['departamento_id']
        tipo_reporte = data['tipo_reporte']
        
        obj_departament = self.pool.get('hr.department')
        obj_payslip = self.pool.get('hr.payslip')
        obj_concept = self.pool.get('reporte.multiple.lineas')
        obj_month = self.pool.get('hr.month')
        obj_payslip_line = self.pool.get('hr.payslip.line')
         
        """ busco los ids de los periodos asociados al mes seleccionado """
        
        month = obj_month.search(cr, uid, [('id','=',mes)])
        browse_month = obj_month.browse(cr, uid, month[0])
        period_ids = [a.id for a in browse_month.hr_period_ids]
        

        """ busco los conceptos """
        
        concept_id = obj_concept.search(cr, uid, [('resporte_multiple_id','=',titulo_id)])
        browse_concept = obj_concept.browse(cr, uid, concept_id)
        
        conceptos=[]
        for i in browse_concept:
            conceptos.append(i.concept_id.id)
        
        """   """
        
        lista_completa=[]
        process_ids = self.pool.get('hr.process').search(cr, uid, [('hr_period_ids','in',period_ids)])
        lista_completa.append(('hr_process_id','in',process_ids))
        if sede_id:
            lista_completa.append(('sede_id','=',sede_id))
        if departamento_id:
            lista_completa.append(('department_id','=', departamento_id)) 
        id_payslip = obj_payslip.search(cr, uid, lista_completa)
        id_payslip_line = obj_payslip_line.search(cr, uid, [('slip_id','in',id_payslip),('concept_id','in',conceptos)])
        browse_payslip_line = obj_payslip_line.browse(cr, uid, id_payslip_line)    
       
        
        """  creo el diccionario de datos """
        
        dicc = {}
        dicct ={}
        dicctt={}
        for x in browse_payslip_line:
            dicc[x.department_id.id]={}
            dicct[x.department_id.id]={}
            
        for x in browse_payslip_line:
            dicc[x.department_id.id].update({x.employee_id.id:{}})
            
            
        for x in browse_payslip_line:
            for c in conceptos:
                dicc[x.department_id.id][x.employee_id.id].update({c:{'amount':0.0, 'quantity':0.0, 'total':0.0}})
                dicct[x.department_id.id].update({c:{'amount':0.0, 'quantity':0.0, 'total':0.0}})
                dicctt[c] = {'amount':0.0, 'quantity':0.0, 'total':0.0}
            
        
        for x in browse_payslip_line:
            dicc[x.department_id.id][x.employee_id.id][x.concept_id.id]['amount'] += x.amount
            dicc[x.department_id.id][x.employee_id.id][x.concept_id.id]['quantity'] += x.quantity
            dicc[x.department_id.id][x.employee_id.id][x.concept_id.id]['total'] += x.total
            
            dicct[x.department_id.id][x.concept_id.id]['amount'] += x.amount
            dicct[x.department_id.id][x.concept_id.id]['quantity'] += x.quantity
            dicct[x.department_id.id][x.concept_id.id]['total'] += x.total
            
            dicctt[x.concept_id.id]['amount'] += x.amount
            dicctt[x.concept_id.id]['quantity'] += x.quantity
            dicctt[x.concept_id.id]['total'] += x.total
            
        acumulador = {}
        ids_departamento = {} 
        
        for i in browse_payslip_line:
            dep_rea = obj_departament.read(self.cr, self.uid, i.department_id.id)
            acumulador[dep_rea['complete_name']] = dicc[i.department_id.id]
            ids_departamento[dep_rea['complete_name']] = i.department_id.id
            
        order_list = []
        for x in sorted(acumulador.iterkeys()):
            order_list.append({x:acumulador[x]})
        
        self.id_departament = ids_departamento
        self.values_concept = order_list
        self.concept = conceptos
        self.values_con = dicc
        self.total_departamento = dicct
        self.total_general= dicctt
        
        return ""
    
    
    def getConcepto(self, dep, emple, concp):
        departamento = self.id_departament[dep[0]]
        return self.values_con[departamento][emple][concp]
    
    def getConceptoTotal(self, dep, conc):
        departamento = self.id_departament[dep[0]]
        return self.total_departamento[departamento][conc]
        
    def total(self, conc):
    
        return self.total_general[conc]
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
report_sxw.report_sxw('report.reporte.multiple.nomina',
    'wizard.reporte.multiple.nomina',
    'sisb_nomina/report/report_reporte_multiple_nomina.rml', parser=report_reporte_multiple_nomina)
