#-*- coding:utf-8 -*-

from report import report_sxw
from report.report_sxw import rml_parse
from datetime import datetime
import time
from osv import fields, osv

class report_maximum_passive_holiday(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(report_maximum_passive_holiday, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'process': self.process,
            'data_rml': self.data_rml,
            'printing_total_empleado': self.printing_total_empleado,
            'printing_total': self.printing_total,
            'total_resumen_rml': self.total_resumen_rml,
            'printing_total_gerencia': self.printing_total_gerencia,
        })
        
        self.lista_resumen = []
        self.total_resumen = {}
        self.total_empleado={}
        self.total_departamento={}
        self.dicc_department = {}
        
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%Y-%m-%d')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d/%m/%Y'))
    
    
    def process(self, data):
        
        dicc_department = {}
        total_gerencia = {}
        
        for i in data['form']:
            sql = 'select nombre_departamento(%s)'%(i)
            self.cr.execute(sql)
            name_full = self.cr.fetchall()
            dicc_department[name_full[0][0]] = sorted(data['form'][i])
        
        dic_res = {}
        for i in dicc_department:
            gerencia = i.split('/')[1]
            dic_res[gerencia.strip()] = []
            total_gerencia[gerencia.strip()]=[]

        for i in dicc_department:
            gerencia = i.split('/')[1]
            dic_res[gerencia.strip()].append(dicc_department[i])
            
        for x in dic_res:
            n=[]
            for i in dic_res[x]:
                for c in i:
                    n.append(c)
            dic_res[x] = sorted(n)
    
        total_gerencia={}
        for i in dic_res:
            total_gerencia[i] = 0.0
            for x in dic_res[i]:
                for c in x[2]:
                    total_gerencia[i] += c['a']
        
        order_list = []
        for x in sorted(dic_res.iterkeys()):
            order_list.append({x:dic_res[x]})
        
        self.dicc_department = order_list
        self.total_resumen = data['total_resumen']
        self.total_empleado = data['total_empleado']
        self.total_departamento = total_gerencia
        
    def data_rml(self):
        return self.dicc_department
        
    def printing_total_gerencia(self, gerencia):
        return self.total_departamento[gerencia]
        
    def printing_total_empleado(self, code_employee):
        return self.total_empleado[code_employee]
    
    def printing_total(self):
        dic_res = {}

        for x in self.dicc_department:
            for i in x.values()[0]:
                for c in i[2]:
                    dic_res[c['n']] = 0.0

        for x in self.dicc_department:
            for i in x.values()[0]:
                for c in i[2]:
                    dic_res[c['n']] += c['a']

        for x in dic_res:
            self.lista_resumen.append((x, dic_res[x]))
            
        self.lista_resumen = sorted(self.lista_resumen)
        
        return self.lista_resumen
    
     
    def total_resumen_rml(self):
        return self.total_resumen
        
    
report_sxw.report_sxw('report.maximum.passive', 
                      'wizard.maximum.passive.holiday', 
                      'sisb_nomina/report/reporte_pasivo_maximo_vacaciones.rml', 
                       parser=report_maximum_passive_holiday,header=False)

