#-*- coding:utf-8 -*-
##############################################################################
#
#    SISB, Sistema Integral Simón Bolivar
#    Copyright (C) 2012-2013 Industrias Diana, C.A. All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
from datetime import datetime
from datetime import timedelta

class reporte_multiple(osv.osv):
    _name = 'reporte.multiple'
    _description = 'Reporte multiple'
    _columns = {
        'name': fields.char('Titulo', size=256, required=True),
    }
    
reporte_multiple()


class reporte_multiple_lineas(osv.osv):
    _name = 'reporte.multiple.lineas'
    _description = 'Reporte multiple lineas'
    

    def _contar_columna(self, cr, uid, ids, field_name, arg, context=None):
       
        obj_lineas = self.pool.get('reporte.multiple.lineas')
        res ={}
        c = 0
        for i in ids:
            if c >= 6:
                raise osv.except_osv(_('ERROR!'), _('Dicho reporte ya contiene la cantidad de columnas establecidas'))
            c+=1
            res[i] = "Columna " + str(c)
            
        return res
                
        
    _columns = {
        
        'concept_id': fields.many2one('hr.concept', 'Conceptos', required=True),
        'columna' : fields.function(_contar_columna, string='Columna', method=True, type='char', size=100, required=True),
        'resporte_multiple_id': fields.many2one('reporte.multiple', 'reporte multiple', required=True, ondelete="cascade"),
    }
    
    
    def _check_columna(self, cr, uid, ids, context = None):
        obj_lineas = self.pool.get('reporte.multiple.lineas')
        lista=[]
        for i in self.browse(cr, uid, ids, context=context):
            titulo = i.resporte_multiple_id.id
        lineas_id = obj_lineas.search(cr, uid, [('resporte_multiple_id','=', titulo)])
        brw = obj_lineas.browse(cr, uid, lineas_id)
        for i in brw:
            lista.append(i.columna)
        aux=[]
        for i in lista:
            if i in aux:
                return False
            aux.append(i)
        return True
        
        
    def _check_concept(self, cr, uid, ids, context = None):
        obj_lineas = self.pool.get('reporte.multiple.lineas')
        lista=[]
        
        for i in self.browse(cr, uid, ids, context=context):
            titulo = i.resporte_multiple_id.id
        lineas_id = obj_lineas.search(cr, uid, [('resporte_multiple_id','=', titulo)])
        brw = obj_lineas.browse(cr, uid, lineas_id)
        
        for i in brw:
            lista.append(i.concept_id)
        aux=[]
        for i in lista:
            if i in aux:
                return False
            aux.append(i)
        return True
        
    _constraints = [(_check_columna, "Columna repetida",['columna']),(_check_concept, "Concepto repetido",['concept_id'])]
      

reporte_multiple_lineas()

class reporte_multiple_herencia(osv.osv):

    _inherit = 'reporte.multiple'
    _description = 'Reporte multiple herencia'
    _columns = {
        'reporte_multiple_lineas_ids': fields.one2many('reporte.multiple.lineas', 'resporte_multiple_id', 'lineas'),
    }
  
reporte_multiple_herencia()




