#!/usr/bin/env python
# -*- coding: utf-8 -*--

from time import strftime
from datetime import datetime
from dateutil import relativedelta  
from osv import fields, osv
import calendar

class wizard_reporte_general(osv.osv_memory):
    _name = 'wizard.reporte.general'
    _description = 'Csv de reporte general de trabajadores'
    _columns = {
         
        'borrador': fields.boolean("BORRADOR"),
        'activo': fields.boolean("ACTIVO"),
        'vacaciones': fields.boolean("VACACIONES"),
        'reposo': fields.boolean("REPOSO"),
        'egresado': fields.boolean("EGRESADO"),
        'actual': fields.boolean("Actual"),
        'mes_id': fields.many2one('hr.month', 'Mes', required=True),
        'codigo': fields.boolean("Codigo"),
        'cedula': fields.boolean("Cedula"),
        'nombre': fields.boolean("Nombre"),
        'fecha_nacimiento': fields.boolean("Fecha Nacimiento"),
        'edad': fields.boolean("Edad"),
        'inicio_relacion_laboral': fields.boolean("Inicio Relacion Laboral"),
        'fin_relacion_laboral': fields.boolean("Fin Relacion Laboral"),
        'sueldo': fields.boolean("Sueldo"),
        'sede': fields.boolean("Sede"),
        'nomina': fields.boolean("Nomina"),
        'tiempo_servicio': fields.boolean("Tiempo Servicio"),
        'fecha_hoy_o_mes': fields.boolean("Fecha"),
        'departamento': fields.boolean("Departamento"),
        'cargo': fields.boolean("Cargo"),
        'gender': fields.boolean("Sexo"),
        'mobile_phone': fields.boolean("Telefono"),
        'email': fields.boolean("Correo"),
        'estado': fields.boolean("Estado"),
    
    }
    
    _defaults = {
        'actual': True, 'activo': True, 'nombre': True, 'codigo': True, 'cedula': True,
    }
    
    
    def generar_csv_reporte_general(self, cr, uid, ids, context=None):
        
        brw = self.browse(cr, uid, ids)[0]
        
        """preparando lista de consulta"""
        
        estados = []
        
        obj_employee = self.pool.get('hr.employee') 
        
        borrador= brw.borrador
        activo=  brw.activo
        vacaciones=  brw.vacaciones
        reposo= brw.reposo
        egresado= brw.egresado
        
        mes_id = brw.mes_id
        actual= brw.actual
        
        codigo = brw.codigo
        cedula= brw.cedula
        nombre= brw.nombre
        fecha_nacimiento= brw.fecha_nacimiento
        edad= brw.edad
        inicio_relacion_laboral= brw.inicio_relacion_laboral
        fin_relacion_laboral= brw.fin_relacion_laboral
        sueldo= brw.sueldo
        sede= brw.sede
        nomina= brw.nomina
        departamento= brw.departamento
        cargo= brw.cargo
        sexo=brw.gender
        telefono=brw.mobile_phone
        correo=brw.email
        estado=brw.estado
        tiempo_servicio= brw.tiempo_servicio
        fecha_hoy_o_mes= brw.fecha_hoy_o_mes
        
        if mes_id:
            year = brw.mes_id.hr_year_id.year 
            month =  brw.mes_id.month_year
            date_start = "%s-%s-01" %(year, month)
            date_end = "%s-%s-%s" %(year, month, calendar.monthrange(year, month)[1])
            date_end = datetime.strptime(date_end, '%Y-%m-%d') 
            formato = str(date_end).split(" ")
            fecha_consulta = formato[0]
        else:
            fecha_consulta = self.get_final_date()
            if borrador:estados.append('borrador')
            if activo: estados.append('activo')
            if vacaciones:estados.append('vacaciones')
            if reposo:estados.append('reposo')
            if egresado:estados.append('egresado')
        
        titulo = []
        cabezera=[]
        
        if codigo:cabezera.append('codigo')
        if cedula: cabezera.append('cedula')
        if nombre:cabezera.append('nombre')
        if sexo:cabezera.append('sexo')
        if telefono:cabezera.append('telefono')
        if correo:cabezera.append('correo')
        if fecha_nacimiento:cabezera.append('fecha_nacimiento')
        if edad:cabezera.append('edad')
        if inicio_relacion_laboral:cabezera.append('inicio_relacion_laboral')
        if fin_relacion_laboral: cabezera.append('fin_relacion_laboral')
        if sueldo:cabezera.append('sueldo')
        if sede:cabezera.append('sede')
        if nomina:cabezera.append('nomina')
        if departamento:cabezera.append('departamento')
        if cargo:cabezera.append('cargo')
        if tiempo_servicio:
            cabezera.append('anos_antiguedad')
            cabezera.append('meses_antiguedad')
            cabezera.append('dias_antiguedad')
        if fecha_hoy_o_mes:cabezera.append('fecha')
        if estado:cabezera.append('estado')
        
        if cabezera:
                data={}
                data['form'] = cabezera
                data['estados'] = estados
                data['fecha'] = fecha_consulta
                data['tipo'] = actual
        else:
            raise osv.except_osv(('ERROR!'), ('Debe seleccionar los datos que desea mostrar en el reporte!!!'))
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name':'general.trabajadores',
            'datas': data,
            }
            
    def get_final_date(self):
        return datetime.now().strftime('%Y-%m-%d')
        
    
wizard_reporte_general()
