#!/usr/bin/env python
# -*- coding: utf-8 -*--

from time import strftime
from datetime import *
import datetime
from dateutil import relativedelta
import netsvc
from osv import fields, osv
import tools
from tools.translate import _
import logging
import base64
import os
import math
import calendar
import re 
import unicodedata




class wizard_listado_prestaciones_sociales(osv.osv_memory):
    _name = 'wizard.listado.prestaciones.sociales'
    _description = 'Wizar para generar reporte de listado de prestaciones sociales'
    _columns = {
    'month_id': fields.many2one('hr.month', 'Mes', required=True), 
    'sede_id': fields.many2one('hr.sede', 'Sede'), 
    'employee_id': fields.many2one('hr.employee', 'Trabajador'), 
    }
    
    def generar_listado(self, cr, uid, ids, context=None):
        agrupador = {}
        wizard_brw = self.browse(cr, uid, ids)[0]
        parametros_obj = self.pool.get('hr.parameters')
        parametros_id = parametros_obj.search(cr, uid, [('type', '=', 'parametros_listado_prestaciones')])
        if not parametros_id:
           raise osv.except_osv(_('ERROR!'), _('No existe el parametro Concepto Listado Prestaciones'))
        
        parametros_brw = parametros_obj.browse(cr, uid, parametros_id)[0]
        concept_list = []
        paramters_dict = {}
        conept_historico = {}
        selection = {}
        for i in parametros_brw.listado_prestaciones_ids:
            paramters_dict[i.concept_id.id] = i.name
            selection[i.name] = i.concept_id.id
            conept_historico[i.concept_id.id] = i.concept_historico_id.id or False
            concept_list.append(i.concept_id.id)
			
		
        for i in self._columns:
            if type(getattr(wizard_brw, i)) in [osv.orm.browse_record, osv.orm.browse_null]:
                agrupador[i] = getattr(getattr(wizard_brw, i),'id')
            else:
                agrupador[i] =  getattr(wizard_brw, i) 
        
        agrupador['sede_name']=wizard_brw.sede_id.name.upper() if wizard_brw.sede_id else None 
        if wizard_brw.month_id:
            agrupador['month_name']=wizard_brw.month_id.name.upper() 
        
        agrupador['concept_list']=concept_list 
        agrupador['paramters_dict']=paramters_dict 
        agrupador['selection']=selection 
        agrupador['conept_historico']=conept_historico 
        data={'form':agrupador}
        return {
        'type': 'ir.actions.report.xml',
        'report_name': 'listado.prestaciones.sociales',
        'datas': data,
        }

wizard_listado_prestaciones_sociales()
