#-*- coding:utf-8 -*-
#!/usr/bin/env python

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

from osv import osv,fields
from tools.translate import _
import pooler
import time
import unicodedata
import re
import datetime

import calendar

class wizard_reporte_multiple_nomina(osv.osv_memory):
    _name = "wizard.reporte.multiple.nomina"
    _description = 'Wizard para generar REPORTE MULTIPLE'
    
    
    def _contar_titulos(self, cr, uid, context=None):
       
        obj_titulo = self.pool.get('reporte.multiple')
        titulo_id = obj_titulo.search(cr, uid, [])
        titulo_browse = obj_titulo.browse(cr, uid, titulo_id)
        res =[]
        res.append(('False',' '))
        for i in titulo_browse:
            res.append( (str(i.id), str(i.name) ))
        return res
    
    _columns = {
        'titulo': fields.selection(_contar_titulos, 'reporte multiple', size=64, required=True),
        'mes': fields.many2one('hr.month', 'Mes', required=True),
        'sede': fields.many2one('hr.sede', 'Sede'),
        'departamento': fields.many2one('hr.department', 'Departamento'),
        'tipo_reporte':fields.selection([('resumido','Resumido'),('detallado', 'Detallado')], 'Tipo de Reporte', required=True),
        'listado':fields.many2many('reporte.multiple.lineas', 'multiple_rel', 'resporte_multiple_id', 'name',  'Conceptos', readonly=True),
    
    }
   
    def onchange_lista_concepto(self, cr, uid, ids, titulo):
        titulo = eval(titulo)
        result = {}
        obj_concept = self.pool.get('reporte.multiple.lineas')
        concept_id = obj_concept.search(cr, uid, [('resporte_multiple_id','=',titulo)])
        result['value'] = {'listado': (6,0, concept_id)}
        return result
            
    
    
    
    def getObtenerDia(self, mes, dia="primer"):
        """Devuelve una tupla con el dia de la semana del dia 1, y el numero de dias que tiene el mes... 
            para el ejemplo, devolvera (6, 31)
            6 => el día 1 del 12/2013 cae en domingo
            31 => dispone de 31 días"""   
        meses = {'Enero':'01', 'Febrero':'02', 'Marzo':'03', 'Abril':'04', 'Mayo':'05', 'Junio':'06', 
        'Julio':'07', 'Agosto':'08', 'Septiembre':'09', 'Octubre':'10', 'Noviembre':'11', 'Diciembre':'12'}
        mes = mes.split(" ")
        calendario = calendar.monthrange(int(mes[1]),int(meses[mes[0]]))
        if dia == "ultimo":
            fecha_creada = str(mes[1])+"-"+ str(meses[mes[0]])+ "-" + str(calendario[1])
            return fecha_creada
        return str(mes[1]+"-") + str(meses[mes[0]]) + "-01"
        
        
        
        
    
    def generar_reporte_multiple(self, cr, uid, ids, context=None):
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        
        titulo_id = eval(brw.titulo)
         
        if not titulo_id:
            raise osv.except_osv(('ERROR!'), ('Debe seleccionar un reporte por favor!!!'))
       
        mes = brw.mes
        
        if not brw.departamento.id:
            departamento_id = False
        else:
            departamento_id = brw.departamento.id
                
        if not brw.sede.id:
            sede_id = False
        else:
            sede_id = brw.sede.id
        
        tipo_reporte = brw.tipo_reporte
         
        
        obj_concept = self.pool.get('reporte.multiple.lineas')
        concept_id = obj_concept.search(cr, uid, [('resporte_multiple_id','=',titulo_id)])
        
        if (len(concept_id)<1):
            raise osv.except_osv(_('ERROR!'), _('No existen conceptos cargados para generar dicho reporte!!!'))
           
        browse_concept = obj_concept.browse(cr, uid, concept_id)
        cant = len(browse_concept)
        
        data={}
        data['mes'] = mes.id
        data['mes_name'] = mes.name
        data['titulo_id'] = titulo_id
        data['sede_id'] = sede_id
        data['departamento_id'] = departamento_id
        data['columnas'] = cant
         
        if departamento_id:
            data['departamento_id2'] = brw.departamento.name
        else:
            data['departamento_id2'] = "TODOS"
        if sede_id:
            data['sede_id2'] = brw.sede.name
        else:
            data['sede_id2'] = "TODOS"
        data['tipo_reporte'] = tipo_reporte.upper()
        

        if data == {}:
            raise osv.except_osv(_('ERROR!'), _('La combinación de filtros para generar este reporte no produjo ningun resultado'))
        else:   
            ruta=""
            if cant >= 5: 
                ruta = "mas_de_cuatro"
            else: 
                ruta = "menos_de_cuatro"
            
            dict_ruta = {'mas_de_cuatro':'sisb_nomina/report/report_reporte_multiple_nomina.rml',
            'menos_de_cuatro':'sisb_nomina/report/report_reporte_multiple_nomina_2.rml',}
            ir_obj = self.pool.get('ir.actions.report.xml')
            ir_id = ir_obj.search(cr, 1, [('model','=',self._name)]) 
            ir_write= ir_obj.write(cr, 1, ir_id, {'report_rml':dict_ruta[ruta]})
            
            return {
                'type': 'ir.actions.report.xml',
                'report_name': 'reporte.multiple.nomina',
                'datas':data, 
                }

wizard_reporte_multiple_nomina()
