#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import datetime
import time 
import logging
from tools.translate import _
from datetime import datetime
import calendar



class commission_wizard_concept_variable(osv.osv_memory):
    _name = 'commission.wizard.concept.variable'
    _description = 'pago de comisiones por nomina'
    _columns = {
        'hr_payroll_id': fields.many2one('hr.payroll','Nomina'),
        'ejecutado':fields.boolean('Ejecutado'),
    }
    
    def _get_process(self, cr, uid, hr_payroll, lines, context=None):
        proceso_obj = self.pool.get('hr.process')
        proceso_ids = proceso_obj.search(cr, uid, [('type','=','nomina'),('state','in',['load', 'review'])], context=None)
        procesos = proceso_obj.browse(cr, uid, proceso_ids, context)
        process_concept_variable = {}
        process_user_ids = []
        for proceso in procesos:
            if hr_payroll in proceso.hr_payroll_ids:
               for line in lines:
                   usuarios_payslip = list(set([i.employee_id.user_id.id for i in proceso.hr_payslip_ids if i.employee_id.user_id.id ]))
                   if line.user_id.id in usuarios_payslip:
                       process_concept_variable[proceso.id] = usuarios_payslip
        if not process_concept_variable:
            raise osv.except_osv(_('Error'), _('No existe un proceso en el cual cargar las comisiones para los trabajadores de la nomina %s') % hr_payroll.name)
        return process_concept_variable 
		
    def _get_conceptos_variables_procesos(self, cr, uid, procesos_ids, tipo_de_proceso=False, context=None):
        conceptos_variables_obj =  self.pool.get('hr.variable.concepts')
        conceptos_variables_reposos = {}

        for proceso_id in procesos_ids:
            conceptos_variables_id = conceptos_variables_obj.search(cr, uid, 
                                 [('hr_process_id','=',proceso_id),
                                 ('tipo_de_proceso','=',tipo_de_proceso),
                                 ('state','in',['draft','load','review'])], context=None)
            
            if not conceptos_variables_id:
                values = {
                    'tipo_de_proceso': tipo_de_proceso,
                    'hr_process_id': proceso_id,
                }
                conceptos_variables_id = conceptos_variables_obj.create(cr, uid, values, context)
                conceptos_variables_reposos[proceso_id] = conceptos_variables_id
            else:
                conceptos_variables_reposos[proceso_id] = conceptos_variables_id[0]
        return conceptos_variables_reposos
    
    def list_2_typle(self, lista):
        if not isinstance(lista, list):
           lista = [lista] 
        lista = [str(i) for i in lista]    
        t = ()
        if len(lista) == 1:
            t = "(%s)"%"".join(lista)
        else:
            t = tuple(lista)
        return t
    
    
    def consulta_vendedores(self, cr, uid, usuarios, estado, fecha):
        l2t = self.list_2_typle
        agrr_comminssion = {}
        sql = """
		select employee.id, commission.id, 
		commission.commission,commission.user_id  
		from sisb_commission as commission
		join resource_resource as resource 
		ON resource.user_id = commission.user_id 
		join hr_employee as employee 
		ON employee.resource_id = resource.id
		where commission.user_id in %s
		and commission.state = '%s'
        and commission.paid_date_invoice <= '%s'
        """%(l2t(usuarios), estado, fecha)
        cr.execute(sql)
        result = cr.fetchall()
        for r in result:
            agrr_comminssion[r[0]] = {}
        for r in result:
            agrr_comminssion[r[0]].update({r[1]:r[2]})
        calculadas = self.sumar_lineas(agrr_comminssion)
        return calculadas
      
    def add_months(self, sourcedate, months, formato='%Y-%m-%d'):
        sourcedate = datetime.strptime(sourcedate, formato)
        month = sourcedate.month - 1 + months
        year = sourcedate.year + month / 12
        month = month % 12 + 1
        day = calendar.monthrange(year,month)[1]
        fech = "%s-%s-%s"%(year,month,day)
        return fech
    
    def ultimo_dia_mes(self, fecha, formato='%Y-%m-%d'):
        somedate = datetime.strptime(fecha, formato)
        dateMonthEnd="%s-%s-%s" % (somedate.year, somedate.month, calendar.monthrange(somedate.year, somedate.month)[1])
        return dateMonthEnd
    
    def ult_month_last_year(self, fecha, formato='%Y-%m-%d' ):
        ult_dia = self.ultimo_dia_mes(fecha, formato=formato)
        mes_ant = self.add_months(ult_dia, -1, formato=formato)
        return mes_ant
        
    def sumar_lineas(self, dict):
        acum_lines = {}
        for i in dict:
            acum_lines[i] = {'lineas':[], 'monto':0.0} 
        for i in dict:
            for l in dict[i]:
                acum_lines[i]['lineas'].append(l)
                acum_lines[i]['monto']+=dict[i][l]
        return acum_lines
        
    def crear_lineas_conceptos_variables(self, cr, uid, ids,  context = None):
        hr_variable_concept_line_obj = self.pool.get('hr.variable.concept.line')
        commissiones_obj = self.pool.get('sisb.commission')
        paremeters_obj = self.pool.get('hr.parameters')
        porcess_obj = self.pool.get('hr.process')
        paremeters_id = paremeters_obj.search(cr, uid, [('type','=','concepto_comisiones_ventas')])
        if not paremeters_id:
		  raise osv.except_osv(_('ERROR!'), _('No hay \
							un parámetro definido para Conceptos de comisiones en ventas \
							Ir \ a la pestaña Configuracion -> Configuraciones \
							de nomina -> Parametros de nomina y \
							registrar el parametro'))
        paremeters_brw = paremeters_obj.browse(cr, uid, paremeters_id)
        concept_id = paremeters_brw[0].concept_comisiones_venta_id.id
        idsw = [context['active_id']]
        nomina = self.browse(cr, uid, ids[0], context).hr_payroll_id
        commissiones_ids = commissiones_obj.search(cr, uid, [('state', '=', 'confirmed')])
        commissiones_brw = commissiones_obj.browse(cr, uid, commissiones_ids)
        procesos = self._get_process(cr, uid, nomina, commissiones_brw, context=None)
        procesos_ids = procesos.keys()
        concepts_variables = self._get_conceptos_variables_procesos(cr, uid, procesos_ids, tipo_de_proceso='comisiones', context=None) 
        for i in procesos:
            usuarios = procesos[i]
            process_brw = porcess_obj.browse(cr, uid, i)
            fecha = process_brw.hr_period_ids[0].date_start
            if fecha:
               fecha = self.ult_month_last_year(fecha)
            comisiones = self.consulta_vendedores(cr, uid, usuarios, 'confirmed', fecha)
            for u in comisiones:
                if comisiones[u]['monto'] > 0:
                   variables = {'variable_concept_id': concepts_variables[i],
                                'employee_id': u,
                                'concept_id': concept_id,
                                 'type': 'amount',
                                'value':comisiones[u]['monto'] }
                   hr_variable_concept_line_obj.create(cr, uid, variables)
                   commissiones_obj.write(cr, uid, comisiones[u]['lineas'], {'state':'done', 'variable_concept_id':concepts_variables[i]})
                elif comisiones[u]['monto'] == 0:
                     commissiones_obj.write(cr, uid, comisiones[u]['lineas'], {'state':'done', 'variable_concept_id':concepts_variables[i]})
            
        return {
        'type': 'ir.actions.act_window_close',
        'active_id': ids
        }





commission_wizard_concept_variable()
