# -*- encoding: utf-8 -*-

from osv import fields, osv
import time
from datetime import datetime
from datetime import  timedelta
import xmlrpclib
import tools
from tools.translate import _
import netsvc
logger = netsvc.Logger()
import logging
import smtp_client_mail
import calendar
import os

class notificaciones_configuracion(osv.osv):
    _name = "notificaciones.configuracion"
    _description = "notificaciones configuracion"
    _columns = {
        'name': fields.char('Nombre', size=256, required=True),
        'web_address': fields.char('Direccion Web', size=256, required=True),
        'web_user': fields.char('Usuario', size=256, required=True,),
        'password': fields.char('Password', size=256, required=True,),
        'mail': fields.char('Correo', size=256,),
        'mail_passwd': fields.char('Contrasena del correo', size=256),
        'url_source': fields.char('URL', size=256, required=True,),
        'state': fields.selection([('draft','Borrardor'), ('confirmed','Confirmado'), ('done', 'Listo')],'Estado',required=True,readonly=True),
        'activo': fields.boolean("Activo", readonly=True),
        'port': fields.integer("Puerto del servidor"),
        'server_smtp':  fields.char('Servidor SMTP', size=256,),
        'auth':fields.boolean("Utiliza autenticacion"),
        'state_server': fields.selection([('start','Iniciado'), ('stop','Detenido')],'Estado',required=True,readonly=True),
        'interval_update': fields.integer('Numero de Repeticiones cada Minuto'),
        'process_cron_id': fields.many2one('ir.cron', 'MTA Process', readonly=True),}
        
    _defaults = {
        'state': lambda *a: 'draft',
        'activo':False,
        'state_server':lambda *a: 'stop'}
    
    def funtion_cron_star(self, cr, uid, ids, context=None):
        if isinstance(ids, list):
            ids = ids[0]
        uid = 1
        ir_cron_obj = self.pool.get('ir.cron')
        brw = self.browse(cr, uid, ids)     
        res = {
            'name':'Procesar solicitudes',
            'model':'notificaciones.configuracion',
            'args': '(%s,%s,%s)'%(ids,[],context), 
            'function':'generate_notification',
            'priority':5,
            'interval_number':brw.interval_update,
            'interval_type':'minutes',
            'user_id':uid,
            'numbercall': -1,
            'doall':False,
            'active':True
        }
        cron_id = ir_cron_obj.create(cr, uid, res)
        self.write(cr, uid, ids, {'process_cron_id':cron_id})
        self.write(cr, uid, ids, {'state_server':'start'})
        return True
    
    def funtion_cron_stop(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids)
        for i in brw:
            self.pool.get('ir.cron').write(cr, uid, i.process_cron_id.id, {'active':False})   
            self.pool.get('ir.cron').unlink(cr, uid, i.process_cron_id.id)    
        self.write(cr, uid, ids, {'state_server':'stop'})
        return True
        
    
    def connect(self, cr, uid, ids, context=None, channel_notify=True):
        try:
            brw = self.browse(cr, uid, ids)[0]
        except:
            raise osv.except_osv(_('ERROR!'), _('No sea definido un usuario y url para la conexion'))  
        try:
            s = xmlrpclib.ServerProxy(brw.url_source)
            res = s.login(brw.web_user, brw.password)
        except:
            if channel_notify: 
                raise osv.except_osv(_('ERROR!'), _('Conexion rechazada'))
            else:
                logger.notifyChannel('XML-RPC', netsvc.LOG_ERROR, 'Conexion rechazada')
            return False 
        return [s, res] 

    def test_connection(self, cr, uid, ids, context=None):
        """
        Funcion para verificar la conexion XML-RPC
        """
        sock = self.connect(cr, uid, ids, context)
        if sock:
            self.write(cr, uid, ids, {'state':'confirmed'})
            self.write(cr, uid, ids, {'activo':True})
        return True 
     
    def test_connect_mail(self, cr, uid, ids, context=None):
        """
        Funcion para comprobar si el servidor de correo esta activo
        y recive los Datos correctos
        """
        brw = self.browse(cr, uid, ids)
        if isinstance(brw, list):
           brw = brw[0] 
        t = smtp_client_mail.sendmailThread(brw.server_smtp, brw.port)
        connect = t.connect(str(brw.mail), str(brw.mail_passwd))
        if not connect[1]:
           raise osv.except_osv(_('ERROR!'), _('Conexion rechazada'))
        if connect[1]:
            connect[0].close()
            raise osv.except_osv(_('INFO!'), _('Conexion aceptada'))      
    
    def create_notify(self, cr, uid, vals, context=None):
		novedad_obj = self.pool.get('notificaciones.libro.novedades')
		novedad_obj.create(cr, uid, vals)
		return True
    
    def search_employee(self, cr, uid, cedula):
        employee_obj = self.pool.get("hr.employee")
        employee_id = employee_obj.search(cr, uid, [('identification_id', '=', int(cedula) )])
        brw = employee_obj.browse(cr, uid, employee_id)
        return brw
  
        
    def send_email_user(self, cr, uid, ids, subject, body, mail_to,attachment=False,filename=False):
		email = self.pool.get("notificaciones.configuracion")
		dict_smtp = email.create_dict_smtp(cr, uid, ids, context=None)
		dict_smtp['subject'] = subject
		dict_smtp['body'] = body
		dict_smtp['mail_to']=mail_to
		dict_smtp['attachment']=attachment
		dict_smtp['filename']=filename
		send= email.send_email(cr, uid, **dict_smtp)	
    
    def recuperar_correo(self, cr, uid, ids, args, context=None):
        cedula = args[0]['cedula'] 
        xmlrpc = self.pool.get("notificaciones.configuracion")
        exp_user_obj = self.pool.get('wizard.export.user.django')
        xmlrpc_id = xmlrpc.search(cr, uid, [('activo','=',True)])
        sock = xmlrpc.connect(cr, uid, xmlrpc_id, context)
        brw_xml_rpc = xmlrpc.browse(cr, uid, xmlrpc_id[0])
        if not sock:
           raise osv.except_osv(_('ERROR!'), _('No se pudo establecer conexion'))  
        
        uid_rpc = sock[1]
        sock_connect = sock[0]
        emp_obj = self.search_employee(cr, uid, cedula)[0]
        if not emp_obj:
           raise osv.except_osv(_('ERROR!'), _('No existe un trabajador con la cedula %s'%cedula))
        exp_user_obj.create_user(cr, uid, ids,  emp_obj,  uid_rpc, sock_connect, brw_xml_rpc, overwrite=True)
        return True 
    
    def conv_datetime(self, date):
		pass 
    
    def get_payment_receipt(self,cr, uid, employee_id, date):
        payslip_obj = self.pool.get('hr.payslip')
        today_=datetime.strptime(date, '%m/%Y')
        date_receipt =datetime.now()
        sql = """
            select payslip.id, process.write_date 
            from hr_payslip as payslip
            inner join hr_process as process ON payslip.hr_process_id = process.id
            inner join hr_period as periodo on payslip.date_from = periodo.date_start and payslip.date_to = periodo.date_end
            inner join hr_month as mes on periodo.hr_month_id = mes.id
            inner join hr_year as _year on _year.id = mes.hr_year_id 
            where mes.month_year = %s
            and _year.year = %s
            and payslip.employee_id = %s
            and payslip.state = 'done'
            and process.type = 'nomina'
            order by date_from
            """ %(today_.month, today_.year, employee_id)
        
        cr.execute(sql)
        payslip_dicc = cr.dictfetchall()
        payslip_ids = [d['id'] for d in payslip_dicc if date_receipt > datetime.strptime(d['write_date'], '%Y-%m-%d %H:%M:%S.%f').replace(microsecond=0)+timedelta(hours=24)]
        return payslip_ids
    
    def send_email(self, cr, uid,  ip, port, mail_from, mail_to, subject, body, attachment=None, auth=False, filename=None):
        args = {'mail_from':mail_from,
                'mail_to':mail_to,
                'subject':subject,
                'body':body,
                'auth':auth,
                'attachment':attachment,
                'filename':filename}
        smtp = smtp_client_mail.sendmailThread(ip, port)
        smtp = smtp.smtp_sendmail(**args) 
        return smtp
    
    def send_sms(self, cr, uid, ids, args, context=None):
        report_prefix = {'receipt':'Recibo de pago', 'constancy':'Constancia'}
        xml_id = self.search(cr, uid, [('activo','=', True)])
        sock = self.connect(cr, uid, xml_id, context=context, channel_notify=False)
        if not sock:
           logger.notifyChannel('XML-RPC', netsvc.LOG_ERROR, 'Conexion rechazada')
           return False
        session=sock[1]
        rpc=sock[0]
        if not args:
           args = []
           novedades_obj = self.pool.get('notificaciones.libro.novedades') 
           novedades_ids = ids
           update_lines = []
           if not novedades_ids:
              novedades_ids = novedades_obj.search(cr, uid, [('state','in', ['send', 'print']) ])
           brw = novedades_obj.browse(cr, uid, novedades_ids)
           for i in brw:
               if i.state == 'send':
				  d = {'cedula':None,
						'telefono':None,
						'texto':None}
				  d['cedula'] = i.employee_id.identification_id
				  d['telefono'] = i.employee_id.mobile_phone
				  d['texto'] = 'Solicitud de %s fue enviada al correo'%report_prefix[i.type_request]
				  update_lines.append(i.id)
				  args.append(d)
       
        r = []
        try:
			r = rpc.notificar_procesado(session, args)
        except:  
			r = False 
        if r:
           self.update_notify(cr, uid, update_lines, {'state':'done'})
        return True 
        
    
    def create_dict_smtp(self, cr, uid, ids, context=None):
        config_obj = self.pool.get('notificaciones.configuracion')
        config_id = config_obj.search(cr, uid, [('activo','=',True)])
        config_brw = config_obj.browse(cr, uid, config_id)[0]
        ip = config_brw.server_smtp
        port = config_brw.port
        mail_from = config_brw.mail
        mail_passwd = config_brw.mail_passwd
        args = {'ip':ip,
                'port':port,
                'mail_from':mail_from,
                'auth':mail_passwd,
                'mail_to':None,
                'subject':None,
                'body':None,
                'attachment':None,
                'filename':None}
        return args
        
    
    def create_report(self, cr, uid, res_ids, report_name=False, file_name=False, data=False, context=None):
        try:
            ret_file_name = '/tmp/'+file_name+'.pdf'
            service = netsvc.LocalService("report."+report_name);
            (result, format) = service.create(cr, uid, res_ids, data, context)
            fp = open(ret_file_name, 'wb+');
            fp.write(result);
            fp.close();
        except Exception,e:
            print 'Exception in create report:',e
            return (False, str(e))
        return (True, ret_file_name)
    
    def update_notify(self, cr, uid, ids, args, context=None):
        novedad_obj = self.pool.get('notificaciones.libro.novedades')
        novedad_write = novedad_obj.write(cr, uid, ids, args)
        return novedad_write
        
        
    def hashrandom(self, key=''):
        import random
        from hashlib import sha256
        from hashlib import md5
        import hmac
        import uuid
        import time
        import os
        ram = str(random.getrandbits(128))
        hash = hmac.new(os.urandom(32), str(key)+ram+str(uuid.uuid4()), md5).hexdigest()
        return  hash

    def elimina_tildes(self, s):
        import unicodedata
        return ''.join((c for c in unicodedata.normalize('NFD', unicode(s)) if unicodedata.category(c) != 'Mn'))  

    def normalizar_string(self, unicode_string):
        from unicodedata import normalize
        #~ unicode_string=unicode(unicode_string, 'utf-8')
        unicode_string=unicode(unicode_string)
        return normalize('NFKD',unicode_string).encode('ASCII', 'ignore').lower()
    
    def generate_notification(self, cr, uid, ids, id=[], context=None):
        elimina_tildes = self.elimina_tildes
        normalizar_string = self.normalizar_string
        dict_smtp = self.create_dict_smtp(cr, uid, ids, context=None)
        report_request_object = {'receipt':'hoja.pago.bi', 'constancy':'hr.constancia.trabajo.bi'}
        report_prefix = {'receipt':'Recibo de pago', 'constancy':'Constancia'}
        payslip = self.get_payment_receipt
        dict_report = {}
        novedad_obj = self.pool.get('notificaciones.libro.novedades')
        employee_obj = self.pool.get('hr.employee')
        novedad_ids = id
        if not novedad_ids:
            novedad_ids = novedad_obj.search(cr, uid, [('state','in', ['received', 'print' ])])
        novedad_brw = novedad_obj.browse(cr, uid, novedad_ids)
        employee_ids = []
        if novedad_brw:
            employee_ids_constancy=[(i.employee_id, [i.employee_id.id], i.type_request, i.description, i.id) for i in novedad_brw if i.type_request== 'constancy']
            employee_ids_receipt=[(i.employee_id, payslip(cr, uid, i.employee_id.id, i.description), i.type_request, i.description, i.id) for i in novedad_brw if i.type_request== 'receipt' if payslip(cr, uid, i.employee_id.id, i.description)]
            employee_ids = employee_ids_constancy+employee_ids_receipt
        for i in employee_ids:
            dict_report[i[0]]={'type':{}, 'id':{}}
        for i in employee_ids:
            dict_report[i[0]]['id'][i[2]] = i[-1]
            dict_report[i[0]]['type'].update({i[2]:[]})
            dict_report[i[0]]['type'][i[2]] =  dict_report[i[0]]['type'][i[2]] + i[1]  
        for r in dict_report:
            for t in dict_report[r]['type']:
                code = self.hashrandom(key=t+datetime.now().strftime('%Y-%m-%d %H:%M:%S'))
                data = {'form':{'code':code, 'employee':r.name}}
                if dict_report[r]['type'][t]:
                    name_employee = normalizar_string(elimina_tildes(r.name))
                    file = self.create_report(cr, uid, dict_report[r]['type'][t], report_name=report_request_object[t], file_name=name_employee+'_'+t, data=data, context=context)
                    if file[0]:
                        args = {'state':'print', 'date_print':datetime.now().strftime('%Y-%m-%d %H:%M:%S'), 'code':code}
                        self.update_notify(cr, uid, dict_report[r]['id'][t], args)
                        dict_smtp['subject'] = 'Procesada solicitud de '+report_prefix[t]
                        dict_smtp['body'] = """Su solicitud de %s ya fue procesada"""%report_prefix[t]
                        dict_smtp['mail_to']=r.work_email
                        dict_smtp['attachment']=file[1]
                        dict_smtp['filename']=report_prefix[t].upper()+' '+name_employee+'.pdf'
                        send= self.send_email(cr, uid, **dict_smtp)
                        if send:
                           os.remove(file[1])
                           args = {'state':'send', 'date_send_mail':datetime.now().strftime('%Y-%m-%d %H:%M:%S'), 'code':code}
                           self.update_notify(cr, uid, dict_report[r]['id'][t], args)
        
        self.send_sms(cr, uid, novedad_ids, [], context=context)
        return True 

    def create(self, cr, uid, vals, context=None):
        if 'activo' in vals:
            if vals['activo']:
               raise osv.except_osv(_('ERROR!'), _('No pueden haber dos configuraciones activas'))
        return super(notificaciones_configuracion, self).create(cr, uid, vals)
    
    def unlink(self, cr, uid, ids, context=None):
        if isinstance(ids, list):
            ids = ids[0]
        brw = self.browse(cr, uid, ids)
        if brw.activo:
            raise osv.except_osv(_('ERROR!'), _('No se puede eliminar la configuracion si esta activo'))
        return super(notificaciones_configuracion, self).unlink(cr, uid, ids)


notificaciones_configuracion()


class notificaciones_historial_correo(osv.osv):
    _name = 'notificaciones.historial.correo'
    _description = 'Email Client History'
    _order = 'id desc'

    _columns = {
        'name' : fields.char('Descripcion',size=250, required=True, readonly=True),
        'message' : fields.text('Mensaje',required=True, readonly=True),
        'date_create': fields.datetime('Fecha de Creacion',readonly=True),
        'email_to':fields.char('Destinatario',size=64,readonly=True),
        'email_from':fields.char('Emisor',size=64,readonly=True),
        'attachment': fields.many2one('ir.attachment', 'Abjunto'),
        'process_id': fields.many2one('ir.cron', 'MTA Process', readonly=True),
        'state':fields.selection([
            ('draft','Borrador'),
            ('sending','Enviando'),
            ('send','Enviado'),
            ('error','Error'),
        ],'Estado', select=True, readonly=True),
    }
    
    _defaults = {
        'date_create': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
        'state': lambda *a: 'draft'
    }


class notificaciones_libro_novedades(osv.osv):
    _name = 'notificaciones.libro.novedades'
    _description = 'Libro de novedades'
    _order = 'id desc'

    _columns = {
        'employee_id': fields.many2one('hr.employee', 'Trabajador', readonly=True),
        'type_request':fields.selection([
            ('receipt','Recibido de pago'),
            ('constancy','Constancia'),
        ],'Tipo de solicitud', select=True, readonly=True),
        'date_received': fields.datetime('Fecha de Recibido',readonly=True),
        'date_print': fields.datetime('Fecha de Impresion',readonly=True),
        'date_send_mail': fields.datetime('Fecha de Envio',readonly=True),
        'description': fields.char("Descripcion", size=130, readonly=True, required=True), 
        'code': fields.char("Codigo de impresion", size=130, readonly=True), 
        'state':fields.selection([
            ('received','Recibido'),
            ('print','Impreso'),
            ('send','Enviado'),
            ('done','Listo'),
        ],'Estado', select=True, readonly=True),    }
    
    
    def generate_notification(self, cr, uid, ids, context=None):
        config = self.pool.get("notificaciones.configuracion")
        config.generate_notification(cr, uid, ids, id=ids, context=context)
        return True

    def copy(self, cr, uid, ids,default=None, context=None):
        pass 
    
    #~ def unlink(self, cr, uid, ids, context=None):
        #~ raise osv.except_osv(_('ERROR!'), _('No se pueden eliminar los registros'))

notificaciones_libro_novedades()    


