#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import time
from datetime import datetime
from datetime import  timedelta
import xmlrpclib
import tools
from tools.translate import _
import netsvc
logger = netsvc.Logger()
import logging
import smtp_client_mail
import calendar
import os
import string
import random

class notificaciones_configuracion(osv.osv):
    _inherit = "notificaciones.configuracion"

    def buscar_codigo_impresion(self, cr, uid, ids, args, context=None):
        report_prefix = {'receipt':'Recibo de pago', 'constancy':'Constancia'}
        res = {}
        novedades_obj = self.pool.get('notificaciones.libro.novedades')
        codigo = args[0]['codigo'] 
        novedades_ids = novedades_obj.search(cr, uid, [('code','=',codigo)])
        if not isinstance(novedades_ids, list):
           novedades_ids = [novedades_ids]
            
        if not novedades_ids:
            res = {'error':"No existen documentos asociado al codigo de impresion: '%s' "%codigo} 
            return res 
        
        brw = novedades_obj.browse(cr, uid, novedades_ids)[0]
        res = {'trabajador':brw.employee_id.name,
               'impresion': brw.date_print,
               'tipo':report_prefix[brw.type_request],
               'descripcion':brw.description,
               'error':""}
        return res 

    def id_generator(size=6, chars=string.digits):
		return ''.join(random.choice(chars) for _ in range(size))
	
    def validar_correo(self, cr, uid, ids, args, context=None):
		correo = args[0]['correo'] 
		cod_validador = self.id_generator()
		msg = "Codigo de validacion %s" %cod_validador
		subject = "Codigo de validacion"
		self.send_email_user(cr, uid, ids, subject, msg, correo, attachment=None,filename=None)
		return cod_validador
    
    def actualizar_correo(self, cr, uid, ids, args, context=None):
        employee_obj = self.pool.get('hr.employee')
        correo = args[0]['correo']
        cedula = args[0]['cedula']
        emp_brw = self.search_employee(cr, uid, cedula)
        if emp_brw:
            if isinstance(emp_brw, list):
               emp_brw = emp_brw[0]
        employee_id = employee_obj.write(cr, uid, emp_brw.id, {'work_email':correo})
        return True     
	
    def peticion_gammu(self,cr, uid, ids, args, context=None):
        for p in args:
            p.update({'inicio_relacion_laboral':None})
            employee_brw = self.search_employee(cr, uid, p['cedula'])
            if employee_brw:
               dict_novedades = {'employee_id': employee_brw[0].id,
               'type_request':p['tipo'],
               'description':p['descripcion'],
               'date_received': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
               'state':'received'}
               self.create_notify(cr, uid, dict_novedades)
               p['valido'] = True
               p['telefono_trabajador'] = employee_brw[0].mobile_phone
               p['inicio_relacion_laboral']=employee_brw[0].start_rel_lab
            else:
                p['valido'] = False
        return  args  
        
         
    
notificaciones_configuracion()
    
	 
		
		
