#!/usr/bin/python

import smtplib
from email.MIMEText import MIMEText
from email.MIMEBase import MIMEBase
from email.MIMEMultipart import MIMEMultipart
from email.Header import Header
from email.Utils import formatdate, COMMASPACE
from email import Encoders    
import threading
import logging
from datetime import datetime
import netsvc
logger = netsvc.Logger()


class sendmailThread():
    #~ def __init__(self, ip, port, args):
    def __init__(self, ip, port):
        self.ip = ip
        self.port = port 
        #~ self.args = args
        self.bandera = False
    
    def run(self):
        dict_mail = self.args
        result = self.smtp_sendmail(self.ip, self.port, **dict_mail)
        return result
    
    def connect(self, mail_from, auth):
        try:
            s = smtplib.SMTP(self.ip, self.port)
            s.debuglevel = 0
            s.starttls()
            if auth:
               s.login(mail_from, auth)
        except Exception, e:
            return [e, False]
        
        return [s, True]    
            
        
    def smtp_sendmail(self, mail_from, mail_to, subject, body, attachment=None, auth=False, filename=None):
            self.bandera = True 
            if not mail_to:
			   self.bandera = False 
				
            try:
                sock = self.connect(mail_from, auth)
                s = sock[0]
                
                if not sock[1]:
                   self.bandera = False 
                   logger.notifyChannel('smtp', netsvc.LOG_ERROR, "NO se pudo establecer conexion %s"%sock[0])
                   return False 
                     
                outer = MIMEMultipart()
                outer['Subject'] = subject
                outer['To'] = mail_to
                outer['From'] = "noreply"
                outer.preamble = 'You will not see this in a MIME-aware mail reader.\n'
                msg = MIMEText(body or '',  _charset = 'utf-8')
                if not attachment:
                    
                    msg['Subject'] = Header(subject.decode('utf8'), 'utf-8')
                    msg['From'] = "noreply" 
                    s.sendmail(mail_from, mail_to, msg.as_string())
                else:
                    attachment = open(attachment, 'rb')
                    msg = MIMEBase('application', "octet-stream")
                    msg.set_payload(attachment.read())
                    attachment.close()
                    Encoders.encode_base64(msg)
                    msg.add_header('Content-Disposition', 'attachment; filename="%s"'%filename)
                    outer.attach(msg)
                    outer.attach(MIMEText(body))

                    composed = outer.as_string()
                    s.sendmail(mail_from, mail_to, composed)
                s.close()
            
            except Exception, e:
                self.bandera = False
                
            
            if self.bandera:
               logger.notifyChannel('smtp', netsvc.LOG_INFO, "CORREO ENVIADO A %s EL %s"%(mail_to, datetime.now().strftime('%y-%m-%d %H:%M:%S') ))    
            
            if not self.bandera:
               logger.notifyChannel('smtp', netsvc.LOG_ERROR, str(e))
            
            return self.bandera 

def init(ip, port, args):
    server = sendmailThread(ip, port)
    server_runner = server.smtp_sendmail(**args)
    return server_runner
    

