#-*- coding:utf-8 -*-
from report import report_sxw
from report.report_sxw import rml_parse
from operator import itemgetter
import time
from datetime import datetime
import random
from numero_a_texto import Numero_a_Texto
import netsvc
import time
from tools.translate import _
from osv import fields, osv
import datetime
from datetime import date
import locale
import re

class hr_constancia_trabajo(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(hr_constancia_trabajo, self).__init__(cr, uid, name, context)
        
        self.localcontext.update({
            'gerente_th':self.gerente_th,
            'get_empresa':self.get_empresa,
            'obt_texto':self.obt_texto,
            'salary':self.salary,
            'nacionalidad':self.nacionalidad,
            'cedula':self.cedula,
            'salary_dia_me':self.salary_dia_me,
            'get_name_departament':self.get_name_departament,
            'get_date_end': self.get_date_end,
            'generate_qrcode': self.generate_qrcode,
            'get_hashkey': self.get_hashkey,
            'crear_notificacion': self.crear_notificacion,
            'get_genero': self.get_genero,
            'get_url_web': self.get_url_web,
            'remuneracion': self.remuneracion,

        })
        self.context = context
        self.code = None 
        self.date_print = datetime.datetime.now().strftime('%d/%m/%Y %H:%M:%S')
        
    def remove_http(self, url):
        url_match = re.findall("https?://", url)
        if url_match:
           url = url.replace(url_match[0], '')
        return url 
    
    def get_url_web(self, url):
        if not url:
            url = ""
        xmlrpc = self.pool.get("notificaciones.configuracion")
        xmlrpc_id = xmlrpc.search(self.cr, self.uid, [('activo','=',True)])
        brw_xml_rpc = xmlrpc.browse(self.cr, self.uid, xmlrpc_id[0])
        url2 = str(brw_xml_rpc.web_address)
        url = self.remove_http(url)
        url2 = self.remove_http(url2)
        url = url+'/'+url2
        return url

    def get_genero(self, genero):
        res = {'female': 'la ciudadana', 'male': 'el ciudadano'}
        return res[genero]
        
    def get_hashkey(self):
        return self.code
              
    def get_name_departament(self, employee):
        departamento = employee.department_id.complete_name.split('/')
        val = ' / '.join([departamento[i].strip() for i in range(1,len(departamento))])

        return val
    
    def qr_validar_consulta(self, code, url, parametro):
        url = self.get_url_web(url)
        l = [url,parametro,code]
        strig_validar ='/'.join([i for i in l if len(i) > 0 ])
        strig_validar = "http://"+strig_validar
        return strig_validar
        

    def generate_qrcode(self, data, partner, employee, time, url=''):
        self.date_print = time
        utilidades_obj = self.pool.get('utilidades.sisb')
        data = data.get('form', {})
        self.code = data.get('code', False) or utilidades_obj.hashrandom()
        employee = data.get('employee', None) or employee 
        code = self.code 
        from datetime import datetime
        qr_encode = None
        if code:
            strig_validar = "%s, %s, %s, SISB, %s"%(partner.name, employee, code, self.date_print)
            strig_validar = strig_validar + ', '+self.qr_validar_consulta(code, url, 'validar_solicitud')
            qr_encode = utilidades_obj.create_qrcode(strig_validar, version=1, correction='L')
        return qr_encode  
        
    def crear_notificacion(self, emp):
        values =  {'employee_id':emp,
                   'date_print': self.date_print ,
                   'code':self.code, 
                   'type_request':'constancy',
                   'description':'basica',
                   'state':'done'}
        self.pool.get('notificaciones.libro.novedades').create(self.cr, self.uid, values) 
        
    def gerente_th(self):
        #Busqueda del concepto que se definio como Gerencte de Talento Humano
        param_gerente_id = self.pool.get('hr.parameters').search(self.cr, self.uid, [('type', '=', 'gerente_th')])
        if not param_gerente_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para Gerente de Talento Humano. Ir a \
                            la pestana Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                            registrar un parametro de tipo Gerente de Talento Humano'))

        gerente_brw = self.pool.get('hr.parameters').browse(self.cr, self.uid, param_gerente_id)[0]
        return gerente_brw
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'web':row.partner_id.website,
            'country':row.country_id.name,
            } 
        return res
        
        
    def salary(self, employee):
        if employee.type_employee == 'obrero':
            return 'Diario'
        else:
            return 'Mensual'
            
            
    def salary_dia_me(self, employee):
        if employee.type_employee == 'obrero':
            return 'Salario'
        else:
            return 'Sueldo'
        
    def nacionalidad(self, employee):
        if employee.country_id.code == 'VE':
            return 'V-'
        else:
            return 'E-'
            
    def cedula(self, employee):
        ced = employee.identification_id
        algo = '{:,}'.format(int(ced))
        return algo.replace(',','.')
        

    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))

    def get_date_end(self, employee):
        contracts = sorted(employee.contract_ids, key=lambda x: x.date_start)
        for val in contracts:
            date_end =val.date_end if employee.state == 'egresado' else ''
        return date_end
        
    def remuneracion(self, employee_id):
        monto = 0.0
        payslip = self.pool.get('hr.payslip')
        payslip_line = self.pool.get('hr.payslip.line')
        payslip_id = payslip.search(self.cr, self.uid, [('employee_id', '=', employee_id), ('type_process', '=', 'nomina'), ('state', '=', 'done')], limit=1)
        if payslip_id:
            payslip_line_id= payslip_line.search(self.cr, self.uid, [('slip_id', '=', payslip_id), ('code', '=', 'SD')] )
            if not payslip_line_id:
                payslip_id= payslip.search(self.cr, self.uid, [('employee_id', '=', employee_id), ('type_process', '=', 'nomina'), ('state', '=', 'done'), ('line_ids.code','=','SD')], limit=1)
                payslip_line_id= payslip_line.search(self.cr, self.uid, [('slip_id', '=', payslip_id), ('code', '=', 'SD')] )
            payslip_line_brw = payslip_line.browse(self.cr, self.uid, payslip_line_id[0])
         
            monto = payslip_line_brw.amount*30
        return monto
        
        
     

       

report_sxw.report_sxw(
        'report.hr.constancia.trabajo.bi',
        'hr.employee',
        'sisb_nomina/report/hr_constancia_trabajo.rml',
        parser=hr_constancia_trabajo, header=False
)
