#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import calendar
from datetime import datetime 
import unicodedata
import random
from tools.translate import _



class wizard_export_user_django(osv.osv_memory):
    _name = 'wizard.export.user.django'
    _description = 'Wizard para exportar trabajadores a Django como usuarios'
    _columns = {
    'users_ids':fields.many2many('hr.employee', 'hr_employee_notificaciones_rel', 
    'user_id', 'notificacion_id', 'Trabajadores',),
    'all_users': fields.boolean('Todos los Trabajadores'),
    'overwrite': fields.boolean('Sobreescribir Trabajador'),
    
    }
    _defaults ={
    'all_users':True,
    }
    
    def elimina_tildes(self, s):
        import unicodedata
        return ''.join((c for c in unicodedata.normalize('NFD', unicode(s)) if unicodedata.category(c) != 'Mn'))  

    def normalizar_string(self, unicode_string):
        from unicodedata import normalize
        #~ unicode_string=unicode(unicode_string, 'utf-8')
        unicode_string=unicode(unicode_string)
        return normalize('NFKD',unicode_string).encode('ASCII', 'ignore').lower()
        
    def GenPasswd(self, n):
        import string
        from random import choice
        return ''.join([choice(string.letters + string.digits) for i in range(n)])
		
    def create_user(self, cr, uid, ids, obj_partner,  uid_rpc, sock_connect, obj_xmlrpc, overwrite=False):
        email_obj = self.pool.get("notificaciones.configuracion")
        create_password =sock_connect.create_password
        elimina_tildes = self.elimina_tildes
        normalizar_string = self.normalizar_string
        username  = obj_partner.identification_id
        first_name = normalizar_string(elimina_tildes(obj_partner.first_name)).upper()
        lastname = normalizar_string(elimina_tildes(obj_partner.first_surname)).upper()
        email = obj_partner.work_email or ''
        is_active = False
        password =  self.GenPasswd(6)
        date = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
        name = normalizar_string(elimina_tildes(obj_partner.name)).upper()
        cedula = obj_partner.identification_id
        direccion = normalizar_string(elimina_tildes(obj_partner.home_address)).upper()
        codigo_u = obj_partner.cod_number 
        telefono = obj_partner.mobile_phone  
        genero = obj_partner.gender  
        fecha_nacimiento = obj_partner.birthday  
        nacionalidad = obj_partner.country_id.code  
        
        if not email:
            raise osv.except_osv(_('ERROR!'), _('El trabajador(a) %s no posee una direccion de correo'%obj_partner.name)) 	

        args = {'username':username, 'first_name':first_name, 
                'last_name':lastname, 'email':email, 
                'password':create_password(password), 'is_staff':False,
                'is_active':is_active, 'is_superuser':False, 
                'last_login':date, 'date_joined':date}
        
        ivss_args = {'nombre':name, 'cedula':cedula, 
                    'direccion':direccion, 'codigo_u':codigo_u, 
                    'telefono':telefono, 'email':email,
                    'genero':genero, 'fecha_nacimiento':fecha_nacimiento, 
                    'nacionalidad':nacionalidad}
        
        id_rpc = sock_connect.search(uid_rpc, 'auth_user', [('&','username', '=', username)])
        id_rpc_ivss = sock_connect.search(uid_rpc, 'constancia_app_usuario', [('&','cedula', '=', cedula)])
        sock_id = False
        if not id_rpc:
           sock_id = sock_connect.create(uid_rpc, 'auth_user', args)
           subject = "Creacion de usuario %s"%obj_xmlrpc.name
           msg = """ Bienvenido %s %s a nuestro sistema de solicitud,\n
                     su usuario se ha creado satisfactoriamente, para \n
                     ingresar y solicitar sus constancias y recibos 
                     debe ingresar a la siguiente direccion %s y\n 
                     colocar los datos que se describen a continuacion\n 
                     usuario: %s contrasena: %s \n
                     una vez que usted ingrese al sistema podra cambiar 
                     la contrasena,  saludos cordiales\n 
                     INDUSTRIAS DIANA - OFICINA DE TALENTO HUMANO"""%(first_name, lastname, obj_xmlrpc.web_address,  username, password)
          
        else:
            if overwrite:
				sock_id = sock_connect.write(uid_rpc, id_rpc, 'auth_user', args)
				subject = "Actualizacion de usuario %s"%obj_xmlrpc.name
				msg = """
					  Se ha actualizado su clave 
					  correctamente ingresa al %s y\n 
					  colocar los datos que se 
					  describen a continuacion\n 
					  usuario: %s contrasena: %s \n
					  y cambia su clave
					  """%(obj_xmlrpc.web_address, username, password)

        if not id_rpc_ivss:
           sock_ivss_id = sock_connect.create(uid_rpc, 'constancia_app_usuario', ivss_args)
        
        if sock_id:
           email_obj.send_email_user(cr, uid, ids, subject, msg, email, attachment=None,filename=None)

        return True 
   
    def export_user_django(self, cr, uid, ids, context=None):
        user_obj = self.pool.get('hr.employee')
        idsw = context['active_ids']
        user_brw = user_obj.browse(cr, uid, idsw)
        xmlrpc = self.pool.get("notificaciones.configuracion")
        xmlrpc_id = xmlrpc.search(cr, uid, [('activo','=',True)])
        brw_xml_rpc = xmlrpc.browse(cr, uid, xmlrpc_id[0])
        sock = xmlrpc.connect(cr, uid, xmlrpc_id, context)
        uid_rpc = sock[1]
        sock_connect = sock[0]
        brw = self.browse(cr, uid, ids[0]) 
        employes_brw = brw.users_ids
        if brw.all_users:
           emp_ids = user_obj.search(cr, uid, [])
           employes_brw = user_obj.browse(cr, uid, emp_ids)
           employes_brw = [i for i in employes_brw if i.work_email]
        for emp in employes_brw:
            self.create_user(cr, uid, ids, emp,  uid_rpc, sock_connect, brw_xml_rpc, overwrite=brw.overwrite)
        return {
            'type': 'ir.actions.act_window_close'
             }    
   

wizard_export_user_django()
