#!/usr/bin/env python
# -*- coding: utf-8 -*-
from osv import fields, osv


class hr_process(osv.osv):
    _inherit = 'hr.process'

    def permit_state(self, cr, uid, ids, state, context=None):
        vc_ids = self.pool.get('hr.variable.concepts').search(cr, uid, [('hr_process_id', 'in', ids), ('tipo_de_proceso', '=', 'permisos')], context=context)
        if vc_ids:
            _sp_obj = self.pool.get('sisb.permits')
            permit_ids = _sp_obj.search(cr, uid, [('variable_concept_id', 'in', vc_ids)], context=context)
            _sp_obj.write(cr, uid, permit_ids, {'state': state}, context=context)
        return True

    def aprobar_proceso(self, cr, uid, ids, context=None):
        self.permit_state(cr, uid, ids, 'done', context=context)
        return super(hr_process, self).aprobar_proceso(cr, uid, ids, context=context)

    def devolver_proceso(self, cr, uid, ids, context=None):
        self.permit_state(cr, uid, ids, 'load', context=context)
        return super(hr_process, self).devolver_proceso(cr, uid, ids, context=context)


hr_process()
