#!/usr/bin/python
# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

class report_z_parser(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_z_parser, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            #~ 'get_lines': self.get_lines,
            'get_maquinas': self.get_maquinas,
            'get_lines_detal': self.get_lines_detal,
        })
        print context

        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d %H:%M:%S')
        return str(new.strftime('%d-%m-%Y'))
    
    
    def get_maquinas(self, data):
        result_maquina = []
        print data
        ids = data['ids']
        ids_sql = str(ids).replace("[","(").replace("]",")")
        report_z = self.pool.get('sisb.report.z')
        repo_brw = report_z.browse(self.cr, self.uid, ids)
        sql_maquinas = """
        SELECT mf.name as name
        FROM sisb_report_z srz
        INNER JOIN maquina_fiscal mf ON mf.id = srz.maquina_fiscal_id
        WHERE srz.id in %s
        GROUP BY mf.name, mf.direccion_asoc_id
        """%(ids_sql)
        self.cr.execute(sql_maquinas)
        result_maquina = self.cr.dictfetchall()
        print result_maquina
        list_fin = []
        for detal in result_maquina:
            dict_detal = {}
            dict_detal[detal['name']] = {}
            inv = self.get_lines_detal(detal,'inv')
            if inv:
                dict_detal[detal['name']]['inv'] = inv
            cr = self.get_lines_detal(detal,'cr')
            if cr:
                dict_detal[detal['name']]['cr'] = cr
            list_fin.append(dict_detal)
        print list_fin
        #~ for l in list_fin:
            #~ print "l******",l
            #~ print "key******",l.keys()[0]
            #~ print "inv******",l[l.keys()[0]]['inv']
            #~ print "cr******",l[l.keys()[0]]['cr']
        return list_fin
        return result_maquina
    
    
    def get_lines_detal(self, maquina, tipo):
        print "-----------------------------"
        result = []
        sql_detalle = """
        SELECT atax.name AS tipo_impuesto,
            SUM(srzt.amount_untaxed) AS base,
            SUM(srzt.amount_tax) AS impuesto,
            SUM(srzt.amount_bi_tax) AS total
        FROM sisb_report_z_tax AS srzt
        INNER JOIN sisb_report_z srz ON srzt.report_z_id = srz.id
        INNER JOIN maquina_fiscal mf ON mf.id = srz.maquina_fiscal_id
        INNER JOIN account_tax atax ON atax.id = srzt.name
        WHERE mf.name = '%s' AND srzt.type = '%s'
        GROUP BY atax.name
        """%(maquina['name'],tipo)
        
        self.cr.execute(sql_detalle)
        result = self.cr.dictfetchall()
        print result
        return result
        
    
    
    #~ def get_lines(self, data):
        #~ result = []
        #~ ids = data['ids']
        #~ ids_sql = str(ids).replace("[","(").replace("]",")")
        #~ report_z = self.pool.get('sisb.report.z')
        #~ repo_brw = report_z.browse(self.cr, self.uid, ids)
        #~ sql_maquinas = """
        #~ SELECT mf.name
        #~ FROM sisb_report_z srz
        #~ INNER JOIN maquina_fiscal mf ON mf.id = srz.maquina_fiscal_id
        #~ WHERE srz.id in (1, 2, 13, 4)
        #~ GROUP BY mf.name
        #~ """
        #~ self.cr.execute(sql_maquinas)
        #~ result_maquina = self.cr.fetchall()
        #~ print result_maquina
        #~ 
        #~ sql_total = """SELECT *
        #~ FROM (--INVOICE
            #~ SELECT mf.name AS reporte_z,
                #~ mf.direccion_asoc_id AS direccion,
                #~ atax.name AS tipo_impuesto,
                #~ srzt.type AS tipo,
                #~ SUM(srzt.amount_untaxed) AS base,
                #~ SUM(srzt.amount_tax) AS impuesto,
                #~ SUM(srzt.amount_bi_tax) AS total
            #~ FROM sisb_report_z_tax AS srzt
            #~ INNER JOIN sisb_report_z srz ON srzt.report_z_id = srz.id
            #~ INNER JOIN maquina_fiscal mf ON mf.id = srz.maquina_fiscal_id
            #~ INNER JOIN account_tax atax ON atax.id = srzt.name
            #~ WHERE srzt.report_z_id in %s AND srzt.type = 'inv'
            #~ GROUP BY mf.direccion_asoc_id, mf.name, atax.name, srzt.type
            #~ UNION ALL
            #~ --CREDIT
            #~ SELECT mf.name AS reporte_z,
                #~ mf.direccion_asoc_id AS direccion,
                #~ atax.name AS tipo_impuesto,
                #~ srzt.type AS tipo,
                #~ SUM(srzt.amount_untaxed) AS base,
                #~ SUM(srzt.amount_tax) AS impuesto,
                #~ SUM(srzt.amount_bi_tax) AS total
            #~ FROM sisb_report_z_tax AS srzt
            #~ INNER JOIN sisb_report_z srz ON srzt.report_z_id = srz.id
            #~ INNER JOIN maquina_fiscal mf ON mf.id = srz.maquina_fiscal_id
            #~ INNER JOIN account_tax atax ON atax.id = srzt.name
            #~ WHERE srzt.report_z_id in %s AND srzt.type = 'cr'
            #~ GROUP BY mf.direccion_asoc_id, mf.name, atax.name, srzt.type
            #~ ) AS union_total
        #~ ORDER BY union_total.direccion, union_total.reporte_z, union_total.tipo desc;
        #~ """%(ids_sql,ids_sql)
        #~ 
        #~ self.cr.execute(sql_total)
        #~ resultat = self.cr.dictfetchall()
        #~ print resultat
        #~ result = {}
        #~ for res in resultat:
            #~ detalle = {}
            #~ detalle = {
                #~ 'tipo_impuesto': res['tipo_impuesto'],
                #~ 'tipo': res['tipo'],
                #~ 'direccion': res['direccion'],
                #~ 'base': res['base'],
                #~ 'impuesto': res['impuesto'],
                #~ 'total': res['total']
            #~ }
            #~ if result.get(res['reporte_z'], False):
                #~ result
            #~ else:
                #~ 
        
        #~ return []
       
report_sxw.report_sxw('report.sisb.report.list.month',
    'sisb.report.z',
    'sisb_reporte_z/report/list_month.rml',
    parser=report_z_parser)
