# -*- encoding: utf-8 -*-
###############Credits#########################################################	
#    Finance by: Industrias Diana, C.A. http://www.industriasdiana.gob.ve	
###############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################
from osv import osv, fields
import decimal_precision as dp
import netsvc
import pooler

class wizard_close_and_report_z(osv.osv_memory):
    _name = "wizard.close.and.report.z"
    _description = "Wizard Close and Report Z"
    
    _columns = {
       'period_id': fields.many2one('account.period', 'Period', required=True),
    }
    
    _defaults = {
        'period_id': lambda self, cr, uid, c: self.pool.get('account.period').find(cr, uid)[0],
    }
    
    
    def print_report_z(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        
        sisb_report_z = self.pool.get('sisb.report.z')
        
        data = {}
        close_z_brw = self.browse(cr, uid, ids[0])
        data['ids'] = sisb_report_z.search(cr, uid, [('date_report','>=',close_z_brw.period_id.date_start),('date_report','<=',close_z_brw.period_id.date_stop)], order='date_report')
        if data['ids']:
            data['form'] = {}
            data['form']['ids'] = data['ids']
            data['form']['period'] = close_z_brw.period_id.name
            return {'type': 'ir.actions.report.xml', 'report_name': 'sisb.report.list.month', 'datas': data}
        else:
            return {'warning': {'message': 'No existen Reportes Z para genetar el reporte'}}
            raise osv.except_osv(_('Error !'),('No existen Reportes Z para genetar el reporte'))
        #~ return True
    
    
    def close_report_z(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        
        sisb_report_z = self.pool.get('sisb.report.z')
        
        close_z_brw = self.browse(cr, uid, ids[0])
        report_z_srch = sisb_report_z.search(cr, uid, [('date_report','>=',close_z_brw.period_id.date_start),('date_report','<=',close_z_brw.period_id.date_stop),('state','=','draft')])
        sisb_report_z.write(cr, uid, report_z_srch, {'state': 'done'})
        
        return {'type': 'ir.actions.act_window_close'}

wizard_close_and_report_z()
