# -*- coding: utf-8 -*-


import time
from report import report_sxw
import datetime
from datetime import datetime


class analisis_cuenta_cobrar_report(report_sxw.rml_parse):
    
    _name = 'analisis.cuenta.cobrar.report'
    
    def __init__(self, cr, uid, name, context=None):
        super(analisis_cuenta_cobrar_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
        'generate_query':self.generate_query,
        'cuenta_detalle':self.cuenta_detalle,
        'get_empresa':self.get_empresa,
        'get_fecha':self.get_fecha,
        'titulos_rml':self.titulos_rml,
        'sumar':self.sumar,
        })
        self.context = context
        self.cr = cr
        self.uid = uid
        self.sub_total = 0.0
        self.impuesto = 0.0
        self.total = 0.0
        self.salida_query = []
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def generate_query(self, value):
        value = value['form']
        is_periodo = value['is_periodo']
        period = value['period_id']
        fecha_desde = value['fecha_desde']
        fecha_hasta = value['fecha_hasta']
        account = value['account_id']
        all_account = value['all_account']
        partner = value['partner_id']
        all_partner = value['all_partner']
        formato = value['formato']
        existencias_cuenta = []
        funciones_query_existencia = {'detail': self.get_existencia_cuenta,
                           'general':self.get_existencia_empresa}
        existencias_cuenta = funciones_query_existencia[formato](is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner)
        self.cuenta = existencias_cuenta
        funciones_query = {'detail': self.detallado_cuenta_por_cobrar,
                           'general':self.resumen_cuenta_por_cobrar}
        salida = funciones_query[formato](is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner)
        return [salida]

    def filter_inicial_sql(self, sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner):
        if not all_account:
            sql = sql + '\nAND  aml.account_id = %s'%account
        if not all_partner:
            sql = sql + '\nAND  aml.partner_id = %s'%partner
        if is_periodo:
            sql = sql + '\nAND aml.date :: date < (SELECT date_start FROM account_period WHERE id = %s)'%period
        else:
            sql = sql + "\nAND aml.date :: date < '%s' "%fecha_desde
        return sql 
   
    def filter_resumido_detallado_sql(self, sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner):
        if not all_account:
            sql = sql + '\nAND  aml.account_id = %s'%account
        if not all_partner:
            sql = sql + '\nAND  aml.partner_id = %s'%partner
        if is_periodo:
           sql = sql + """\nand aml.date :: date >= (SELECT date_start FROM account_period WHERE id = %s) 
                            \nand aml.date :: date <= (SELECT date_stop FROM account_period WHERE id = %s)"""%(period,period)
        else:
            sql = sql + "\n AND aml.date :: date >= '%s' and aml.date :: date <= '%s'" %(fecha_desde, fecha_hasta)
        return sql 
        
    def cuenta_detalle(self, k, l=None):
        if l is not None:
            cuenta_detail = self.cuenta[k][l]
        else:
            cuenta_detail = self.cuenta[k]
            lista =  cuenta_detail.keys()
            l = lista[0]
            cuenta_detail = self.cuenta[k][l]
        return cuenta_detail

    def get_existencia_cuenta(self, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner):
        sql = """
        SELECT aml.partner_id, aa.id, aa.code as cta_debit, SUM(aml.debit) as debit,  aa.code as cta_credit, 
        SUM(aml.credit) as credit, aa.name, rp.name 
        FROM account_move_line aml
        INNER JOIN account_account as aa ON  aa.id = aml.account_id
        INNER JOIN account_account_type as aa_type ON aa.user_type = aa_type.id
        LEFT JOIN res_partner as rp ON aml.partner_id = rp.id
        WHERE aml.credit is not null AND aml.debit is not null 
        and aa.type = 'receivable'"""
        sql = self.filter_inicial_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner) 
        sql = sql + """\n group by aml.partner_id, aa.id, aa.code, aa.name, rp.name 
                        \n ORDER BY  aml.partner_id """
        salida = self.execute_sql(sql)
        agrupar = {}
        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            agrupar[partner] = {}
        
        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            saldo = i[3] - i[5]
            agrupar[partner][i[1]] = {'debito':i[3], 'credito':i[5], 'existencia': saldo ,
             'cuenta':i[6], 'empresa':i[7], 'saldo_debito': 0.0, 'saldo_credito': 0.0, 'saldo':saldo}
        return agrupar
        
    def get_existencia_empresa(self, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner):
        sql = """
        SELECT  aa.id, aml.partner_id, aa.code as cta_debit, SUM(aml.debit) as debit,  aa.code as cta_credit, 
        SUM(aml.credit) as credit, (aa.code || ' ' ||aa.name) as name, rp.name 
        FROM account_move_line aml
        INNER JOIN account_account as aa ON  aa.id = aml.account_id
        INNER JOIN account_account_type as aa_type ON aa.user_type = aa_type.id
        LEFT JOIN res_partner as rp ON aml.partner_id = rp.id
        WHERE aml.credit is not null AND aml.debit is not null 
        and aa.type = 'receivable'"""
        sql = self.filter_inicial_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner) 
        sql = sql + """\n group by  aa.id, aml.partner_id, aa.code, aa.name, rp.name  
                        \n order by aa.id, aml.partner_id"""
        salida = self.execute_sql(sql)
        
        sql = """
        SELECT  aa.id, aa.code as cta_debit, SUM(aml.debit) as debit,  aa.code as cta_credit, 
        SUM(aml.credit) as credit 
        FROM account_move_line aml
        INNER JOIN account_account as aa ON  aa.id = aml.account_id
        INNER JOIN account_account_type as aa_type ON aa.user_type = aa_type.id
        WHERE aml.credit is not null AND aml.debit is not null 
        and aa.type = 'receivable'"""
        sql = self.filter_inicial_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner)
        sql = sql + """\n group by  aa.id, aa.code                  
                        \n order by aa.id"""
        salida2 = self.execute_sql(sql)
        
        agrupar = {}
        for i in salida:
            agrupar[i[0]] = {}

        for i in salida:
            saldo = i[3] - i[5]
            if i[1] == None:
                partner = "Vacio"
            else:
                partner = i[1]
            agrupar[i[0]][partner] = {'debito':i[3], 'credito':i[5], 'existencia': saldo,
             'cuenta':i[6], 'saldo_debito': 0.0, 'saldo_credito': 0.0, 'saldo':saldo, 'empresa': i[7]}

        for i in salida2:
            if i[0] in agrupar:
                for j in agrupar[i[0]]:
                    agrupar[i[0]][j].update({'debito_cuenta':i[2], 'credito_cuenta':i[4], 'existencia_cuenta':i[2]-i[4]})
        return agrupar
             
    def detallado_cuenta_por_cobrar(self, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner):
        sql = """
        SELECT aml.partner_id, am.name, aml.ref, aml.date, aml.name, aj.name, aa.code as cta_debit, 
        SUM(aml.debit) as debit, aa.code as cta_credit, SUM(aml.credit) as credit, aa.id, aa.name, rp.name 
        FROM account_move_line aml
        INNER JOIN account_move as am ON aml.move_id = am.id
        INNER JOIN account_account as aa ON  aa.id = aml.account_id
        INNER JOIN account_account_type as aa_type ON aa.user_type = aa_type.id
        INNER JOIN account_journal as aj ON aml.journal_id = aj.id 
        LEFT JOIN res_partner as rp ON aml.partner_id = rp.id
        WHERE aml.credit is not null AND aml.debit is not null 
        and aa.type = 'receivable'"""
        sql = self.filter_resumido_detallado_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner) 
        sql = sql + """
                    \n GROUP BY
                    \n aml.partner_id, am.name, aml.ref, aml.date, aml.name, aj.name, aa.code, aa.id, aa.name, rp.name
                    \n ORDER BY  aml.partner_id """
        salida = self.execute_sql(sql)
        agrupador = {}
        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            agrupador[partner] = {}
        
        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            agrupador[partner][i[10]] = []
           
        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            if partner in self.cuenta:
                if i[10] in self.cuenta[partner]:
                    saldo_debito = self.cuenta[partner][i[10]]['saldo_debito'] + i[7]
                    saldo_credito = self.cuenta[partner][i[10]]['saldo_credito'] + i[9]
                    saldo = self.cuenta[partner][i[10]]['saldo'] + i[7] - i[9]
                    agrupador[partner][i[10]].append({'empresa': i[12],'ref': i[2], 'asiento':i[1], 'fecha':i[3], 'nombre':i[4], 
                                            'diario': i[5], 'debito':i[7], 'credito':i[9], 'saldo':saldo})
                    self.cuenta[partner][i[10]]['saldo_debito'] = saldo_debito
                    self.cuenta[partner][i[10]]['saldo_credito'] = saldo_credito
                    self.cuenta[partner][i[10]]['saldo'] = saldo
                else:
                    self.cuenta[partner][i[10]]={'debito':i[7], 'credito':i[9], 'existencia': i[7]-i[9],
                                'cuenta':i[11], 'empresa':i[12], 'saldo_debito':i[7], 'saldo_credito': i[9], 
                                'saldo':i[7]-i[9]}
            else:
                self.cuenta[partner] = {}
                self.cuenta[partner][i[10]]={'debito':i[7], 'credito':i[9], 'existencia': i[7]-i[9],
                    'cuenta':i[11], 'empresa':i[12], 'saldo_debito':i[7], 'saldo_credito': i[9], 
                    'saldo':i[7]-i[9]}
        return agrupador
        
    def resumen_cuenta_por_cobrar(self, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner):
        sql = """        
        SELECT aml.partner_id, aa.id, aa.code as cta_debit, SUM(aml.debit) as debit,  aa.code as cta_credit, 
        SUM(aml.credit) as credit, aa.name, rp.name 
        FROM account_move_line aml
        INNER JOIN account_account as aa ON  aa.id = aml.account_id
        INNER JOIN account_account_type as aa_type ON aa.user_type = aa_type.id
        LEFT JOIN res_partner as rp ON aml.partner_id = rp.id
        WHERE aml.credit is not null AND aml.debit is not null 
        and aa.type = 'receivable'"""
        sql = self.filter_resumido_detallado_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, account, all_account, partner, all_partner) 
        sql = sql + """
                    \n GROUP BY
                    \n aml.partner_id, aa.id, aa.code, aa.name, rp.name
                    \n ORDER BY 
                    \n aa.id, aml.partner_id
                    """
        salida = self.execute_sql(sql)
        agrupador = {}
        for i in salida:
           agrupador[i[1]] = {}
           
        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            agrupador[i[1]][partner] = []

        for i in salida:
            if i[0] == None:
                partner = "Vacio"
            else:
                partner = i[0]
            #~ agrupador[i[1]][partner] = []
            if i[1] in self.cuenta:
                if partner in self.cuenta[i[1]]:
                    self.cuenta[i[1]][partner]['saldo_debito'] += i[3]
                    self.cuenta[i[1]][partner]['saldo_credito'] += i[5]
                    self.cuenta[i[1]][partner]['saldo'] += i[3] - i[5]
                    agrupador[i[1]][partner].append({'empresa': i[7], 'debito':i[3], 'credito':i[5], 'saldo': self.cuenta[i[1]][partner]['existencia'] + i[3] - i[5]})
                else:
                    self.cuenta[i[1]][partner]={'debito':i[3], 'credito':i[5], 'existencia': i[3]-i[5],
                            'cuenta':i[6], 'saldo_debito':i[3], 'saldo_credito': i[5], 'saldo':i[3]-i[5]}                  
                    agrupador[i[1]][partner].append({'empresa': i[7], 'debito':i[3], 'credito':i[5], 'saldo':i[3] - i[5]})
            else:
                i[1] = {}
                self.cuenta[i[1]][partner]={'debito':i[3], 'credito':i[5], 'existencia': i[3]-i[5],
                        'cuenta':i[6], 'saldo_debito':i[3], 'saldo_credito': i[5], 'saldo':i[3]-i[5]}               
                agrupador[i[1]][partner].append({'empresa': i[7], 'debito':i[3], 'credito':i[5], 'saldo':i[3] - i[5]})
                
        #~ Ingresa cuentas y clientes que no tiene movimientos en la fecha o periodo solicitado
        for i in self.cuenta:
            if i not in agrupador:
                agrupador[i] = {}
                for j in self.cuenta[i]:
                    agrupador[i][j] = []
                    agrupador[i][j].append({'empresa': self.cuenta[i][j]['empresa'], 'debito':0.00, 
                                            'credito':0.00, 'saldo':self.cuenta[i][j]['existencia']})
            else:
                for j in self.cuenta[i]:
                    if j not in agrupador[i]:
                        agrupador[i][j] = []
                        agrupador[i][j].append({'empresa': self.cuenta[i][j]['empresa'], 'debito':0.00, 
                                            'credito':0.00, 'saldo':self.cuenta[i][j]['existencia']})
        return agrupador

    def execute_sql(self, sql):
        self.cr.execute(sql)
        consulta = self.cr.fetchall()
        return consulta

    def cvr_fecha(self, f):
        d = datetime.strptime(f, '%Y-%m-%d').strftime('%d/%m/%Y')
        return d 
        
    def list_2_typle(self, list):
            list = [str(i) for i in list]    
            t = ()
            if len(list) == 1:
               t = "(%s)"%"".join(list)
            else:
                t = tuple(list)
            return t   
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        d = datetime.datetime.strptime(fecha, '%Y-%m-%d').strftime('%Y/%m/%d')
        return d 
    
    def titulos_rml(self, data):
        d = {'detail':'DETALLADO',
            'resume':'RESUMIDO',
            }
        return d[data['form']['formato']]

    def get_fecha(self, value):
        salida = ''
        if value['is_periodo']:
           salida = "Periodo: %s" %value['periodo_name']
        else:
            salida = 'Desde: %s Hasta: %s'%(self.cvr_fecha(value['fecha_desde']), self.cvr_fecha(value['fecha_hasta']))
        return salida
        
    def sumar(self, d):
        calculo = {'debito':0.00, 'credito':0.00, 'saldo':0.00}
        for i in d:
            for j in d[i]:
                calculo['debito'] += j['debito']
                calculo['credito'] += j['credito']
                calculo['saldo'] += j['saldo']
        return calculo
        

report_sxw = report_sxw.report_sxw    
class RMLParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False, header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
       
    
    
    def create_single_pdf(self, cursor, uid, ids, data, report_xml, context=None):
        """generate the PDF"""
        
        if context is None:
            context={}
        
        if report_xml.report_type == 'pdf':
            return super(RMLParser,self).create_single_pdf(cursor, uid, ids, data, report_xml, context=context)


RMLParser('report.analisis.cuenta.cobrar',
          'wizard.analisis.cuenta.cobrar', 
          'sisb_invoice_report/report/analisis_cuenta_cobrar_report.rml',
          parser=analisis_cuenta_cobrar_report)
