# -*- coding: utf-8 -*-


import time
from report import report_sxw
import datetime
from datetime import datetime


class analisis_inventario_valorado_report(report_sxw.rml_parse):
    
    _name = 'analisis.inventario.valorado.report'
    
    def __init__(self, cr, uid, name, context=None):
        super(analisis_inventario_valorado_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
        'generate_query':self.generate_query,
        'producto_detalle':self.producto_detalle,
        'get_empresa':self.get_empresa,
        'get_fecha':self.get_fecha,
        'titulos_rml':self.titulos_rml,
        'sumar':self.sumar,
        'get_totales':self.get_totales,
        })
        self.context = context
        self.cr = cr
        self.uid = uid
        self.sub_total = 0.0
        self.impuesto = 0.0
        self.total = 0.0
        self.salida_query = []
        self.totales = {}
        
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def generate_query(self, value):
        value = value['form']
        location = value['location_id']
        is_periodo = value['is_periodo']
        period = value['period_id']
        fecha_desde = value['fecha_desde']
        fecha_hasta = value['fecha_hasta']
        product = value['product_id']
        all_product = value['all_product']
        formato = 'detail'
        existencias_productos = self.get_existencia_ubicacion(location, is_periodo, period, fecha_desde, fecha_hasta, product, all_product)
        self.producto = existencias_productos
        salida = self.detallado_productos_valorado(location, is_periodo, period, fecha_desde, fecha_hasta, product, all_product, existencias_productos, formato)
        return [salida]
    
    
    
    def filter_sql(self, sql, is_periodo, period, fecha_desde, fecha_hasta, product, all_product):
        if not all_product:
            sql = sql + '\nAND  db_tbl.product_id = %s'%product
        if is_periodo:
            sql = sql + '\nAND db_tbl.date :: date <= (SELECT date_stop FROM account_period WHERE id < %s ORDER BY id desc LIMIT 1)'%period
        else:
            sql = sql + "\nAND db_tbl.date :: date < '%s' "%fecha_desde

        sql = sql + """\n group by db_tbl.product_id, db_tbl.default_code, db_tbl.name
                        \n order by db_tbl.name"""
        return sql 
   
    def filter_resumido_detallado_sql(self, sql, is_periodo, period, fecha_desde, fecha_hasta, product, all_product):
        if not all_product:
           sql = sql + '\nAND  db_tbl.product_id = %s'%product
        if is_periodo:
           sql = sql + """\nand db_tbl.date :: date >= (SELECT date_start FROM account_period WHERE id = %s) 
                            \nand db_tbl.date :: date <= (SELECT date_stop FROM account_period WHERE id = %s)"""%(period,period)
        else:
            sql = sql + "\n AND db_tbl.date :: date >= '%s' and db_tbl.date :: date <= '%s'" %(fecha_desde, fecha_hasta)
        return sql 
        
    def producto_detalle(self, k):
        producto_detail = self.producto[k]
        return producto_detail
    
    def get_existencia_ubicacion(self, location, is_periodo, period, fecha_desde, fecha_hasta, product, all_product):
        sql = """
        SELECT product_id, default_code, name, SUM(cant_convertida) as existencia_inicial from (
        SELECT
        min(m.id) AS id, m.date,
        m.location_id,
        m.product_id,
        pp.default_code,
        pt.name,
        m.state,
        CASE WHEN m.product_uom != pt.uom_id THEN
        COALESCE(sum(round((- m.product_qty :: numeric/u.factor :: numeric) * pu.factor :: numeric ,3)), 0.0)
        ELSE COALESCE(sum(- m.product_qty), 0.0)
        END as cant_convertida
        FROM
        stock_move m
        INNER JOIN (select distinct p.id, p.product_tmpl_id, p.default_code from product_product p inner join product_template pt on p.product_tmpl_id = pt.id
            inner join (                
            select distinct slp.id as parent_id, slh.id as child_id from product_category slp
            left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
            inner join diana_category_location_rel dcr on dcr.category_id =slp.id
            inner join diana_groups_location_rel dlr on dlr.location_id = dcr.location_id
            where dlr.groups_id in (select gid from res_groups_users_rel where uid = %s))
            as tbld on pt.categ_id = tbld.child_id
            inner join (                
            select distinct slp.id as parent_id, slh.id as child_id from product_category slp
            left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
            inner join diana_category_groups_rel dcg on dcg.category_id = slp.id 
            where dcg.group_id in (select gid from res_groups_users_rel where uid = %s))
            as tbld2 on pt.categ_id = tbld2.child_id) pp ON m.product_id = pp.id        
        LEFT JOIN stock_picking p ON m.picking_id = p.id
        LEFT JOIN product_template pt ON pp.product_tmpl_id = pt.id
        LEFT JOIN product_uom pu ON pt.uom_id = pu.id
        LEFT JOIN product_uom u ON m.product_uom = u.id
        LEFT JOIN stock_location l ON m.location_id = l.id
        GROUP BY
        m.id, m.product_id, pp.default_code, m.product_uom, pt.name, pt.categ_id, m.address_id, m.location_id, m.location_dest_id,
        m.prodlot_id, m.date, m.state, l.usage, m.company_id, pt.uom_id
        UNION ALL
        SELECT
        - m.id AS id, m.date,
        m.location_dest_id AS location_id,
        m.product_id,
        pp.default_code,
        pt.name,
        m.state,
        CASE WHEN m.product_uom != pt.uom_id THEN
        COALESCE(sum(round((m.product_qty :: numeric/u.factor :: numeric) * pu.factor :: numeric ,3)), 0.0)
        ELSE COALESCE(sum(m.product_qty), 0.0)
        END as cant_convertida
        FROM
        stock_move m
        INNER JOIN (select distinct p.id, p.product_tmpl_id, p.default_code from product_product p inner join product_template pt on p.product_tmpl_id = pt.id
                inner join (                
                select distinct slp.id as parent_id, slh.id as child_id from product_category slp
                left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
                inner join diana_category_location_rel dcr on dcr.category_id =slp.id
                inner join diana_groups_location_rel dlr on dlr.location_id = dcr.location_id
                where dlr.groups_id in (select gid from res_groups_users_rel where uid = %s))
                as tbld on pt.categ_id = tbld.child_id
                inner join (                
                select distinct slp.id as parent_id, slh.id as child_id from product_category slp
                left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
                inner join diana_category_groups_rel dcg on dcg.category_id = slp.id 
                where dcg.group_id in (select gid from res_groups_users_rel where uid = %s))
                as tbld2 on pt.categ_id = tbld2.child_id) pp ON m.product_id = pp.id        
        LEFT JOIN stock_picking p ON m.picking_id = p.id
            LEFT JOIN product_template pt ON pp.product_tmpl_id = pt.id
            LEFT JOIN product_uom pu ON pt.uom_id = pu.id
        LEFT JOIN product_uom u ON m.product_uom = u.id
        LEFT JOIN stock_location l ON m.location_dest_id = l.id
        GROUP BY
        m.id, m.product_id, pp.default_code, m.product_uom, pt.name, pt.categ_id, m.address_id, m.location_id, m.location_dest_id,
        m.prodlot_id, m.date, m.state, l.usage, m.company_id, pt.uom_id
        ) db_tbl
        where db_tbl.location_id = %s
        and db_tbl.state = 'done'
        """ %(self.uid, self.uid, self.uid, self.uid, location)
        
        sql = self.filter_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, product, all_product)

        salida = self.execute_sql(sql)
        agrupar = {}
        for i in salida:
            agrupar[i[0]] = {'codigo':i[1], 'name':i[2], 'existencia':i[3]}
        
        self.producto = agrupar
        return agrupar
        
    def detallado_productos_valorado(self, location, is_periodo, period, fecha_desde, fecha_hasta, product, all_product, existencias, formato):
        sql = """
        select db_tbl.date, db_tbl.date, db_tbl.location_id, db_tbl.product_id, db_tbl.name, db_tbl.default_code, db_tbl.refer, 
        db_tbl.name_unidad, db_tbl.state, SUM(db_tbl.cant_convertida) as cant_convertida, db_tbl.mov, db_tbl.ubicacion, db_tbl.price_unit, 
        SUM(CASE WHEN cant_convertida > 0 THEN  cant_convertida ELSE 0 END) as entrada, 
        SUM(CASE WHEN cant_convertida < 0 THEN  cant_convertida * -1 ELSE 0 END) as salida 
        from (SELECT
        min(m.id) AS id, m.date,
        m.location_id,
        m.product_id,
        pt.name, 
        pp.default_code,
        p.name AS refer,
        CASE WHEN t_unidad_deter.name_puom is null THEN 
        pu.name ELSE t_unidad_deter.name_puom 
        END as name_unidad,
        m.state,
        CASE WHEN m.product_uom != pt.uom_id THEN
        COALESCE(sum(round((- m.product_qty :: numeric/u.factor :: numeric) * pu.factor :: numeric ,3)), 0.0)
        ELSE COALESCE(sum(- m.product_qty), 0.0)
        END as cant_convertida,
        'A-->' AS mov,
        l2.name AS ubicacion,
        CASE WHEN m.product_uom != pt.uom_id THEN
        COALESCE(round((m.price_unit :: numeric/pu.factor :: numeric) * u.factor :: numeric ,5), 0.0)
        ELSE COALESCE(m.price_unit, 0.0)
        END as price_unit 
        FROM
        stock_move m
        INNER JOIN (select distinct p.id, p.product_tmpl_id, p.default_code from product_product p inner join product_template pt on p.product_tmpl_id = pt.id
                inner join (                
                select distinct slp.id as parent_id, slh.id as child_id from product_category slp
                left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
                inner join diana_category_location_rel dcr on dcr.category_id =slp.id
                inner join diana_groups_location_rel dlr on dlr.location_id = dcr.location_id
                where dlr.groups_id in (select gid from res_groups_users_rel where uid = %s))
                as tbld on pt.categ_id = tbld.child_id
                inner join (                
                select distinct slp.id as parent_id, slh.id as child_id from product_category slp
                left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
                inner join diana_category_groups_rel dcg on dcg.category_id = slp.id 
                where dcg.group_id in (select gid from res_groups_users_rel where uid = %s))
                as tbld2 on pt.categ_id = tbld2.child_id) pp ON m.product_id = pp.id        
        LEFT JOIN stock_picking p ON m.picking_id = p.id
        LEFT JOIN product_template pt ON pp.product_tmpl_id = pt.id
        LEFT JOIN product_uom pu ON pt.uom_id = pu.id
        LEFT JOIN product_uom u ON m.product_uom = u.id
        LEFT JOIN stock_location l ON m.location_id = l.id
        LEFT JOIN stock_location l2 ON m.location_dest_id = l2.id
        LEFT JOIN (SELECT p_uom.id as p_uom_id, it.value as name_puom 
        FROM ir_translation it
        INNER JOIN product_uom p_uom ON p_uom.id = it.res_id
        WHERE it.name = 'product.uom,name' ) as t_unidad_deter ON pu.id = t_unidad_deter.p_uom_id 
        GROUP BY
        m.id, m.product_id, pt.name, p.name, pp.default_code, pu.name, t_unidad_deter.name_puom, m.product_uom, m.location_id, l2.name, m.location_dest_id,
        m.date, m.state, pt.uom_id, pu.factor, u.factor, m.price_unit
        UNION ALL
        SELECT
        m.id AS id, m.date,
        m.location_dest_id AS location_id,
        m.product_id,
        pt.name,
        pp.default_code,
        p.name AS refer,
        CASE WHEN t_unidad_deter.name_puom is null THEN 
        pu.name ELSE t_unidad_deter.name_puom 
        END as name_unidad, 
        m.state,
        CASE WHEN m.product_uom != pt.uom_id THEN
        COALESCE(sum(round((m.product_qty :: numeric/u.factor :: numeric) * pu.factor :: numeric ,3)), 0.0)
        ELSE COALESCE(sum(m.product_qty), 0.0)
        END as cant_convertida,
        'DE->' AS mov,
        l2.name AS ubicacion,
        CASE WHEN m.product_uom != pt.uom_id THEN
        COALESCE(round((m.price_unit :: numeric/pu.factor :: numeric) * u.factor :: numeric ,5), 0.0)
        ELSE COALESCE(m.price_unit, 0.0)
        END as price_unit         
        FROM
        stock_move m
        INNER JOIN (select distinct p.id, p.product_tmpl_id, p.default_code from product_product p inner join product_template pt on p.product_tmpl_id = pt.id
                inner join (                
                select distinct slp.id as parent_id, slh.id as child_id from product_category slp
                left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
                inner join diana_category_location_rel dcr on dcr.category_id =slp.id
                inner join diana_groups_location_rel dlr on dlr.location_id = dcr.location_id
                where dlr.groups_id in (select gid from res_groups_users_rel where uid = %s))
                as tbld on pt.categ_id = tbld.child_id
                inner join (                
                select distinct slp.id as parent_id, slh.id as child_id from product_category slp
                left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
                inner join diana_category_groups_rel dcg on dcg.category_id = slp.id 
                where dcg.group_id in (select gid from res_groups_users_rel where uid = %s))
                as tbld2 on pt.categ_id = tbld2.child_id) pp ON m.product_id = pp.id        
        LEFT JOIN stock_picking p ON m.picking_id = p.id
	    LEFT JOIN product_template pt ON pp.product_tmpl_id = pt.id
	    LEFT JOIN product_uom pu ON pt.uom_id = pu.id
        LEFT JOIN product_uom u ON m.product_uom = u.id
        LEFT JOIN stock_location l ON m.location_dest_id = l.id
        LEFT JOIN stock_location l2 ON m.location_id = l2.id
        LEFT JOIN (SELECT p_uom.id as p_uom_id, it.value as name_puom 
        FROM ir_translation it
        INNER JOIN product_uom p_uom ON p_uom.id = it.res_id
        WHERE it.name = 'product.uom,name') as t_unidad_deter ON pu.id = t_unidad_deter.p_uom_id                
        GROUP BY
        m.id, m.product_id, pt.name, p.name, pp.default_code, pu.name, t_unidad_deter.name_puom, m.product_uom,  m.location_id, l2.name, m.location_dest_id,
        m.date, m.state, pt.uom_id, pu.factor, u.factor, m.price_unit 
        ) db_tbl
        where db_tbl.location_id = %s 
        and db_tbl.state = 'done'  
        """%(self.uid, self.uid, self.uid, self.uid, location)
        sql = self.filter_resumido_detallado_sql(sql, is_periodo, period, fecha_desde, fecha_hasta, product, all_product)
        sql = sql + """
        GROUP BY  
        db_tbl.date, db_tbl.location_id, db_tbl.product_id, db_tbl.name, db_tbl.default_code, db_tbl.refer, db_tbl.name_unidad, db_tbl.state, 
        db_tbl.mov, db_tbl.ubicacion, db_tbl.price_unit"""
        sql = sql + '\n order by db_tbl.product_id, db_tbl.date'
        salida = self.execute_sql(sql)
        agrupador = {}
        valorado = {}
        states = {'done':'Realizado'}
        total = 0.0
        
        for i in salida:
            if i[3] not in existencias:
               existencias.update({i[3]:{'name':i[4], 'codigo':i[5], 'existencia':0.00}})
            agrupador[i[3]] = []
        
        self.producto = existencias
        
        for i in salida:
            total = 0.0
            if i[3] not in existencias:
               existencias.update({i[3]:{'name':i[4], 'codigo':i[5], 'existencia':0.00}})

            if i[12] is not None:
                total = i[9]*i[12]
            valorado = {'fecha':i[1][0:10], 'entrada':i[13], 'ref':i[6],
                                    'udm':i[7], 'ubicacion': i[10]+' '+i[11], 'salida':i[14], 
                                    'costo_unit':i[12], 'total': total}
            valorado.update(self.detallado_productos_referencia_valorado(i[3], i[6]))
            agrupador[i[3]].append(valorado)
            
            if i[11] not in self.totales:
                self.totales[i[11]] = {}
            
            if valorado['cta_debito'] not in self.totales[i[11]]:
                self.totales[i[11]] [valorado['cta_debito']] = {'debito':0.0, 'credito':0.0}
            if valorado['cta_credito'] not in self.totales[i[11]]:
                self.totales[i[11]] [valorado['cta_credito']] = {'debito':0.0, 'credito':0.0}
            
            
            if valorado['cta_credito'] in self.totales[i[11]]:   
                self.totales[i[11]][valorado['cta_credito']]['credito'] += valorado['credito']
            if valorado['cta_debito'] in self.totales[i[11]]:      
                self.totales[i[11]][valorado['cta_debito']]['debito'] += valorado['debito']
                
        self.producto = existencias

        for i in existencias:
            if i not in agrupador:
                if existencias[i]['existencia'] != 0.00:
                    agrupador.update({i:[{'fecha':None, 'entrada':0.0, 'ref':None,
                                        'udm':None, 'ubicacion':None, 'salida':0.0, 
                                        'existencia':existencias[i]['existencia'], 
                                        'costo_unit':0.0, 'total': 0.0,
                                        'cta_debito':None, 'debito':0.0, 'cta_credito':None, 'credito':0.0}]})
        return agrupador
        
    def detallado_productos_referencia_valorado(self, product, ref):
        sql = """
        SELECT aml.ref, aml.product_id, aa.code as cta_debit, SUM(aml.debit) as debit, aa_aux.code as cta_credit, SUM(aml_aux.credit) as credit 
        FROM account_move_line aml
        INNER JOIN account_move_line aml_aux ON aml.move_id = aml_aux.move_id
        INNER JOIN account_account as aa ON  aa.id = aml.account_id
        INNER JOIN account_account as aa_aux ON  aa_aux.id = aml_aux.account_id 
        WHERE aml_aux.credit is not null AND aml.debit is not null AND aml.product_id = %s AND aml.ref = '%s' 
        GROUP BY  aml.ref, aml.product_id, aa.code, aa_aux.code 
        --LIMIT 1 
        """%(product, ref)
        salida = self.execute_sql(sql)
        valor = {'cta_debito':None, 'debito':0.0, 'cta_credito':None, 'credito':0.0}
        
        for i in salida:
            valor['cta_debito'] = i[2]
            valor['debito'] = i[3]
            valor['cta_credito'] = i[4]
            valor['credito'] = i[5]
        
        return valor    
                     
    def execute_sql(self, sql):
        self.cr.execute(sql)
        consulta = self.cr.fetchall()
        return consulta
		
    def cvr_fecha(self, f):
        d = datetime.strptime(f, '%Y-%m-%d').strftime('%d/%m/%Y')
        return d 
        
    def list_2_typle(self, list):
            list = [str(i) for i in list]    
            t = ()
            if len(list) == 1:
               t = "(%s)"%"".join(list)
            else:
                t = tuple(list)
            return t   
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        d = datetime.datetime.strptime(fecha, '%Y-%m-%d').strftime('%Y/%m/%d')
        return d 
    
    def titulos_rml(self, data):
        d = {'detail':'DETALLADO',
            'resume':'RESUMIDO',
            'total':'TOTAL'
            }
        return d[data['form']['formato']]

    def get_fecha(self, value):
        salida = ''
        if value['is_periodo']:
           salida = "Periodo: %s" %value['periodo_name']
        else:
            salida = 'Desde: %s Hasta: %s'%(self.cvr_fecha(value['fecha_desde']), self.cvr_fecha(value['fecha_hasta']))
        return salida
    
    def sumar(self, k, d):
        calculo = {'salida':0.00, 'entrada':0.00, 'total':0.00, 'debito':0.00, 'credito':0.00}
        for i in d[k]:
            calculo['salida'] += i['salida']
            calculo['entrada'] += i['entrada']
            calculo['total'] += i['total']
            calculo['debito'] += i['debito']
            calculo['credito'] += i['credito']                           
        return calculo
        
    
    def get_totales(self):
        return [self.totales]
        

report_sxw = report_sxw.report_sxw    
class RMLParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False, header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
       
    
    
    def create_single_pdf(self, cursor, uid, ids, data, report_xml, context=None):
        """generate the PDF"""
        
        if context is None:
            context={}
        
        if report_xml.report_type == 'pdf':
            return super(RMLParser,self).create_single_pdf(cursor, uid, ids, data, report_xml, context=context)


RMLParser('report.analisis.inventario.valorado',
          'wizard.analisis.inventario.valorado', 
          'sisb_invoice_report/report/analisis_inventario_valorado.rml',
          parser=analisis_inventario_valorado_report)
