#!/usr/bin/python
# -*- encoding: utf-8 -*-

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

from osv import osv,fields
from tools.translate import _
import unicodedata
import re
import datetime

class report_comisiones(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_comisiones, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'vendedor': self.vendedor,
            'equipo_ventas': self.equipo_ventas,
            'estado_comision': self.estado_comision,
            'sucursal': self.sucursal,
            'descripcion': self.descripcion,
            'get_rol': self.get_rol,
            'get_cliente': self.get_cliente,
            'contador': self.contador,
            
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d %H:%M:%S')
        return str(new.strftime('%d-%m-%Y'))
    
    
    def get_rol(self, rol):
        if rol == 'salesman':
            rol = "Vendedor"
        elif rol == "responsible":
            rol = "Responsable"
        else:
            rol = "Otros"
        return rol
    
    def vendedor(self, id_vendedor):
        if id_vendedor:
            query_equipo = """select name from res_users
                           where id =  %s"""
            self.cr.execute(query_equipo %id_vendedor)
            vendedor = self.cr.fetchall()
            return vendedor[0][0]
        return "Todos"
        
    def equipo_ventas(self, id_equipo):
        if id_equipo:
            query_equipo = """select complete_name from crm_case_section
                            where id = %s order by id """
            self.cr.execute(query_equipo %id_equipo)
            equipo = self.cr.fetchall()
            return equipo[0][0]
        return "Todos"
    
    def sucursal(self, id_shop):
        if id_shop:
            query_equipo = """select * from sale_shop where id = %s"""
            self.cr.execute(query_equipo %id_shop)
            sucursales = self.cr.fetchall()
            return sucursales[0][5]
        return "Todos"
    
    def descripcion(self, id_comision):
        if id_comision:
            query_equipo = """select name from sisb_commission where id = %s"""
            self.cr.execute(query_equipo %id_comision)
            sucursales = self.cr.fetchall()
            return sucursales[0][0]
        return "Todos"
    
    def get_cliente(self, cliente):
        if cliente:
            query_equipo = """select name from res_partner where id= %s"""
            self.cr.execute(query_equipo %cliente)
            cli = self.cr.fetchall()
            return cli[0][0]
        return "Todos"
        
    def estado_comision(self, msj):
        if msj == "confirmed":
            msj = "CONFIRMADO"
        else:
            msj = "REALIZADO"
        return msj
    
    def contador(self, lista):
        cuenta = len(lista)
        return cuenta


report_sxw.report_sxw('report.reportecomisiones',
    'wizard.comisiones',
    'sisb_reportes_especiales/report/report_comisiones.rml',
    parser=report_comisiones)
