# /usr/bin/env python
# -*- encoding: utf-8 -*-

from osv import osv
from osv import fields
import datetime
from tools.translate import _

class wizard_analisis_origen_asiento(osv.osv_memory):
    
    _name = "wizard.analisis.origen.asiento"
    _description = "wizard para generar reporte de analisis contable de movimientos"
    
    _columns = {
    'is_periodo': fields.boolean('Periodo'),
    'fecha_desde': fields.date('Fecha desde'),
    'fecha_hasta': fields.date('Fecha Hasta'),
    'period_id': fields.many2one('account.period', 'Periodo'),
    'account_id': fields.many2one('account.account', 'Cuenta'),
    'all_account': fields.boolean('Todas las Cuentas'),    
    'product_id': fields.many2one('product.product', 'Producto'),
    'all_product': fields.boolean('Todos los Productos'),
     }
    _defaults = {
        'all_product':True,
        'all_account':True,
    }
    

    def generate_report(self, cr, uid, ids, context=None):
        agrupador = {}
        wizard_brw = self.browse(cr, uid, ids)[0]
        for i in self._columns:
            if type(getattr(wizard_brw, i)) in [osv.orm.browse_record, osv.orm.browse_null]:
                agrupador[i] = getattr(getattr(wizard_brw, i),'id')
            else:
                agrupador[i] =  getattr(wizard_brw, i)  
        
        if not agrupador['is_periodo']:
            fecha_desde_date = datetime.datetime.strptime(agrupador['fecha_desde'], "%Y-%m-%d")
            fecha_hasta_date = datetime.datetime.strptime(agrupador['fecha_hasta'], "%Y-%m-%d")
            dif = fecha_desde_date - fecha_hasta_date
            dif = abs(dif)
            if dif.days > 31:
                raise osv.except_osv('ERROR', "Las fechas no pueden exceder de 31 dias") 
        
        
        agrupador['periodo_name'] =  wizard_brw.period_id.name
        if wizard_brw.account_id.code is not None:
            agrupador['account_name'] =  wizard_brw.account_id.code + ' ' + wizard_brw.account_id.name
        if wizard_brw.product_id.name is not None:
			agrupador['product_name'] =  wizard_brw.product_id.name.replace('#',' ')   
        datas = {'form':agrupador}
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'analisis.origen.asiento',
            'datas': datas,
       }
    
   
  
        
wizard_analisis_origen_asiento()
