# /usr/bin/env python
# -*- encoding: utf-8 -*-

from osv import osv
from osv import fields

class wizard_comisiones(osv.osv_memory):
    
    _name = "wizard.comisiones"
    _description = "wizard para generar reporte comisiones"
    _columns = {
    
    'vendedor_id': fields.many2one('res.users', 'Vendedor'),                         
    'mes_desde': fields.date('Desde', required=True),
    'mes_hasta': fields.date('Hasta', required=True),
    'sucursal_id': fields.many2one('sale.shop', 'Sucursal'),
    'estado_comision':fields.selection([('confirmed','Confirmado'),('done', 'Realizado')], 'Estado de la Comision', required=True),  
    'tipo_reporte':fields.selection([('resumido','Resumido'),('detallado', 'Detallado')], 'Tipo de Reporte', required=True),
    'equipo_ventas':fields.many2one('crm.case.section', 'Equipo de Ventas'),   
      
                }
    
    def generate_report(self, cr, uid, ids, context=None):
        
        self.cr = cr
        self.ids = ids
        create_brw = self.browse(cr, uid, ids)[0]
         
        vendedor_id = create_brw.vendedor_id.id
        sucursal_id = create_brw.sucursal_id.id
        equipo_ventas = create_brw.equipo_ventas.id
        
        mes_desde = create_brw.mes_desde
        mes_hasta = create_brw.mes_hasta
        estado_comision = create_brw.estado_comision
        tipo_reporte = create_brw.tipo_reporte
        
        obj = self.pool.get('sisb.commission')
        
        m_d = mes_desde.split('-')
        m_h = mes_hasta.split('-')
        
        if mes_desde > mes_hasta:
            raise osv.except_osv(('ERROR!'), ('Error en la combinacion de fechas, hasta no puede ser mayor a desde!!!'))
        if m_d[0] != m_h[0]:
            raise osv.except_osv(('ERROR!'), ('Error en la combinacion de fechas, las fechas deben pertenecer al mismo mes y año!!!'))
        if m_d[1] != m_h[1]:
            raise osv.except_osv(('ERROR!'), ('Error en la combinacion de fechas, las fechas deben pertenecer al mismo mes y año!!!'))
        mes = "Desde: "+ str(m_d[2])+"/"+str(m_d[1]) +"/"+ str(m_d[0]) + " hasta: " + str(m_h[2])+"/"+str(m_h[1]) +"/"+ str(m_h[0])

        
        
        lista_busqueda=[]
        titulo=[]
        if vendedor_id:
            lista_busqueda.append(('user_id','=',vendedor_id))
        if sucursal_id:
            lista_busqueda.append(('shop_id','=',sucursal_id))
        if equipo_ventas:
            lista_busqueda.append(('context_section_id','=',equipo_ventas))
       
        lista_busqueda.append(('state', '=', estado_comision))
        lista_busqueda.append(('paid_date_invoice','>=',mes_desde))
        lista_busqueda.append(('paid_date_invoice','<=',mes_hasta))
        
    
        datos = obj.search(cr, uid, lista_busqueda, order = "paid_date_invoice")
        browse_datos = obj.browse(cr, uid, datos)
        acumulador = {}
        sumador = {}
        total={}
        #~ DETALLADO
        if tipo_reporte == "detallado":
            for i in browse_datos:
                sumador[i.user_id.id]={}
                
            for i in browse_datos:
                acumulador[i.user_id.id]=[]
                sumador[i.user_id.id].update({i.condition:{'base':0.0, 'comision': 0.0}})
                total[i.user_id.id] = {'base':0.0, 'comision': 0.0}
                
            for i in browse_datos:
                acumulador[i.user_id.id].append((i.id, i.shop_id.id, i.context_section_id.id, i.base, i.commission, i.paid_date_invoice, i.condition, i.partner_id.id, i.percentage, i.invoice_id.name))
                sumador[i.user_id.id][i.condition]['base'] += i.base
                sumador[i.user_id.id][i.condition]['comision'] += i.commission
                total[i.user_id.id]['base'] += i.base
                total[i.user_id.id]['comision'] += i.commission
            
                
        #~ RESUMIDO
        if tipo_reporte == "resumido":
            for i in browse_datos:
                acumulador[i.user_id.id]={}
            for i in browse_datos:
                acumulador[i.user_id.id].update({i.condition:{'base':0.0, 'comision': 0.0}})
                total = {'base':0.0, 'comision': 0.0}
                
            for i in browse_datos:
                acumulador[i.user_id.id][i.condition]['comision'] += i.commission
                acumulador[i.user_id.id][i.condition]['base'] += i.base
                total['base'] += i.base
                total['comision'] += i.commission
                
        
        data={}
        if acumulador == {}:
            raise osv.except_osv(('ERROR!'), ('La combinación de filtros para generar dicho reporte no arrojo ningún resultado!!!'))
        else:
            data['cuerpo'] = acumulador
            data['suma'] = sumador
            data['total'] = total
            data['vendedor'] = vendedor_id
            data['sucursal'] = sucursal_id
            data['equipo_ventas'] = equipo_ventas
            data['estado_comision'] = estado_comision
            data['mes'] = mes

        dict_ruta = {
        'resumido':'sisb_reportes_especiales/report/report_comisiones.rml',
        'detallado':'sisb_reportes_especiales/report/report_comisiones_detallado.rml',

        }
        
        ir_obj = self.pool.get('ir.actions.report.xml')
        ir_id = ir_obj.search(cr, 1, [('model','=',self._name)]) 
        ir_write= ir_obj.write(cr, 1, ir_id, {'report_rml':dict_ruta[tipo_reporte]})
        
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'reportecomisiones',
            'datas': data,
        }
       
        
wizard_comisiones()
