#-*- coding:utf-8 -*- 
#!/usr/bin/env python 
 
from osv import osv, fields
 
class wizard_inventario_producto_terminado(osv.osv_memory): 
    
    _name = 'wizard.inventario.producto.terminado' 
    _description = '' 
    _columns = {
       
        'mostrarcero': fields.boolean('Mostrar existencia 0.0'),
        'is_periodo': fields.boolean('Periodo'),
        'fecha_desde': fields.date('Fecha desde'),
        'fecha_hasta': fields.date('Fecha Hasta'),
        'period_id': fields.many2one('account.period', 'Periodo'),
        'categ_id': fields.many2one('configuration.inventario.producto.terminado', 'Categoria', required=True),
        'product_id': fields.many2one('product.product', 'Producto'),
        'all_product': fields.boolean('Todos los Productos'),
        'location_id': fields.many2one('stock.location', 'Ubicacion', required=False),
        'formato':fields.selection([(False,''),
                                    ('ubicacion','Por Ubicación'),
                                    ('todas_ubicaciones', 'Todas las Ubicaciones'),
                                    ('total', 'Total')], 'Tipo', required=True),
     }
    
    _defaults = {
            'all_product':True,
            'is_periodo':False,
        }
   
    def child_cat(self, cr, uid, categoria_id, context=None):
        
        child_ids = [c.id for c in self.pool.get('product.category').browse(cr, uid, categoria_id, context=context).child_id]
        return [categoria_id] + reduce(lambda x, y: x + y, [self.child_cat(cr, uid, d, context=context) for d in child_ids], []) if child_ids else [categoria_id]
        
    def generate_report(self, cr, uid, ids, context=None): 
        
        brw = self.browse(cr, uid, ids, context)[0]
        formato = brw.formato 
        categ_id = brw.categ_id 
        all_product = brw.all_product 
        product_id = brw.product_id 
        
        categorias_ids = self.child_cat(cr, uid, categ_id.categ_id.id, context)
        filtros = []
        
        if not all_product:
            filtros.append(('id','=',product_id.id))
        filtros.append(('categ_id','in',categorias_ids))
        
        obj_product = self.pool.get('product.product') 
        product_ids = obj_product.search(cr, uid, filtros)
                
        if not product_ids:
            raise osv.except_osv('ERROR', "La combinación de filtros no genero ningun resultado ó no se tiene permisos para acceder a dicha información.") 
        
        if formato == 'ubicacion':
            return { 
               'type': 'ir.actions.report.xml',
               'report_name': 'wizard.inventario.producto.terminado.xml.id', 
            } 
        elif formato == 'todas_ubicaciones':
            return { 
               'type': 'ir.actions.report.xml',
               'report_name': 'wizard.inventario.producto.terminado.xml.id.detallado', 
            } 
            
        else:
            return { 
               'type': 'ir.actions.report.xml',
               'report_name': 'wizard.inventario.producto.terminado.xml.id.total', 
            } 
        
        
   
wizard_inventario_producto_terminado() 
