#!/usr/bin/env python
# -*- coding: utf-8 -*--

from osv import osv,fields 
from tools.translate import _ 
import pooler 
import time 
import unicodedata 
from datetime import *
import calendar


class wizard_reposo_medico_cal(osv.osv_memory):
    _name = 'wizard.reposo.medico.cal'
    _description = 'Wizard para generar csv de reposos medicos'
    _columns = {
        'nomina_id': fields.many2one('hr.payroll', 'Nómina'),
        'sede_id': fields.many2one('hr.sede', 'Sede'),
        'semana_desde': fields.date('Semana', required=True),
        'tipo_reporte': fields.selection([('semanal', 'Semanal')], '', required=True)
    }
    
    def obtener_domingo(self, fecha):
        if fecha:
            mes = datetime.strptime(fecha, "%Y-%m-%d")
            if calendar.day_name[mes.weekday()] == 'lunes':
                dias = timedelta(days=6)
                domingo = mes + dias
                return domingo
            return False
    
    def generar_reporte(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids)[0] 
        tipo_reporte = brw.tipo_reporte
        
        if tipo_reporte == 'semanal':
            
            lunes = brw.semana_desde
            domingo = self.obtener_domingo(lunes)
            sede_id = brw.sede_id.id
            nomina_id = brw.nomina_id.id
            resultado ={}
            if not domingo:
                raise osv.except_osv(_('ERROR!'), _('Debes seleccionar un dia lunes!!!')) 
            else:
                if sede_id:
                    sede_titulo =  brw.sede_id.name
                else:
                    sede_titulo = 'TODAS'
                if nomina_id:
                    nomina_titulo = brw.nomina_id.name
                else:
                    nomina_titulo = 'TODAS'
                    
                resultado = {'form':lunes, 'domingo':domingo, 'sede_id':sede_id, 'nomina_id':nomina_id, 'nomina_titulo':nomina_titulo,'sede_titulo':sede_titulo }
                
                return {
                    'type': 'ir.actions.report.xml',
                    'report_name': 'reposos.medicos.report',
                    'datas': resultado,
                    }
        else:
            raise osv.except_osv(_('ERROR!'), _('Tipo de reporte no valido!!!')) 

wizard_reposo_medico_cal()
