#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Copyright (C) Industrias Diana, C.A. (www.industriasdiana.gob.ve)
#    All Rights Reserved
###############Credits######################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################
import re
import csv

#~  algoritmo: Distancia de Levenshtein para calcular la diferencia entre palabras
def cadena_similar(str1, str2):
    d=dict()
    for i in range(len(str1)+1):
        d[i]=dict()
        d[i][0]=i
    for i in range(len(str2)+1):
        d[0][i] = i
    for i in range(1, len(str1)+1):
        for j in range(1, len(str2)+1):
            d[i][j] = min(d[i][j-1]+1, d[i-1][j]+1, d[i-1][j-1]+(not str1[i-1] == str2[j-1]))
    return d[len(str1)][len(str2)]




def cadena_coincidencias(nombre_buscar,lista_de_nombres):
    #~ Recibe un nombre a buscar:nombre_buscar 
    #~ dentro de una lista:lista_de_nombres 
    posibles_coincidencias = []
    for n in lista_de_nombres:

        resultado = cadena_similar(n,nombre_buscar)
        if  resultado <= 4:
            posibles_coincidencias.append(n)
    #~ retorna las posibles coincidencias para orientar al usuario
    return posibles_coincidencias
