#-*- coding:utf-8 -*- 
#!/usr/bin/env python 
 
###############Credits######################################################## 
#    Developed by: Industrias Diana, C.A. 
##############################################################################

from report import report_sxw
import datetime
from datetime import datetime

import xlwt
from xlwt import Workbook
from xlwt import Font
from xlwt import XFStyle
from xlwt import Borders

class wizard_relacion_buque(report_sxw.rml_parse):
    _name =  'wizard.relacion.buque'
    
    def __init__(self, cr, uid, name, context):
        super(wizard_relacion_buque, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'cvr_date':self.cvr_date,
            
        })

        self.context = context

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        return  datetime.datetime.strptime(fecha, '%Y/%m/%d').strftime('%Y%m%d')    

report_sxw = report_sxw.report_sxw     

class TxtParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False,
        header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
   
   
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y')    
   
    def crear_xls(self, data, ano, producto, qty_real):
        import StringIO
        import base64
        try:
            import xlwt
        except:
            raise osv.except_osv('Warning !','Please download python xlwt module from\nhttp://pypi.python.org/packages/source/x/xlwt/xlwt-0.7.2.tar.gz\nand install it')
        
        empresas = []
        referencia = []
        dic_ref = {}
        dic_emp = {}
        for ref in data:
            dic_ref[ref] = 0.0
            if not ref in referencia:
                referencia.append(ref)
                 
            for emp in data[ref]:
                dic_emp[emp] = 0.0
                if not emp in empresas:
                    empresas.append(emp)
                    
        empresas = sorted(empresas)
        referencia = sorted(referencia)
        filas = len(referencia) + 1
        wbk = xlwt.Workbook()
        
        title_left = xlwt.easyxf('align: horiz left;' 'font: name Times New Roman, colour black, bold on, height 200; pattern: pattern solid, fore_colour white;')
        title_center = xlwt.easyxf('align: horiz center;' 'font: name Times New Roman, colour black, bold on, height 200; pattern: pattern solid, fore_colour white;')
        title_center_hora = xlwt.easyxf('align: horiz center;' 'font: name Times New Roman, colour black, bold on, height 160; pattern: pattern solid, fore_colour white;')
        title2 = xlwt.easyxf('font: bold on, height 140;' 'align: horiz center;''borders: left thin, right thin, top thin')
        style1 = xlwt.easyxf('font: bold off, height 140;' 'align: horiz left;''borders: left thin, right thin, top thin')
        style3 = xlwt.easyxf('font: bold off, height 140;' 'align: horiz center;''borders: left thin, right thin, top thin')
        numbers = xlwt.easyxf('font: bold off, height 140;' 'align: horiz right;''borders: left thin, right thin, top thin', num_format_str='#,##0.00')
        numbers2 = xlwt.easyxf('font: bold on, height 140;' 'align: horiz right;''borders: left thin, right thin, top thin', num_format_str='#,##0.00')

        ws = wbk.add_sheet('Buques ' + str(ano))
        
        ws.col(0).width = 10000
        ws.write(0, 0, 'INDUSTRIAS DIANA C.A.', title_left)
        
        ws.col(0).width = 10000
        ws.write(1, 0, 'G200096144', title_left)
        
        ws.col(0).width = 10000
        ws.write(2, 0, 'AV Henry Ford Local Nro S/N Urb La Isabelica Sector Zona Industrial Sur II', title_left)
        
        ws.col(0).width = 10000
        ws.write(3, 0, 'Valencia-Venezuela', title_left)
    
        ws.col(0).width = 10000
        ws.write_merge(4, 4, 0, filas, 'RELACION DE BUQUES QUE DESCARGARON EN EL ' + str(ano), title_center)
        
        fecha = self.get_final_date()
        ws.col(0).width = 10000
        ws.write_merge(5, 5, 0, filas, producto, title_center)
    
        
        ws.col(0).width = 10000
        ws.write_merge(6, 6, 0, filas, 'A LA FECHA ' + str(fecha), title_center_hora)
        
        
        
        
        ws.col(0).width = 10000
        ws.write(7, 0, 'EMPRESAS', title2)
        
        b = 1
        for i in referencia:
            ws.write(7, b, i, title2)
            b += 1
            
        ws.write(7, b, 'TOTAL DESPACHADO', title2)
        
        
        
        
        
        
        
        c = 8
        for i in empresas:
            ws.col(0).width = 10000
            ws.write(c, 0, i, style1)
            c = c + 1
        
        c = 8
        total_total = 0.0
        for emp in empresas:
            f = 1
            for ref in referencia:
                try:
                    cantidad = data[ref][emp]['qty']
                    total_total += cantidad
                    dic_ref[ref] += cantidad
                    dic_emp[emp] += cantidad
                    ws.write(c, f, cantidad, numbers)
                except:
                    ws.write(c, f, '', style1)
                f = f + 1
            ws.write(c, f, dic_emp[emp], numbers2)
            c = c + 1
        
        ws.write(c, 0, 'DESPACHADO', title2)
        
        f = 1
        for ref in referencia:
            cantidad = dic_ref[ref]
            ws.write(c, f, cantidad, numbers2)
            f = f + 1
        ws.write(c, f, total_total, numbers2)
        c = c + 1
        
        
        ws.write(c, 0, 'DESCARGADO', title2)
        
        f = 1
        total_real = 0.0
        for ref in referencia:
            total_real += qty_real[ref]
            ws.write(c, f, qty_real[ref], numbers2)
            f = f + 1
        ws.write(c, f, total_real, numbers2)
        c = c + 1
        
        
        ws.write(c, 0, 'DISPONIBLE', title2)
        
        total_disponible = 0.0
        f = 1
        for ref in referencia:
            cantidad = qty_real[ref] - dic_ref[ref]
            total_disponible += cantidad 
            ws.write(c, f, cantidad, numbers2)
            f = f + 1
        ws.write(c, f, total_disponible, numbers2)
        c = c + 1
        
        try:
            file_data=StringIO.StringIO()
            o=wbk.save(file_data)
            return file_data.getvalue()
        except:
            raise osv.except_osv('Warning !','Error al crear el archivo')
        
    
    def create_single_pdf(self, cursor, uid, ids, data, report_xml, context):
      
        if context is None:
            context={}
        
        if  data['form']:
            xls_report = self.crear_xls(data['form'], data['year'], data['producto'], data['real'])
            return (xls_report, 'ods')
        else:
            return super(TxtParser,self).create_single_pdf(cursor, uid, ids, data, report_xml, context=context)

TxtParser('report.wizard_relacion_buque_xml', 
            'wizard.relacion.buque', 
            'sisb_ship_reception/report/wizard_relacion_buque.rml', 
            parser=wizard_relacion_buque, header=False)
