#-*- coding:utf-8 -*- 
#!/usr/bin/env python 
 
###############Credits######################################################## 
#    Developed by: Industrias Diana, C.A. 
############################################################################## 
 
from osv import osv,fields 
from tools.translate import _ 
import pooler 
import time 
import unicodedata 
import re 
import datetime 
 
class wizard_reception_ship(osv.osv_memory): 
    _name = "wizard.reception.ship" 
    _description = 'Wizard para generar REPORTE de movimiento de buque' 
    _columns = { 
    
        } 
    def generar_reporte(self, cr, uid, ids, context=None): 
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        data = {}
        
        rs_obj = self.pool.get('sisb.ship.reception.detail')
        r_obj = self.pool.get('sisb.ship.reception')
        
        ship_reception_detail = rs_obj.browse(cr, uid, brw.id)
        ship_reception_ids = r_obj.search(cr, uid, [('id','=', ship_reception_detail.ship_reception_id.id)])
        ship_reception_browse = r_obj.browse(cr, uid, ship_reception_ids)
        
        for i in ship_reception_browse:
            data['buque'] = i.name
            data['referencia'] = i.reference
        
        pick_name = ''
        for x in ship_reception_detail.picking_out_ids:
            pick_name += str(x.name) + ' '
        

        direccion = []
        if ship_reception_detail.partner_invoice_id.street:
            direccion.append(ship_reception_detail.partner_invoice_id.street)            
        if ship_reception_detail.partner_invoice_id.street2:
            direccion.append(ship_reception_detail.partner_invoice_id.street2)
        if ship_reception_detail.partner_invoice_id.zip:
            direccion.append(ship_reception_detail.partner_invoice_id.zip)
        if ship_reception_detail.partner_invoice_id.city:
            direccion.append(ship_reception_detail.partner_invoice_id.city)
        if ship_reception_detail.partner_invoice_id.state_id:
            direccion.append(ship_reception_detail.partner_invoice_id.state_id.name)
        if ship_reception_detail.partner_invoice_id.country_id:
            direccion.append(ship_reception_detail.partner_invoice_id.country_id.name)

        direccion_factura = ", ".join(direccion)
        
        data['producto'] = ship_reception_detail.product_id.name
        data['ubicacion_origen'] = ship_reception_detail.location_id.name
        data['detalle_de_movimiento'] = ship_reception_detail.ship_reception_id.name
        data['ubicacion_destino'] = ship_reception_detail.location_dest_id.name
        data['direccion_de_factura'] = direccion_factura
        data['cliente'] = ship_reception_detail.partner_id.name
        data['unidad_de_medida'] = ship_reception_detail.product_uom.name
        data['cantidad'] = ship_reception_detail.product_qty
        data['nota'] = ship_reception_detail.note or ''
        data['albaran'] = pick_name or ''
        data['tipo_de_transaccion'] = ship_reception_detail.transaction_type_id.name
        data['fecha'] = ship_reception_detail.date
        
        if not ship_reception_detail.printers:
            data['imprimir'] = "IMPRESO"
            res = rs_obj.write(cr, uid, ship_reception_detail.id, {'printers':True})
        else:
            data['imprimir'] = "REIMPRESO"
        
        if data == {}: 
            raise osv.except_osv(_('ERROR!'), _('la combinacion para generar dicho reporte no arrojo ningun resultado!!!')) 
        return { 
            
            'type': 'ir.actions.report.xml', 
            'report_name': 'xml_reception_ship', 
            'datas':data,  
            } 
 
wizard_reception_ship() 
 
