#-*- coding:utf-8 -*- 
#!/usr/bin/env python 
 
###############Credits######################################################## 
#    Developed by: Industrias Diana, C.A. 
############################################################################## 
 
from osv import osv,fields 
from tools.translate import _ 
import pooler 
import unicodedata 
import re 
from time import strftime
from datetime import *
 
class wizard_relacion_buque(osv.osv_memory): 
    _name = "wizard.relacion.buque" 
    _description = 'Wizard para generar REPORTE de Relacion de buque' 
    _columns = { 
    
    'product_id': fields.many2one('sisb.product.master', 'Producto', required=True),
    'fiscalyear_id': fields.many2one('account.fiscalyear', 'Año', required=True),
    
    
    } 
 
    def generar_reporte(self, cr, uid, ids, context=None): 
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        
        product = brw.product_id.id
        year = brw.fiscalyear_id.name
        
        data = {}
        qty_real = {}
        busqueda = [] 
        
        desde = year+'-01-01'
        hasta = year+'-12-31'
        
        if product:
            busqueda.append(('product_id','=',product))
        if year:
            busqueda.append(('real_arrival_date','>=',desde))
            busqueda.append(('real_arrival_date','<=',hasta))
        
        obj_reception = self.pool.get('sisb.ship.reception')
        obj_reception_detail = self.pool.get('sisb.ship.reception.detail')
        
        ship_reception_ids = obj_reception.search(cr, uid, busqueda)
        ship_reception_brw = obj_reception.browse(cr, uid, ship_reception_ids)
        
        for ref in ship_reception_brw:
            qty_real[ref.reference] = ref.product_qty
            data[ref.reference]={}
            
            ship_reception_detail_ids = obj_reception_detail.search(cr, uid, [('ship_reception_id','=',ref.id)])
            ship_reception_detail_brw = obj_reception_detail.browse(cr, uid, ship_reception_detail_ids)
            
            for det in ship_reception_detail_brw:
                data[ref.reference].update({det.partner_id.name:{}})
                
            for det in ship_reception_detail_brw:
                data[ref.reference][det.partner_id.name].update({'qty':0.0})
                
            for det in ship_reception_detail_brw:
                data[ref.reference][det.partner_id.name]['qty'] += det.product_qty
                
        
        
        
        
        if data == {}: 
            raise osv.except_osv(_('ERROR!'), _('la combinacion para generar dicho reporte no arrojo ningun resultado!!!')) 
        
        #~ order_list = []
        #~ for x in sorted(data.iterkeys()):
            #~ order_list.append({x:data[x]})
        
        data2 = {'form':data, 'year':year, 'producto':brw.product_id.name, 'real':qty_real}
        ir_obj = self.pool.get('ir.actions.report.xml')
        
        return{ 
            'type': 'ir.actions.report.xml', 
            'report_name': 'wizard_relacion_buque_xml', 
            'datas':data2,
            } 
        
wizard_relacion_buque() 
 
