# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2011 OpenERP Venezuela (http://openerp.com.ve)
# All Rights Reserved.
# Programmed by: Equipo SISB - Industrias Diana C.A.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields
import sys
from tools.translate import _
import decimal_precision as dp
import netsvc
from datetime import datetime
import random

class sisb_assignment_ship_differential_wizard(osv.osv_memory):
    """
    Assignment
    """
    _name = "sisb.assignment.ship.differential.wizard"
    
    _description = "Assignment Differential Ship"
    _columns = {
       'partner_id': fields.many2one('res.partner', 'Customer', required=True, change_default=True, select=True),
       'product_qty': fields.float('Quantity', digits_compute=dp.get_precision('Account'), required=True),
       'note': fields.text('Notes', required=True),
       'valid_item':fields.integer('Valid Item'),
    }
    
    _defaults = {
        'valid_item':lambda self,cr,uid,context : random.randrange(1, 100000000, 1)
    }
    
    def assignment_ship_differential(self, cr, uid, ids, context=None):
        
        data_unloading_ship = self.read(cr, uid, ids, [],context=context)[0]
        
        #Consultar existencia
        reception_ship_brw = self.pool.get('sisb.ship.reception').browse(cr, uid, context['active_id'], context=context)
        
        product_exist = reception_ship_brw.product_differential_available
        
        if data_unloading_ship['product_qty'] <= 0.00 or data_unloading_ship['product_qty'] > product_exist:
            raise osv.except_osv(_('mensaje'),_('The quantity of assignment can not be more than the existence.'))
        else:
            addr = self.pool.get('res.partner').address_get(cr, uid, [data_unloading_ship['partner_id']], ['invoice'])
                
            values = {
                'ship_reception_id': context['active_id'],
                'partner_id': data_unloading_ship['partner_id'],
                'partner_invoice_id': addr['invoice'],
                'product_qty': data_unloading_ship['product_qty'],
                'date': datetime.now(),
                'note': data_unloading_ship['note'],
                'valid_item': data_unloading_ship['valid_item'],
            }
            
            res = self.pool.get('sisb.ship.reception.detail.diferential').create(cr, uid, values, context)

            if res:
                return {'type': 'ir.actions.act_window_close'}
            else:
                raise osv.except_osv(_('mensaje'),_('There were errors in the process, contact the administrator.')) 
                
        
sisb_assignment_ship_differential_wizard()
