# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2011 OpenERP Venezuela (http://openerp.com.ve)
# All Rights Reserved.
# Programmed by:  Equipo SISB - Industrias Diana C.A.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields
import sys
from tools.translate import _
import decimal_precision as dp
import netsvc
from datetime import datetime

class sisb_confirmed_unloading_ship_wizard(osv.osv_memory):
    """
    Confirm landing ship
    """
    _inherit = "sisb.confirmed.unloading.ship.wizard"
    
    
    def unloading_ship(self, cr, uid, ids, context=None):
        ship_recept_obj = self.pool.get('sisb.ship.reception')
        data_unloading_ship = self.read(cr, uid, ids, [],context=context)[0]
        
        ship_recept_brw = ship_recept_obj.browse(cr, uid, context['active_id'], context=context)
        
        if ship_recept_brw.state == 'waiting':
        
            if  data_unloading_ship['product_qty'] < 1:
                raise osv.except_osv(_('mensaje'),_('Set real quantity of unloading ship.'))
            elif not ship_recept_brw.is_differential and round(abs(ship_recept_brw.product_uom_qty-data_unloading_ship['product_qty'])/ship_recept_brw.product_uom_qty,3) > 0.002:
                raise osv.except_osv(_('mensaje'),_('Exceeded the limit of decrease.'))
            elif ship_recept_brw.is_differential and (ship_recept_brw.product_uom_qty-data_unloading_ship['product_qty']) <= 0:
                raise osv.except_osv(_('mensaje'),_('Exceeded the limit permitted.'))
            else:
                differential_ship = 0.00
                if ship_recept_brw.is_differential:
                    differential_ship = ship_recept_brw.product_uom_qty - data_unloading_ship['product_qty']
                data_update = {
                    'location_dest_id':data_unloading_ship['location_dest_id'],
                    'product_qty':data_unloading_ship['product_qty'],
                    'real_arrival_date': datetime.now(),
                    'note_discharged': data_unloading_ship['note'],
                    'product_qty_diff': differential_ship
                }
                
                resultado01 = ship_recept_obj.write(cr,uid,context['active_id'],data_update,context=context)
                resultado02 = ship_recept_obj.action_confirmed(cr,uid,[context['active_id']],context=context)
                
                
                if resultado01 and resultado02:
                    return {'type': 'ir.actions.act_window_close'}
                else:
                    raise osv.except_osv(_('mensaje'),_('There were errors in the process, contact the administrator.')) 
                    
        else:
            return {'type': 'ir.actions.act_window_close'}

sisb_confirmed_unloading_ship_wizard()
