#!/usr/bin/env python
# -*- coding: utf-8 -*-
##############################################################################
#
#    SISB, Sistema Integral Simon Bolivar
#    Copyright (C) 2012-2013 Industrias Diana, C.A. All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
{
    'name': 'Calculos de turnos',
    'version': '1.0',
    "author": "Industrias Diana C.A.",
    "category": "Human Resources",
    "website": "http://www.industriasdiana.gob.ve",
    'description': """\
        Modulo para el calculo de los bonos y deducciones por conceptos de turno.

        --  Se deben haber cargado los conceptos variables por reposos medicos
            antes de calcular los bonos por turno.
        --  Si no existe una hoja de conceptos variables para reposos medicos,
            el proceso asumira que no se deben calcular si hubo pagos indebidos.
        --  Se calculan primeramente los bonos del periodo anterior, tomando en
            cuenta las ausencias cargadas en hr_holidays, y los dias feriados.
        --  No se evalua contra marcaje si un trabajador cumplio con su jornada
            laboral, se asume que las unicas ausencias son las cargadas hasta la
            fecha en la tabla hr_holidays.
        --  Los pagos indebidos cargados por el sistema, que tengan que ver con
            reposos medicos, seran corregidos automaticamente una vez que sea
            convalidado el reposo medico en alguno de los procesos siguientes.
        --  Los pagos indebidos cargados por el sistema, que no sean por reposos
            medicos, deben ser corregidos manualmente por el analista de nomina.
    """,
    'depends': ['base', 'sisb_nomina', 'hr_holidays', 'sisb_reposos_medicos', 'sisb_turn_swap'],
    'external_dependencies': {},
    'init_xml': [],
    'update_xml': [
        'views/hr_hours_per_day_inherit.xml',
        'wizard/turns_variable_concepts.xml',
        'security/ir.model.access.csv'
    ],
    'active': True,
    'installable': True
}
