# -*- coding: utf-8 -*-
#!/usr/bin/env python

from report import report_sxw
from datetime import datetime
import os

class sisb_turn_list_report(report_sxw.rml_parse):
    _name =  'sisb.turn.list.report'
    
    def __init__(self, cr, uid, name, context):
        super(sisb_turn_list_report, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_pretty_date': self.get_pretty_date,
            'sort': self._sort
        })
        self.context = context

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id = obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            }
        return res
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')

    def get_pretty_date(self):
        return datetime.now().strftime('%A %d/%m/%Y')

    def _sort(self, lines):
        return sorted(lines, key=lambda a: (a.shift_week_id.shift_id.id, a.employee_id.cod_number))


report_sxw = report_sxw.report_sxw

class TxtParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False,
        header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser, header, store)

        
    
TxtParser(
    'report.sisb.turn.list',
    'sisb.turn.list',
    'sisb_turn_list/report/sisb_turn_list_report.rml',
    parser=sisb_turn_list_report, header=False)