# -*- coding: utf-8 -*-
#!/usr/bin/env python
from osv import fields, osv
from tools.translate import _

""" This inheritance allows RRHH managers to set the maximum days and hours the users
    have to create swap lines
"""
class hr_payroll(osv.osv):
    def not_negative(self, cr, uid, ids, context=None):
        for record in self.browse(cr, uid, ids, context):
            if record.swap_days < 0 or record.swap_hours < 0: return False
            else: return True

    _inherit = 'hr.payroll'
    _columns = {
        'swap_days': fields.integer('Allowed swap days', help="Sets the maximum days allowed to make swaps", required=True),
        'swap_hours': fields.integer('Allowed swap hours', help="Counting the days allowed to swap, adds the maximum hours allowed to make swaps", required=True)
    }
    _defaults = {
        'swap_days': lambda *a: 0,
        'swap_hours': lambda *a: 0
    }
    _constraints = [
        (not_negative, _('Swap days and horus can not be negative'), ['swap_days','swap_hours'])
    ]

hr_payroll()