# -*- coding: utf-8 -*-
#!/usr/bin/env python

from report import report_sxw
from datetime import datetime
from tools.translate import _

class report_sisb_turn_swap(report_sxw.rml_parse):
    _name =  'report.sisb.turn.swap'

    def __init__(self, cr, uid, name, context):
        super(report_sisb_turn_swap, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'get_pretty_date': self.get_pretty_date,
            'get_state':self.get_state,
            'get_type':self.get_type
        })
        self.context = context

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')

    def get_pretty_date(self):
        return datetime.now().strftime('%A %d/%m/%Y')

    def get_state(self, value):
        if value == 'draft': return _('Draft')
        elif value == 'confirmed': return _('Confirmed')
        elif value == 'approved': return _('Approved')
        elif value == 'rejected': return _('Rejected')
        else: return ''
        
    def get_type(self, value):
        if value == 'emp': return _('Employee')
        elif value == 'rota': return _('Rotation')
        elif value == 'turn': return _('Turn')
        else: return ''

report_sxw.report_sxw(
    'report.sisb.turn.swap',
    'sisb.turn.swap',
    'sisb_turn_swap/report/report_sisb_turn_swap.rml',
    parser=report_sisb_turn_swap, header=False)